package controle.eventos;

import java.awt.Frame;
import java.io.File;
import java.util.ArrayList;

import javax.swing.JPopupMenu.Separator;

import modelo.RedeConfig;

import jfan.fan.NeuronioFAN;
import jfan.fan.utilitarias.DetectorMaxMinMean;
import jfan.fan.utilitarias.RecalculadorClasses;
import jfan.io.arquivos.CarregaNeuronioXML;
import jfan.io.arquivos.GerenciadorPadroes;
import thinlet.Thinlet;
import thinletcommons.AntiAliasedThinlet;
import thinletcommons.ExtensionFileFilter;
import thinletcommons.FileChooser;
import thinletcommons.FileFilter;
import thinletcommons.MessageDialog;
import thinletcommons.ThinletDialog;
import controle.main.App;

public class EvtAbrirArquivo extends AntiAliasedThinlet{

	private static final long serialVersionUID = 1L;
	private String[][] array = null;
    private ConfigurarArquivo conarq = new ConfigurarArquivo();
    public String type = null;
    public String[] allFilesSuported = {"xml","dat","txt","xls"};
    
    private FileFilter[] filtro = new FileFilter[]{
    		new FileFilter(){
    	        public boolean accept(File dir) { 
    	        	if (dir.getAbsolutePath().indexOf(".dat") > -1 || dir.getAbsolutePath().indexOf(".epd") > -1 || dir.getAbsolutePath().indexOf(".txt") > -1 || dir.getAbsolutePath().indexOf(".xls") > -1) {
    	        		return true;
    	        	}
    	        	return false;
    	        }
    	        public String getDescription() { return "Arquivos suportados (epd,dat,txt,xls)"; }
    	    },
    		new ExtensionFileFilter("epd", "EasyFAN files (*.epd)"),
			new ExtensionFileFilter("dat", "DAT files (*.dat)"),
			new ExtensionFileFilter("txt", "TXT files (*.txt)"),
			new ExtensionFileFilter("xls", "XLS files (*.xls)"),
			
	  };
    
       
	
public  String[][] abrirTreinamento(){
	this.type = "Treinamento";
	String[][] arrayResult= null;
	try {
		FileChooser f = new FileChooser(new Frame(),"Abrir conjunto treinamento",FileChooser.MODE_OPEN);
		f.setFileFilters(filtro);
		f.setSelectedFile(App.getUltimoArquivo());
		f.setSelectedFiler(App.getUltimoFiltro());
		
		f.show();
	
		File file = f.getSelectedFile();
		if (file != null)
			App.setUltimoArquivo(file);
		App.setUltimoFiltro(f.getIndexOfSelectedFileFilter());
		
		
		if (file != null){
			String path = file.getAbsolutePath();
			GerenciadorPadroes ga = App.getGerenciadorPadroes();
			String formatoArquivo = path.substring(path.length()-3,path.length()).toUpperCase();
			if (formatoArquivo.equals("TXT")){
				conarq.abrirTxt(this.type,file);
				if (conarq.getStatusCancelar() != 1){
					ga.adicionarConjuntoTreinamento(path,conarq.getSeparador(),conarq.getColunaClasse(),conarq.getColunaInicial(),conarq.getColunaFinal(),conarq.getLinhaInicial(),conarq.getLinhaFinal());
				}			
			} else	if (formatoArquivo.equals("XLS")){
				conarq.abrirXls(this.type,file);  
				if (conarq.getStatusCancelar() != 1){
					ga.adicionarConjuntoTreinamento(path,null,conarq.getColunaClasse(),conarq.getColunaInicial(),conarq.getColunaFinal(),conarq.getLinhaInicial(),conarq.getLinhaFinal());
				}
			}else 
				ga.adicionarConjuntoTreinamento(path,"  ",0,0,0,0,0);
				array = ga.getConjuntoTreinamento();
				arrayResult=array;
				
				if (App.getProjetoConfig().getRedeConf().getMaximosAutomaticos() == null) {
					int fim = ga.getConjuntoTreinamentoRede().get(0).getQuantasCaracteristicas();
					boolean[] bb = new boolean[fim];
					for (int i = 0; i< fim;i++) bb[i] = true;
					App.getProjetoConfig().getRedeConf().setMaximosAutomaticos(bb);
				
				}
			
				if (App.getProjetoConfig().getRedeConf().getMinimosAutomaticos() == null) {
					int fim = ga.getConjuntoTreinamentoRede().get(0).getQuantasCaracteristicas();
					boolean[] bb = new boolean[fim];
					for (int i = 0; i< fim;i++) bb[i] = true;
					App.getProjetoConfig().getRedeConf().setMinimosAutomaticos(bb);
					
				}
			
				if (App.getProjetoConfig().getRedeConf().getMediasAutomaticas() == null) {
					int fim = ga.getConjuntoTreinamentoRede().get(0).getQuantasCaracteristicas();
					boolean[] bb = new boolean[fim];
					for (int i = 0; i< fim;i++) bb[i] = true;
					App.getProjetoConfig().getRedeConf().setMediasAutomaticas(bb);
				
				}
				
				double[] dd;// = new double[fim];
				GerenciadorPadroes g =  App.getGerenciadorPadroes();
				dd =  DetectorMaxMinMean.procurarMaximos(g.getConjuntoClassificacaoRede(),g.getConjuntoTesteRede(), g.getConjuntoTreinamentoRede(), g.getConjuntoValidacaoRede());
				
				if (App.getProjetoConfig().getRedeConf().getMaximos() == null) {
					App.getProjetoConfig().getRedeConf().setMaximos(dd);
				}
				else {
					double[] arrayD = App.getProjetoConfig().getRedeConf().getMaximos();
					boolean[] arrayB = App.getProjetoConfig().getRedeConf().getMaximosAutomaticos();
					for (int i =0; i < arrayD.length; i++ ) {
						if (arrayB[i]) {
							arrayD[i] =  dd[i];
						}
					}
				}
	
				dd =  DetectorMaxMinMean.procurarMinimos(g.getConjuntoClassificacaoRede(),g.getConjuntoTesteRede(), g.getConjuntoTreinamentoRede(), g.getConjuntoValidacaoRede());
				if (App.getProjetoConfig().getRedeConf().getMinimos() == null) {
					App.getProjetoConfig().getRedeConf().setMinimos(dd);
				} 
				else {
					double[] arrayD = App.getProjetoConfig().getRedeConf().getMinimos();
					boolean[] arrayB = App.getProjetoConfig().getRedeConf().getMinimosAutomaticos();
					for (int i =0; i < arrayD.length; i++ ) {
						if (arrayB[i]) {
							arrayD[i] =  dd[i];
						}
					}
				}
				
				dd =  DetectorMaxMinMean.procurarMedias(g.getConjuntoClassificacaoRede(),g.getConjuntoTesteRede(), g.getConjuntoTreinamentoRede(), g.getConjuntoValidacaoRede());
				if (App.getProjetoConfig().getRedeConf().getMedias() == null) {
					App.getProjetoConfig().getRedeConf().setMedias(dd);
				}
				else {
					double[] arrayD = App.getProjetoConfig().getRedeConf().getMedias();
					boolean[] arrayB = App.getProjetoConfig().getRedeConf().getMediasAutomaticas();
					for (int i =0; i < arrayD.length; i++ ) {
						if (arrayB[i]) {
							arrayD[i] =  dd[i];
						}
					}
				}
			
			
				App.vericarMonitor();
				App.getMonitorFAN().setClasses(App.getGerenciadorPadroes().getClassesConjuntoTreinamento());
		    }
		}
		catch(Exception e){
				e.printStackTrace();
			}
		App.setPrecisaNormalizar(true);
	return arrayResult;
}
public  String[][] abrirTeste(){
	this.type = "Teste";
   	String[][] arrayResult= null;
	try {
    	FileChooser f = new FileChooser(new Frame(),"Abrir conjunto de teste",FileChooser.MODE_OPEN);
    	f.setFileFilters(filtro);
    	f.setSelectedFile(App.getUltimoArquivo());
		f.setSelectedFiler(App.getUltimoFiltro());
		
		f.show();
	
		File file = f.getSelectedFile();
		if (file != null)
			App.setUltimoArquivo(file);
		App.setUltimoFiltro(f.getIndexOfSelectedFileFilter());
		if (file != null){
			String path = file.getAbsolutePath();
			String formatoArquivo = path.substring(path.length()-3,path.length()).toUpperCase();
			GerenciadorPadroes ga = App.getGerenciadorPadroes();
			if (formatoArquivo.equals("TXT")){
				conarq.abrirTxt(this.type,file);  
				ga.adicionarConjuntoTeste(path,conarq.getSeparador(),conarq.getColunaClasse(),conarq.getColunaInicial(),conarq.getColunaFinal(),conarq.getLinhaInicial(),conarq.getLinhaFinal());
			}
			else if (formatoArquivo.equals("XLS")){
				conarq.abrirXls(this.type,file);  
				ga.adicionarConjuntoTeste(path,null,conarq.getColunaClasse(),conarq.getColunaInicial(),conarq.getColunaFinal(),conarq.getLinhaInicial(),conarq.getLinhaFinal());
			}else 
				ga.adicionarConjuntoTeste(path,"  ",0,0,0,0,0);
			array = ga.getConjuntoTeste();
			arrayResult=array;
			App.vericarMonitor();
						
			if (App.getProjetoConfig().getRedeConf().getMaximosAutomaticos() == null) {
				int fim = ga.getConjuntoTesteRede().get(0).getQuantasCaracteristicas();
				boolean[] bb = new boolean[fim];
				for (int i = 0; i< fim;i++) bb[i] = true;
				App.getProjetoConfig().getRedeConf().setMaximosAutomaticos(bb);
			
			}
		
			if (App.getProjetoConfig().getRedeConf().getMinimosAutomaticos() == null) {
				int fim = ga.getConjuntoTesteRede().get(0).getQuantasCaracteristicas();
				boolean[] bb = new boolean[fim];
				for (int i = 0; i< fim;i++) bb[i] = true;
				App.getProjetoConfig().getRedeConf().setMinimosAutomaticos(bb);
				
			}
		
			if (App.getProjetoConfig().getRedeConf().getMediasAutomaticas() == null) {
				int fim = ga.getConjuntoTesteRede().get(0).getQuantasCaracteristicas();
				boolean[] bb = new boolean[fim];
				for (int i = 0; i< fim;i++) bb[i] = true;
				App.getProjetoConfig().getRedeConf().setMediasAutomaticas(bb);
			
			}
			
			double[] dd;// = new double[fim];
			GerenciadorPadroes g =  App.getGerenciadorPadroes();
			dd =  DetectorMaxMinMean.procurarMaximos(g.getConjuntoClassificacaoRede(),g.getConjuntoTesteRede(), g.getConjuntoTreinamentoRede(), g.getConjuntoValidacaoRede());
			
			if (App.getProjetoConfig().getRedeConf().getMaximos() == null) {
				App.getProjetoConfig().getRedeConf().setMaximos(dd);
			}
			else {
				double[] arrayD = App.getProjetoConfig().getRedeConf().getMaximos();
				boolean[] arrayB = App.getProjetoConfig().getRedeConf().getMaximosAutomaticos();
				for (int i =0; i < arrayD.length; i++ ) {
					if (arrayB[i]) {
						arrayD[i] =  dd[i];
					}
				}
			}

			dd =  DetectorMaxMinMean.procurarMinimos(g.getConjuntoClassificacaoRede(),g.getConjuntoTesteRede(), g.getConjuntoTreinamentoRede(), g.getConjuntoValidacaoRede());
			if (App.getProjetoConfig().getRedeConf().getMinimos() == null) {
				App.getProjetoConfig().getRedeConf().setMinimos(dd);
			} 
			else {
				double[] arrayD = App.getProjetoConfig().getRedeConf().getMinimos();
				boolean[] arrayB = App.getProjetoConfig().getRedeConf().getMinimosAutomaticos();
				for (int i =0; i < arrayD.length; i++ ) {
					if (arrayB[i]) {
						arrayD[i] =  dd[i];
					}
				}
			}
			
			dd =  DetectorMaxMinMean.procurarMedias(g.getConjuntoClassificacaoRede(),g.getConjuntoTesteRede(), g.getConjuntoTreinamentoRede(), g.getConjuntoValidacaoRede());
			if (App.getProjetoConfig().getRedeConf().getMedias() == null) {
				App.getProjetoConfig().getRedeConf().setMedias(dd);
			}
			else {
				double[] arrayD = App.getProjetoConfig().getRedeConf().getMedias();
				boolean[] arrayB = App.getProjetoConfig().getRedeConf().getMediasAutomaticas();
				for (int i =0; i < arrayD.length; i++ ) {
					if (arrayB[i]) {
						arrayD[i] =  dd[i];
					}
				}
			}

			
		}
		if (App.getGerenciadorPadroes().getConjuntoTreinamentoRede().size() > 0) {
			App.vericarMonitor();
			App.getMonitorFAN().setClasses(App.getGerenciadorPadroes().getClassesConjuntoTreinamento());
		}
		else {
			App.vericarMonitor();
			App.getMonitorFAN().setClasses(App.getGerenciadorPadroes().getClassesConjuntoTeste());
		}
		
		
	}
	catch(Exception e){
			e.printStackTrace();
		}
	
	
	
	App.setPrecisaNormalizar(true);
	return arrayResult;
}
public  String[][] abrirClassificacao(){
	this.type = "Classificacao";
   	String[][] arrayResult= null;
	try {
		
    	FileChooser f = new FileChooser(new Frame(),"Abrir conjunto classifica��o",FileChooser.MODE_OPEN);
    	f.setFileFilters(filtro);
    	f.setSelectedFile(App.getUltimoArquivo());
		f.setSelectedFiler(App.getUltimoFiltro());
		
		f.show();
	
		File file = f.getSelectedFile();
		if (file != null)
			App.setUltimoArquivo(file);
		App.setUltimoFiltro(f.getIndexOfSelectedFileFilter());
		if (file != null){
			file.getName();
			String path = file.getAbsolutePath();
			String formatoArquivo = path.substring(path.length()-3,path.length()).toUpperCase();
			GerenciadorPadroes ga = App.getGerenciadorPadroes();
			if (formatoArquivo.equals("TXT")){
				conarq.abrirTxt(this.type,file);  
				ga.adicionarConjuntoClassificacao(path,conarq.getSeparador(),conarq.getColunaClasse(),conarq.getColunaInicial(),conarq.getColunaFinal(),conarq.getLinhaInicial(),conarq.getLinhaFinal());
			}else	if (formatoArquivo.equals("XLS")){
				conarq.abrirXls(this.type,file);  
				ga.adicionarConjuntoClassificacao(path,null,conarq.getColunaClasse(),conarq.getColunaInicial(),conarq.getColunaFinal(),conarq.getLinhaInicial(),conarq.getLinhaFinal());
			}else 
				ga.adicionarConjuntoClassificacao(path,"  ",0,0,0,0,0);
			array = ga.getConjuntoClassificacao();
			arrayResult=array;
		}
		
		if (App.getGerenciadorPadroes().getConjuntoTreinamentoRede().size() > 0) {
			App.vericarMonitor();
			App.getMonitorFAN().setClasses(App.getGerenciadorPadroes().getClassesConjuntoTreinamento());
		}
		else {
			App.vericarMonitor();
			App.getMonitorFAN().setClasses(App.getGerenciadorPadroes().getClassesConjuntoClassificacao());
		}
	}
	catch(Exception e){
			e.printStackTrace();
		}
	App.setPrecisaNormalizar(true);
	
	
	
	return arrayResult;
}
public  String[][] abrirValidacao(){
	this.type = "Validacao";
   	String[][] arrayResult= null;
	try {
    	FileChooser f = new FileChooser(new Frame(),"Abrir conjunto validaca��o",FileChooser.MODE_OPEN);
    	f.setFileFilters(filtro);
    	f.setSelectedFile(App.getUltimoArquivo());
		f.setSelectedFiler(App.getUltimoFiltro());
		
		f.show();
	
		File file = f.getSelectedFile();
		if (file != null)
			App.setUltimoArquivo(file);
		App.setUltimoFiltro(f.getIndexOfSelectedFileFilter());
		if(file != null){
			file.getName();
			String path = file.getAbsolutePath();
			String formatoArquivo = path.substring(path.length()-3,path.length()).toUpperCase();
			GerenciadorPadroes ga = App.getGerenciadorPadroes();
			if (formatoArquivo.equals("TXT")){
				conarq.abrirTxt(this.type,file);  
				ga.adicionarConjuntoValidacao(path,conarq.getSeparador(),conarq.getColunaClasse(),conarq.getColunaInicial(),conarq.getColunaFinal(),conarq.getLinhaInicial(),conarq.getLinhaFinal());
			}else	if (formatoArquivo.equals("XLS")){
				conarq.abrirXls(this.type,file);  
				ga.adicionarConjuntoValidacao(path,null,conarq.getColunaClasse(),conarq.getColunaInicial(),conarq.getColunaFinal(),conarq.getLinhaInicial(),conarq.getLinhaFinal());
			}else
				ga.adicionarConjuntoValidacao(path,"  ",0,0,0,0,0);
			array = ga.getConjuntoValidacao();
			arrayResult=array;
		}
		if (App.getGerenciadorPadroes().getConjuntoTreinamentoRede().size() > 0) {
			App.vericarMonitor();
			App.getMonitorFAN().setClasses(App.getGerenciadorPadroes().getClassesConjuntoTreinamento());
		}
		else {
			App.vericarMonitor();
			App.getMonitorFAN().setClasses(App.getGerenciadorPadroes().getClassesConjuntoValidacao());
		}
	}
	catch(Exception e){
			e.printStackTrace();
		}
	App.setPrecisaNormalizar(true);
	return arrayResult;
	
}

	public CarregaNeuronioXML abrirRede() {
		FileChooser fc = new FileChooser(App.getTelaEasyFAN().getFrame(),"Abrir Rede", FileChooser.MODE_OPEN);
		fc.setFileFilters(new FileFilter[]{
				 new FileFilter(){
						public boolean accept(File dir) { 
					    if (dir.getAbsolutePath().indexOf(".dat") > -1 || dir.getAbsolutePath().indexOf(".enn") > -1) {
					        		return true;
					        	}
					      	return false;
					        }
					    public String getDescription() { return "Arquivos suportados (enn,dat)"; }
			    },
				new ExtensionFileFilter("enn", "EasyFAN files (*.enn)"),
				new ExtensionFileFilter("dat", "DAT files (*.dat)"),   
		  });
		 fc.show();
		 File selectedFile = fc.getSelectedFile();
		 String enderecoDoArquivo = selectedFile.getAbsolutePath();
		 String extArquivo = selectedFile.getName();//fc.getFilterChanged();
		 extArquivo = extArquivo.substring(extArquivo.length()-4,extArquivo.length());
		 if (extArquivo.equalsIgnoreCase(".enn")){
			 CarregaNeuronioXML cxml = new CarregaNeuronioXML(enderecoDoArquivo,App.getGerenciadorPadroes());
			  try {
				return cxml;
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				return null;
			}
			 
		 
		 }
		 else {
			 MessageDialog msg = new MessageDialog(fc.getDialog(),"Arquivo inv�lido","Tipo de arquivo inv�lido.");
			 msg.show();
		 }
		return null;

	}
	
	public void abrirRedeTreinamento() {
		try {
			CarregaNeuronioXML cxml = abrirRede();
			RedeConfig rc = App.getProjetoConfig().getRedeConf();
			rc.setMaximos(cxml.getMaximos());
			rc.setMinimos(cxml.getMinimos());
			rc.setMedias(cxml.getMedias());
			rc.setTipoNormalizador(cxml.getTipoNormalizacao());
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		
	}
	
	public ArrayList<NeuronioFAN> abrirRedeSomenteNeuronios() {
		try {
			CarregaNeuronioXML cxml = abrirRede();
			ArrayList<NeuronioFAN> arr = cxml.getNeuroniosFAN();
			int fim = arr.size();
			int[] classes = new int[fim];
			for(int i = 0; i < fim; i++) {
				classes[i] = arr.get(i).getClasseAssociada();
			}
			RecalculadorClasses.indexarNeuronios(classes, arr);
			return cxml.getNeuroniosFAN();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public CarregaNeuronioXML abrirRedeCarregaXML() {
		try {
			CarregaNeuronioXML cxml = abrirRede();
			ArrayList<NeuronioFAN> arr = cxml.getNeuroniosFAN();
			/*int fim = arr.size();
			int[] classes = new int[fim];
			for(int i = 0; i < fim; i++) {
				classes[i] = arr.get(i).getClasseAssociada();
			}*/
			//RecalculadorClasses.indexarNeuronios(classes, arr);
			return cxml;
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

}