package controle.eventos;

import java.util.ArrayList;

import controle.main.App;
import visao.gui.telas.classes.EasyFan;
import jfan.fan.NeuronioFAN;
import jfan.fan.StoredNetworkType;
import jfan.io.arquivos.CarregaNeuronioXML;

public class EvtClassificacao {

	private final EasyFan easyfan;
	
	public EvtClassificacao(EasyFan easyfan) {
		this.easyfan = easyfan;
	}
	
	
	public void classificar(StoredNetworkType tipoRede) {
		App.requisitarNormalizacao();
		App.getMonitorFAN().classificar(tipoRede);
		App.getGerenciadorPadroes().atualizarConjuntoClassificacao();
		easyfan.atualizarTabelaClassificacao();
		
	}
	
	public void classificar(ArrayList<NeuronioFAN> neuronios) {
		App.requisitarNormalizacao();
		App.getMonitorFAN().classificar(neuronios);
		App.getGerenciadorPadroes().atualizarConjuntoClassificacao();
		easyfan.atualizarTabelaClassificacao();
		
	}
	
	public void classificar(ArrayList<NeuronioFAN> neuronios, CarregaNeuronioXML cnx) {
		App.requisitarNormalizacao();
		try {
			App.getMonitorFAN().classificar(neuronios, cnx);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		App.getGerenciadorPadroes().atualizarConjuntoClassificacao();
		easyfan.atualizarTabelaClassificacao();
		
	}
	
}
