package controle.eventos;

import java.awt.Frame;
import java.io.File;
import jfan.io.arquivos.PersistorDados;
import controle.main.App;

import thinletcommons.ExtensionFileFilter;
import thinletcommons.FileChooser;
import thinletcommons.FileFilter;
import thinletcommons.MessageDialog;

public class EvtSalvarArquivo {
	
	
	public static void salvarConjuntoTreinamento() {
		FileChooser f = new FileChooser(new Frame(), "Salvar conjunto de treinamento",
				FileChooser.MODE_SAVE);
		f.setFileFilters(new FileFilter[] {
				new ExtensionFileFilter("epd", "EasyFAN files (*.epd)"),
				new ExtensionFileFilter("dat", "DAT files (*.dat)")}				
			
			);
	
		//f.setSelectedFile(App.getUltimoArquivo());
		//f.setSelectedFiler(App.getUltimoFiltro());
		
		f.show();
	
		File file = f.getSelectedFile();
		if (file != null)
			App.setUltimoArquivo(file);
		App.setUltimoFiltro(f.getIndexOfSelectedFileFilter());
		
		if (file != null) {
			PersistorDados pd = new PersistorDados();
			try {
				if (f.getSelectedFileFilter().getDescription()
						.equalsIgnoreCase("DAT files (*.dat)"))
					pd.gravaPadroesDat(App.getGerenciadorPadroes()
							.getConjuntoTreinamentoRede(), file
							.getAbsolutePath()
							+ ".dat");
				else if (f.getSelectedFileFilter().getDescription()
						.equalsIgnoreCase("EasyFAN files (*.epd)")) {
					String[] nomeCarac;
					if (App.getGerenciadorPadroes()
							.getNomeCaracteristicasTreinamento() == null) {
						// Criar interface para preenher nome das
						// caracter�sticas
						// por enquanto preenche com "Caracter�stica X
						nomeCarac = new String[App.getGerenciadorPadroes()
								.getConjuntoTreinamentoRede().get(0)
								.getQuantasCaracteristicas()];
						for (int i = 0; i < nomeCarac.length; i++)
							nomeCarac[i] = "Caracteristica "
									+ String.valueOf(i + 1);
					} else
						nomeCarac = App.getGerenciadorPadroes()
								.getNomeCaracteristicasTreinamento();


					pd.gravaPadroesXml(App.getGerenciadorPadroes(),App.getGerenciadorPadroes()
							.getConjuntoTreinamentoRede(), file
							.getAbsolutePath()
							+ ".epd", f.getSelectedFile().getName(),
      						"Treinamento", nomeCarac);

				}
			} catch (Exception e) {
				new MessageDialog(f.getDialog(), "Erro ao persistir",
						"Um erro ocorreu ao tentar salvar o arquivo.").show();
				e.printStackTrace();
			}
		}
	}

	public static void salvarConjuntoTeste() {
		if (permitePersistir()){
			
			FileChooser f = new FileChooser(new Frame(), "Salvar conjunto de teste",
					FileChooser.MODE_SAVE);
			f.setFileFilters(new FileFilter[] {
					new ExtensionFileFilter("epd", "EasyFAN files (*.epd)"),
					new ExtensionFileFilter("dat", "DAT files (*.dat)")				
    		 });
			
			f.setSelectedFile(App.getUltimoArquivo());
			f.setSelectedFiler(App.getUltimoFiltro());
			
			f.show();
		
			File file = f.getSelectedFile();
			if (file != null)
				App.setUltimoArquivo(file);
			App.setUltimoFiltro(f.getIndexOfSelectedFileFilter());
			
			if (file != null) {
				PersistorDados pd = new PersistorDados();
				try {
					if (f.getSelectedFileFilter().getDescription()
							.equalsIgnoreCase("DAT files (*.dat)"))
						pd.gravaPadroesDat(App.getGerenciadorPadroes()
								.getConjuntoTesteRede(), file
								.getAbsolutePath()
								+ ".dat");
					else if (f.getSelectedFileFilter().getDescription()
							.equalsIgnoreCase("EasyFAN files (*.epd)")) {
						String[] nomeCarac = null;
						if (App.getGerenciadorPadroes()
								.getNomeCaracteristicasTreinamento() == null) {
							// Criar interface para preenher nome das
							// caracter�sticas
							// por enquanto preenche com "Caracter�stica X
							nomeCarac = new String[App.getGerenciadorPadroes()
									.getConjuntoTesteRede().get(0)
									.getQuantasCaracteristicas()];
							for (int i = 0; i < nomeCarac.length; i++)
								nomeCarac[i] = "Caracteristica "
										+ String.valueOf(i + 1);
						} else
							nomeCarac = App.getGerenciadorPadroes()
									.getNomeCaracteristicasTreinamento();
						
							pd.gravaPadroesXml(App.getGerenciadorPadroes(),App.getGerenciadorPadroes()
									.getConjuntoTesteRede(), file
									.getAbsolutePath()
									+ ".epd", f.getSelectedFile().getName(),
									"Teste", nomeCarac);
					}
				} catch (Exception e) {
					new MessageDialog(f.getDialog(), "Erro ao persistir",
							"Um erro ocorreu ao tentar salvar o arquivo.").show();
					e.printStackTrace();
				}
			}
		}
	}

	public static void salvarConjuntoClassificacao() {
		if (permitePersistir()){
			
			FileChooser f = new FileChooser(new Frame(), "Salvar conjunto de classificac�o",
					FileChooser.MODE_SAVE);
			f.setFileFilters(new FileFilter[] {
					new ExtensionFileFilter("epd", "EasyFAN files (*.epd)"),
					new ExtensionFileFilter("dat", "DAT files (*.dat)")
			});
			
			f.setSelectedFile(App.getUltimoArquivo());
			f.setSelectedFiler(App.getUltimoFiltro());
			
			f.show();
		
			File file = f.getSelectedFile();
			if (file != null)
				App.setUltimoArquivo(file);
			App.setUltimoFiltro(f.getIndexOfSelectedFileFilter());
	
			if (file != null) {
				PersistorDados pd = new PersistorDados();
				try {
					if (f.getSelectedFileFilter().getDescription()
							.equalsIgnoreCase("DAT files (*.dat)"))
						pd.gravaPadroesDat(App.getGerenciadorPadroes()
								.getConjuntoClassificacaoRede(), file
								.getAbsolutePath()
								+ ".dat");
					else if (f.getSelectedFileFilter().getDescription()
							.equalsIgnoreCase("EasyFAN files (*.epd)")) {
						String[] nomeCarac;
						if (App.getGerenciadorPadroes()
								.getNomeCaracteristicasTreinamento() == null) {
							// Criar interface para preenher nome das
							// caracter�sticas
							// por enquanto preenche com "Caracter�stica X
							nomeCarac = new String[App.getGerenciadorPadroes()
									.getConjuntoClassificacaoRede().get(0)
									.getQuantasCaracteristicas()];
							for (int i = 0; i < nomeCarac.length; i++)
								nomeCarac[i] = "Caracteristica "
										+ String.valueOf(i + 1);
						} else
							nomeCarac = App.getGerenciadorPadroes()
									.getNomeCaracteristicasTreinamento();
	
							pd.gravaPadroesXml(App.getGerenciadorPadroes(),App.getGerenciadorPadroes()
									.getConjuntoTesteRede(), file
									.getAbsolutePath()
									+ ".epd", f.getSelectedFile().getName(),
									"Classificacao", nomeCarac);
					}
				} catch (Exception e) {
					new MessageDialog(f.getDialog(), "Erro ao persistir",
							"Um erro ocorreu ao tentar salvar o arquivo.").show();
					e.printStackTrace();
				}
			}
		}
	}

	private static boolean permitePersistir(){
		boolean permitir = true;
		try {
			if (App.getGerenciadorPadroes().getConjuntoTreinamentoRede().size()<1){
				new MessageDialog(App.getTelaEasyFAN().getFrame(), "Verifica��o",
				"� necess�rio carregar um conjunto de treinamento").show();
				permitir = false;
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return permitir;
	}
	
	
	
	public static void salvarConjuntoValidacao() {
		if (permitePersistir()){
			FileChooser f = new FileChooser(new Frame(), "Salvar conjunto de valida��o",
					FileChooser.MODE_SAVE);
			f.setFileFilters(new FileFilter[] {
					new ExtensionFileFilter("epd", "EPD files (*.epd)"),
					new ExtensionFileFilter("dat", "DAT files (*.dat)")
			});
			
			f.setSelectedFile(App.getUltimoArquivo());
			f.setSelectedFiler(App.getUltimoFiltro());
			
			f.show();
		
			File file = f.getSelectedFile();
			if (file != null)
				App.setUltimoArquivo(file);
			App.setUltimoFiltro(f.getIndexOfSelectedFileFilter());
	
			if (file != null) {
				PersistorDados pd = new PersistorDados();
				try {
					if (f.getSelectedFileFilter().getDescription()
							.equalsIgnoreCase("DAT files (*.dat)"))
						pd.gravaPadroesDat(App.getGerenciadorPadroes()
								.getConjuntoValidacaoRede(), file
								.getAbsolutePath()
								+ ".dat");
					else if (f.getSelectedFileFilter().getDescription()
							.equalsIgnoreCase("EasyFAN files (*.epd)")) {
						String[] nomeCarac;
						if (App.getGerenciadorPadroes()
								.getNomeCaracteristicasTreinamento() == null) {
							// Criar interface para preenher nome das
							// caracter�sticas
							// por enquanto preenche com "Caracter�stica X
							nomeCarac = new String[App.getGerenciadorPadroes()
									.getConjuntoValidacaoRede().get(0)
									.getQuantasCaracteristicas()];
							for (int i = 0; i < nomeCarac.length; i++)
								nomeCarac[i] = "Caracteristica "
										+ String.valueOf(i + 1);
						} else
							nomeCarac = App.getGerenciadorPadroes()
									.getNomeCaracteristicasTreinamento();
	
							pd.gravaPadroesXml(App.getGerenciadorPadroes(),App.getGerenciadorPadroes()
									.getConjuntoTesteRede(), file
									.getAbsolutePath()
									+ ".epd", f.getSelectedFile().getName(),
									"Validacao", nomeCarac);
	
						
					}
				} catch (Exception e) {
					new MessageDialog(f.getDialog(), "Erro ao persistir",
							"Um erro ocorreu ao tentar salvar o arquivo.").show();
					e.printStackTrace();
				}
			}
		}

	}

}
