package controle.eventos;

import java.text.NumberFormat;
import java.util.ArrayList;

import jfan.fan.NeuronioFAN;
import jfan.fan.StoredNetworkType;
import jfan.fan.beans.StatisticBean;
import jfan.fan.padroes.IPadrao;
import modelo.AbaTesteBean;
import thinlet.Thinlet;
import thinletcommons.MessageDialog;
import visao.gui.telas.classes.MatrizConfusaoTela;
import controle.main.App;



public class EvtTeste {

	private final AbaTesteBean testeBean = new AbaTesteBean();
	private final Object lblHarmonica,lblMaxMin,lblAritmetica;
	private Thinlet thinlet;// = App.getTelaEasyFAN();
	private final NumberFormat numFormat = NumberFormat.getInstance();
	private StatisticBean estatisticas;
	
	public EvtTeste(Thinlet thinlet,Object lblHarmonica,Object lblMaxMin, Object lblAritmetica) {
		this.lblAritmetica = lblAritmetica;
		this.lblHarmonica = lblHarmonica;
		this.lblMaxMin = lblMaxMin;
		numFormat.setMaximumFractionDigits(4);
		numFormat.setMinimumFractionDigits(4);
		numFormat.setMaximumIntegerDigits(3);
		numFormat.setMinimumIntegerDigits(3);
		this.thinlet = thinlet;
	}
	
	public void testarRede(StoredNetworkType tipo) {
		App.requisitarNormalizacao();
		switch (tipo) {
			case Actual:
				estatisticas = App.getMonitorFAN().testar();
				break;
			case BestAritmethicMean:
				estatisticas = App.getMonitorFAN().testar(App.getMonitorFAN().getNeuroniosMelhorAritmetica());
				break;
			case BestHarmonicMean:
				estatisticas = App.getMonitorFAN().testar(App.getMonitorFAN().getNeuroniosMelhorHarmonica());		
				break;
			case BestMaxMin:
				estatisticas = App.getMonitorFAN().testar(App.getMonitorFAN().getNeuroniosMelhorMaximoMinimo());
				break;
			default:
				break;
		}
		atualizarDados();
	}
	
	public void testarRede(ArrayList<NeuronioFAN> neuronios) {
		App.requisitarNormalizacao();
		estatisticas = App.getMonitorFAN().testar(neuronios);
		atualizarDados();
	}
	
	public void testarRede(ArrayList<NeuronioFAN> neuronios, ArrayList<IPadrao> padroes) {
		//App.requisitarNormalizacao();
		estatisticas = App.getMonitorFAN().testar(neuronios, padroes);
		atualizarDados();
	}
	
	public void chamarTelaMatrizConfusao() {
		if (testeBean.getMatrizConfusao() != null) {
			MatrizConfusaoTela mct = new MatrizConfusaoTela(App.getTelaEasyFAN().getFrame(),"Matriz de confus�o: Teste",-1,testeBean.getMatrizConfusao(),testeBean.getHarmonica(),testeBean.getAritmetica(),testeBean.getMaxmin(), null);
			mct.show();
		}
		else {
			MessageDialog msg = new MessageDialog(App.getTelaEasyFAN().getFrame(),"Aten��o","� necess�rio testar uma rede antes.");
			msg.show();
		}
	}
	
	private void atualizarDados() {
		testeBean.setAritmetica(estatisticas.getAritmetica());
		testeBean.setHarmonica(estatisticas.getHarmonica());
		testeBean.setMaxmin(estatisticas.getMaxmin());
		testeBean.setMatrizConfusao(estatisticas.getMatrizConfusao());
		/*int certos = 0, errados = 0;
		if (testeBean.getMatrizConfusao() != null) {
			int[][] matrix = testeBean.getMatrizConfusao();
			for (int i = 0;i < matrix.length;i++) {
				for (int j = 0;j < matrix[i].length;j++) {
					if (i != j) {
						errados += matrix[i][j];
					}
					else {
						certos += matrix[i][j];
					}
				}
			}
		}*/
		thinlet.setString(lblAritmetica, "text", numFormat.format(testeBean.getAritmetica()));
		thinlet.setString(lblHarmonica, "text", numFormat.format(testeBean.getHarmonica()));
		thinlet.setString(lblMaxMin, "text", numFormat.format(testeBean.getMaxmin()));
		App.getTelaEasyFAN().setCertosTeste(estatisticas.getAcertos());
		App.getTelaEasyFAN().setErrosTeste(estatisticas.getErros());
	}
	
}
