package controle.eventos.auxiliares;

import java.text.NumberFormat;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.TimeUnit;

import jfan.fan.events.TrocaValorTemperaEvent;
import thinlet.Thinlet;

public class AtualizadorTempera implements Runnable {
    
    private LinkedBlockingQueue<TrocaValorTemperaEvent> filaValorTempera;
    
    private TrocaValorTemperaEvent eventoAtual;
    
    NumberFormat numformat = NumberFormat.getInstance();
    
    private boolean keepGoing = true;
    
    private long ultimaAtualizacao = 0l;
    
    /**
     * Tela thinlet, para poder atualizar os campos.
     */
    private Thinlet tela;
    
    /**
     * Campos thinlet.
     */
    Object lblValorAtualTempera;
    
    public AtualizadorTempera(
            LinkedBlockingQueue<TrocaValorTemperaEvent> queueValorTemperaEvent, Object lblValorTempera, Thinlet tela) {
        
        this.tela = tela;
        
        lblValorAtualTempera = lblValorTempera;
        
        filaValorTempera = queueValorTemperaEvent;
        
        numformat.setMinimumFractionDigits(4);
        numformat.setMaximumFractionDigits(4);
        numformat.setMinimumIntegerDigits(3);
        numformat.setMaximumIntegerDigits(3);
    }
    
    public void stop() {
        keepGoing = false;
    }
    
    public void run() {
        while (keepGoing) {
            synchronized (this) {
                // Dorme um pouco caso n�o haja nada em nenhuma fila.
                if (filaValorTempera.size() == 0) {
                    try {
                        Thread.sleep(400);
                    } catch (InterruptedException e) {
                        // TODO Auto-generated catch block
                        e.printStackTrace();
                    }
                } else { // Caso haja algo em alguma fila.
//                    if (System.currentTimeMillis() - ultimaAtualizacao > 5000) {
                    
                    if (tela != null) {
                        try {
                            //Atualiza��o aritim�tica
                            if (filaValorTempera.size() > 0) {
                                eventoAtual = filaValorTempera.poll(250,
                                        TimeUnit.MILLISECONDS);
                                if (eventoAtual != null) {
                                    tela.setString(lblValorAtualTempera, "text", numformat.format(eventoAtual.getValor()));
                                }
                            }
                        } catch (InterruptedException e) {
                            // TODO Auto-generated catch block
                            e.printStackTrace();
                        }
                    }
                    ultimaAtualizacao = System.currentTimeMillis();
                }
//                }
            }
            Thread.yield();
        }
    }
}
