package controle.eventos.auxiliares;

import java.util.concurrent.LinkedBlockingQueue;

import jfan.fan.events.MelhorAritimeticaEvent;
import jfan.fan.events.MelhorAritimeticaListener;
import jfan.fan.events.MelhorHarmonicaEvent;
import jfan.fan.events.MelhorHarmonicaListener;
import jfan.fan.events.MelhorMaximoMinimoEvent;
import jfan.fan.events.MelhorMaximoMinimoListener;
import jfan.fan.events.TrocaEpocaEvent;
import jfan.fan.events.TrocaEpocaListener;
import jfan.fan.events.TrocaValorTemperaEvent;
import jfan.fan.events.TrocaValorTemperaListener;

public class EnfileiradorEventos implements MelhorAritimeticaListener,
		MelhorHarmonicaListener, MelhorMaximoMinimoListener, TrocaEpocaListener, TrocaValorTemperaListener {

	private final LinkedBlockingQueue<MelhorAritimeticaEvent> queueMelhorAritmeticaEvent;
	
	private final LinkedBlockingQueue<MelhorHarmonicaEvent> queueMelhorHarmonicaEvent;
	
	private final LinkedBlockingQueue<MelhorMaximoMinimoEvent> queueMelhorMaxMinEvent;
	
	private final LinkedBlockingQueue<TrocaEpocaEvent> queueTrocaEpocaEvent;
	
	private final LinkedBlockingQueue<TrocaValorTemperaEvent> queueTrocaValorTemperaEvent;
	
	private final int MAX_FILA_EPOCA = 20;
	
	private final int MAX_FILA_OUTROS = 10;
	
	
	
	public EnfileiradorEventos(EvtQueues queues) {
		queueMelhorAritmeticaEvent = queues.getQueueMelhorAritmeticaEvent();
		queueMelhorHarmonicaEvent = queues.getQueueMelhorHarmonicaEvent();
		queueMelhorMaxMinEvent = queues.getQueueMelhorMaxMinEvent();
		queueTrocaEpocaEvent = queues.getQueueTrocaEpocaEvent();
		queueTrocaValorTemperaEvent = queues.getQueueTrocaValorTemperaEvent();
	}
	
	public void trocouMelhorMediaAritimetica(MelhorAritimeticaEvent event) {
		try {
			if (queueMelhorAritmeticaEvent.size() >= MAX_FILA_OUTROS) {
				queueMelhorAritmeticaEvent.poll();
			}
			queueMelhorAritmeticaEvent.put(event);
		} catch (InterruptedException e) {
			e.printStackTrace(); //TODO revisar aviso de erro
		}
	}

	public void trocouMelhorMediaHarmonica(MelhorHarmonicaEvent event) {
		try {
			if (queueMelhorHarmonicaEvent.size() >= MAX_FILA_OUTROS) {
				queueMelhorHarmonicaEvent.poll();
			}
			queueMelhorHarmonicaEvent.put(event);
		} catch (InterruptedException e) {
			e.printStackTrace();//TODO revisar aviso de erro
		}
	}

	public void trocouMelhorMaximoMinimo(MelhorMaximoMinimoEvent event) {
		try {
			if (queueMelhorMaxMinEvent.size() >= MAX_FILA_OUTROS) {
				queueMelhorMaxMinEvent.poll();
			}
			queueMelhorMaxMinEvent.put(event);
		} catch (InterruptedException e) {
			e.printStackTrace();//TODO revisar aviso de erro
		}
	}

	public void trocouEpoca(TrocaEpocaEvent event) {
		try {
			if (queueTrocaEpocaEvent.size() >= MAX_FILA_OUTROS) {
				queueTrocaEpocaEvent.poll();
			}
			queueTrocaEpocaEvent.put(event);
			//queueTrocaEpocaEvent.offer(event);
		} catch (InterruptedException e) {
			e.printStackTrace();//TODO revisar aviso de erro
		}
	}

	public void trocouValorTempera(TrocaValorTemperaEvent event) {
		try {
			if (queueTrocaValorTemperaEvent.size() >= MAX_FILA_OUTROS) {
				queueTrocaValorTemperaEvent.poll();
//                                System.gc();
			}
			queueTrocaValorTemperaEvent.put(event);
		} catch (InterruptedException e) {
			e.printStackTrace();//TODO revisar aviso de erro
		}
	}

}
