package controle.main;


import java.awt.Dialog;
import java.awt.Frame;
import java.awt.Label;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import jfan.exceptions.JfanPorcentagemException;
import jfan.fan.MonitorFAN;
import jfan.fan.RedeFAN;
import jfan.fan.normalizadores.INormalizator;
import jfan.fan.normalizadores.NormalizatorConfiguration;
import jfan.fan.normalizadores.NormalizatorMax;
import jfan.fan.normalizadores.NormalizatorMaxMean;
import jfan.fan.normalizadores.NormalizatorMaxMin;
import jfan.fan.normalizadores.NormalizatorTypes;
import jfan.fan.padroes.IPadrao;
import jfan.fan.temperas.ITemperaSimulada;
import jfan.fan.utilitarias.CalcularCaracteristicasFANBatch;
import jfan.fan.utilitarias.DetectorMaxMinMean;
import jfan.io.arquivos.GerenciadorPadroes;
import modelo.ApplicationConfig;
import modelo.DataSetPool;
import modelo.Projeto;
import visao.gui.telas.classes.EasyFan;
import controle.eventos.auxiliares.EnfileiradorEventos;
import controle.eventos.auxiliares.EvtQueues;

public class App {
	
	private static File ultimoArquivo = null;
	
	private static int ultimoFiltro = 0;
	
	private static MonitorFAN monitorFAN = null;
	
	private static GerenciadorPadroes gerenciadorPad = new GerenciadorPadroes();
	
	private static EasyFan tela;
	
	private static final ApplicationConfig appConfig = new ApplicationConfig(); 
	
	private static final Projeto projetoConfig = new Projeto("./ArqConfigEasyFAN.xml");
	
	private static final EvtQueues eventQueues = new EvtQueues();
	
	private static final EnfileiradorEventos enfileirador = new EnfileiradorEventos(eventQueues);
	
	private static boolean precisaNormalizar = true;
	
	private static final DataSetPool datasetpool = new DataSetPool();
	
	private static Object lockGraphicStatistic = new Object();
	//TODO criar campo que representa o thintel da primeira tela
	//private static Thinlet telaPrincipal
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		//jfan.fan.RedeFAN.main(new String[1]);
		try {
			tela = new EasyFan();
			
			tela.open();
		} catch (IOException e) {
			e.printStackTrace(); //TODO Retirar Ap�s desenvolvimento
			Dialog d = new Dialog(new Frame(),"Erro",true);
			String message = ("Ocorreu um erro ao tentar abrir a GUI principal, " +
			"o arquivo EasyFAN.xml deve estar corrompido ou adulterado inadequadamente.");
			Label l = new Label(message,Label.CENTER);
			d.add(l);
			d.setVisible(true);
			
		}
		//projetoConfig.saveAsDefaultConfiguration();
	}
	
	public static void iniciaRede() {
		try {
			monitorFAN = new MonitorFAN(new RedeFAN(projetoConfig.getRedeConf().getRaioDifuso(), projetoConfig.getRedeConf().getSuporteConjuntosDifusos()),gerenciadorPad);
			applyConfigurations();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		//RedeFAN.novaRedeFAN(raioDifuso, suporteConjuntosDifusos);
		//rede = RedeFAN.getRedeFAN();
	}
	
	public static GerenciadorPadroes getGerenciadorPadroes() {
		return gerenciadorPad;
	}
	
	public static MonitorFAN getMonitorFAN() {
		return monitorFAN;
	}

	public static ApplicationConfig getApplicationConfig() {
		return appConfig;
	}

	public static EvtQueues getEventQueues() {
		return eventQueues;
	}

	public static Projeto getProjetoConfig() {
		return projetoConfig;
	}
	
	private static void applyConfigurations() {
		//monitorFAN.setClasses(gerenciadorPad.getClassesConjuntoTreinamento());
		monitorFAN.setTemperaSimulada(projetoConfig.getTreinoConf().getTempera());
		monitorFAN.setCadaEpocaEmbaralharPadroes(projetoConfig.getTreinoConf().getCadaEpocaEmbaralharPadroes());
		monitorFAN.setCadaEpocaReiniciarTempera(projetoConfig.getTreinoConf().getCadaEpocaResetTempera());
		monitorFAN.setCadaEpocaRenormalizar(projetoConfig.getTreinoConf().getCadaEpocaRenormalizar());
		monitorFAN.setCadaEpocaStepTempera(projetoConfig.getTreinoConf().getCadaEpocaStepTempera());
		try {
			monitorFAN.setChanceRenormalizacao(projetoConfig.getTreinoConf().getChanceRenormalizar());
		} catch (JfanPorcentagemException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		monitorFAN.setNumeroPadroesTreinamento(projetoConfig.getTreinoConf().getNumeroPadroesTreino());
		monitorFAN.addValidacaoListener(tela.getEvtValidacao());
		projetoConfig.getRedeConf().setNormalizatorConfiguration(new NormalizatorConfiguration());
	}

	public static boolean isPrecisaNormalizar() {
		return precisaNormalizar;
	}

	public static void setPrecisaNormalizar(boolean precisaNormalizar) {
		App.precisaNormalizar = precisaNormalizar;
	}
	
	public static EasyFan getTelaEasyFAN() {
		return tela;
	}

	public static DataSetPool getDatasetpool() {
		return datasetpool;
	}
	
	{
		//TODO isso deve ser feito no começo de cada projeto.
		//App.getProjetoConfig().getRedeConf().setNormalizatorConfiguration(new NormalizatorConfiguration());
	}

	public static EnfileiradorEventos getEnfileiradorEventos() {
		return enfileirador;
	}
	
	public static void vericarMonitor() {
		if (monitorFAN == null) {
			App.iniciaRede();
			App.getMonitorFAN().addTrocaEpocaListener(enfileirador);
			App.getMonitorFAN().addMaximoMinimoListener(enfileirador);
			App.getMonitorFAN().addMelhorAritimeticaListener(enfileirador);
			App.getMonitorFAN().addMelhorHarmonicaListener(enfileirador);
			//TODO retirar, tempor�rio s� para testes
			App.getMonitorFAN().setCadaEpocaEmbaralharPadroes(50);
			//App.getMonitorFAN().setTemperaSimulada(null);
			App.getMonitorFAN().setCadaEpocaStepTempera(0);
			//App.getMonitorFAN().setNumeroPadroesTreinamento(2500);
			App.getMonitorFAN().setCadaEpocaReiniciarTempera(500);
			App.getMonitorFAN().setCadaEpocaRenormalizar(2000);
			ITemperaSimulada temp =  App.getProjetoConfig().getTreinoConf().getTempera();
			if (temp != null)
				temp.addTrocaValorTemperaListener(enfileirador);
			monitorFAN.addValidacaoListener(tela.getEvtValidacao());
		}

	}

	public static Object getLockGraphicStatistic() {
		return lockGraphicStatistic;
	}
	
	/*static {
			App.iniciaRede();
			App.getMonitorFAN().addTrocaEpocaListener(enfileirador);
			App.getMonitorFAN().addMaximoMinimoListener(enfileirador);
			App.getMonitorFAN().addMelhorAritimeticaListener(enfileirador);
			App.getMonitorFAN().addMelhorHarmonicaListener(enfileirador);
			//TODO retirar, tempor�rio s� para testes
			App.getMonitorFAN().setCadaEpocaEmbaralharPadroes(50);
			//App.getMonitorFAN().setTemperaSimulada(null);
			App.getMonitorFAN().setCadaEpocaStepTempera(0);
			//App.getMonitorFAN().setNumeroPadroesTreinamento(2500);
			App.getMonitorFAN().setCadaEpocaReiniciarTempera(500);
			App.getMonitorFAN().setCadaEpocaRenormalizar(2000);
			ITemperaSimulada temp =  App.getProjetoConfig().getTreinoConf().getTempera();
			if (temp != null)
				temp.addTrocaValorTemperaListener(enfileirador);
			}*/
	
	public static void reiniciarGerenciadorPadroes() {
		gerenciadorPad = new GerenciadorPadroes();
	}
	
	public static void requisitarNormalizacao() {
		if(precisaNormalizar) {
			//firstRunning = false;
			ArrayList<IPadrao> tr,ts, vl, cl;
			try {
				tr = gerenciadorPad.getConjuntoTreinamentoRede();
				ts = gerenciadorPad.getConjuntoTesteRede();
				vl = gerenciadorPad.getConjuntoValidacaoRede();
				cl = gerenciadorPad.getConjuntoClassificacaoRede();
				//double[] max = DetectorMaxMinMean.procurarMaximos(tr, ts, vl, cl);
				//double[] min = DetectorMaxMinMean.procurarMinimos(tr, ts, vl, cl);
				//double[] mean = DetectorMaxMinMean.procurarMedias(tr, ts, vl, cl);
				//TODO retirar -- tempor�rio
				//projetoConfig.getRedeConf().setMaximos(max);
				//projetoConfig.getRedeConf().setMinimos(min);
				//projetoConfig.getRedeConf().setMedias(mean);
				//TODO fazer ifs para saber que tipo normalizar
				//TODO pegar max,min e means de uma configura��o do projeto.
				
				INormalizator norm = null;
				
				
				
				NormalizatorConfiguration config = App.getProjetoConfig().getRedeConf().getNormalizatorConfiguration();
				
//				TODO retirar -- tempor�rio
				config.setMaximos(App.getProjetoConfig().getRedeConf().getMaximos());
				config.setMinimos(App.getProjetoConfig().getRedeConf().getMinimos());
				config.setMedias(App.getProjetoConfig().getRedeConf().getMedias());
				
				
				NormalizatorTypes tipo = App.getProjetoConfig().getRedeConf().getTipoNormalizador();
				//Os testes para saber qual normalizador usar,
				//o normalizador, caso n�o se tenha escolhido normalizador, � o NormalizatorMax, por isso ele s� � considerado no else.
				//O padr�o do easyfan � o NormalizatorMaxMin.
				if (tipo == NormalizatorTypes.NormalizatorMaxMin) {
					norm = new NormalizatorMaxMin(config);
				}
				else if (tipo == NormalizatorTypes.NormalizatorMaxMean) {
					norm = new NormalizatorMaxMean(config);
				}
				else if (tipo == NormalizatorTypes.NormalizatorArcSinMaxMin) {
					//TODO ArcSinMaxMin
				}
				else{
					norm = new NormalizatorMax(config);
				}
				
				norm.normalizarThreaded(tr);
				norm.normalizarThreaded(ts);
				norm.normalizarThreaded(vl);
				norm.normalizarThreaded(cl);
				
				CalcularCaracteristicasFANBatch calc = new CalcularCaracteristicasFANBatch(App.getProjetoConfig().getRedeConf().getRaioDifuso(), App.getProjetoConfig().getRedeConf().getSuporteConjuntosDifusos());
				calc.calcularCaracteristicasFAN(tr);
				calc.calcularCaracteristicasFAN(ts);
				calc.calcularCaracteristicasFAN(vl);
				calc.calcularCaracteristicasFAN(cl);
				precisaNormalizar =  false;
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	public static File getUltimoArquivo() {
		return ultimoArquivo;
	}

	public static void setUltimoArquivo(File ultimoArquivo) {
		App.ultimoArquivo = ultimoArquivo;
	}

	public static int getUltimoFiltro() {
		return ultimoFiltro;
	}

	public static void setUltimoFiltro(int ultimoFiltro) {
		App.ultimoFiltro = ultimoFiltro;
	}
}
