package visao.gui.telas.classes;

import java.awt.Dialog;
import java.awt.Frame;
import java.io.IOException;
import java.util.ArrayList;

import jfan.fan.NeuronioFAN;
import jfan.fan.StoredNetworkType;
import jfan.io.arquivos.CarregaNeuronioXML;
import thinlet.Thinlet;
import thinletcommons.AntiAliasedThinlet;
import thinletcommons.ThinletDialog;
import controle.eventos.EvtClassificacao;
import controle.eventos.EvtValidacao;
import controle.main.App;

public class ClassificaRede {

	private Thinlet thinlet;

	private ThinletDialog dialog;
	
	private StoredNetworkType tipoRede = StoredNetworkType.BestHarmonicMean;
	
	private boolean carregar = false;
	
	private EvtClassificacao evtClassificacao = App.getTelaEasyFAN().getEvtClassificacao();

	public ClassificaRede(Dialog owner) {
		this.dialog = new ThinletDialog(owner, false);
		this.init();
	}

	public ClassificaRede(Dialog owner, String title) {
		this.dialog = new ThinletDialog(owner, title, false);
		this.init();
	}

	public ClassificaRede(Frame owner) {
		this.dialog = new ThinletDialog(owner, false);
		this.init();
	}

	public ClassificaRede(Frame owner, String title) {
		this.dialog = new ThinletDialog(owner, title, false);
		this.init();
	}

	private void init() {
		this.thinlet = new AntiAliasedThinlet();
		Object panel = null;
		try {
			panel = thinlet.parse(
					"/visao/gui/telas/TesteRede.xml", this);
		} catch (IOException e) {
			// TODO Criar mensagem de erro na constura��o
			e.printStackTrace();

		}
		thinlet.add(panel);
		dialog.setContent(thinlet);
	}

	public void show() {
		dialog.pack();
		//dialog.setSize(210, 175);
		//dialog.setAlwaysOnTop(true);
		dialog.setModal(true);
		dialog.setLocationRelativeTo(dialog.getOwner());
		dialog.setVisible(true);
	}

	public void confirmar() {
		if (carregar) {
			CarregaNeuronioXML cnx = App.getTelaEasyFAN().getEvtAbrirArquivo().abrirRedeCarregaXML();
			ArrayList<NeuronioFAN> neurons = App.getTelaEasyFAN().getEvtAbrirArquivo().abrirRedeSomenteNeuronios();
			//evtTeste.testarRede(neurons);
			evtClassificacao.classificar(neurons,cnx);
		}
		else {
			evtClassificacao.classificar(tipoRede);
		}
		dialog.setVisible(false);
	}

	public void cancelar() {
		dialog.setVisible(false);
	}
	
	public void radioHarmonica() {
		this.carregar = false;
		this.tipoRede = StoredNetworkType.BestHarmonicMean;
	}
	
	public void radioAritmetica() {
		this.carregar = false;
		this.tipoRede = StoredNetworkType.BestAritmethicMean;
	}
	
	public void radioMaxMin() {
		this.carregar = false;
		this.tipoRede = StoredNetworkType.BestMaxMin;
	}
	
	public void radioAtual() {
		this.carregar = false;
		this.tipoRede = StoredNetworkType.Actual;
	}
	
	public void radioCarregada() {
		this.carregar = true;
	}

	
}
