package visao.gui.telas.classes;


import java.awt.Dialog;
import java.awt.Frame;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.IOException;

import controle.eventos.EvtNormalizacao;
import controle.main.App;
import thinlet.Thinlet;
import thinletcommons.AntiAliasedThinlet;
import thinletcommons.MessageDialog;
import thinletcommons.ThinletDialog;

public class ConfigNormalizacao  extends AntiAliasedThinlet {
	private Thinlet thinlet;
	private ThinletDialog dialog;
	
	private int indiceAtual = 0;
	
	private double[] arrayValoresMax = App.getProjetoConfig().getRedeConf().getMaximos();
	private double[] arrayValoresMin = App.getProjetoConfig().getRedeConf().getMinimos();
	private double[] arrayValoresMean = App.getProjetoConfig().getRedeConf().getMedias();
	
	private boolean[] arrayAutoMax = App.getProjetoConfig().getRedeConf().getMaximosAutomaticos();
	private boolean[] arrayAutoMin = App.getProjetoConfig().getRedeConf().getMinimosAutomaticos();
	private boolean[] arrayAutoMean = App.getProjetoConfig().getRedeConf().getMediasAutomaticas();
	
	private Object txtMax, txtMin, txtMean, cmbCaracteristica, chkMax, chkMin, chkMean;
	

	
	public ConfigNormalizacao(Frame frame,String title) {
		//this.dialog = new ThinletDialog(frame,true);
		ChamarDialogo(frame,"Configurar Normalizao");
	}

    public void ChamarDialogo(Frame owner, String title) {
    	this.dialog = new ThinletDialog(owner,title,true);
    	this.init();
    	this.show();
    }
	
    public void initParameters(Object txtMax,Object txtMin,Object txtMean,Object cmbCaracteristica,Object chkMax,Object chkMin,Object chkMean) {
    	this.txtMax = txtMax;
    	this.txtMin = txtMin;
    	this.txtMean = txtMean;
    	this.chkMax = chkMax;
    	this.chkMean = chkMean;
    	this.chkMin = chkMin;
    	this.cmbCaracteristica = cmbCaracteristica;
    	
    	//Preenche combobox com as características
    	try {
    		if (App.getGerenciadorPadroes().getConjuntoTreinamentoRede().size() == 0) {
    			MessageDialog msgDialog = new MessageDialog(dialog,"Aviso","Deve ser carregado um conjunto de treinamento \n antes de configurar os parâmetros de normalização.");
    			msgDialog.show();
    			dialog.setVisible(false);
    			return;
    		}
			int numCar = App.getGerenciadorPadroes().getConjuntoTreinamentoRede().get(0).getQuantasCaracteristicas();
			for (int i = 0; i < numCar; i++ ) {
				Object choice = thinlet.create("choice");
				thinlet.setString(choice, "text", Integer.toString(i+1));
				thinlet.add(cmbCaracteristica, choice);
			}
			thinlet.setInteger(cmbCaracteristica, "selected", 0);
			thinlet.setString(cmbCaracteristica, "text", "1");
			
			loadData();	
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	
    }
    
    private void loadData() {
//    	preencher txts & chks
		thinlet.setBoolean(chkMax, "selected", arrayAutoMax[indiceAtual]);
		thinlet.setBoolean(chkMin, "selected", arrayAutoMin[indiceAtual]);
		thinlet.setBoolean(chkMean, "selected", arrayAutoMean[indiceAtual]);
		thinlet.setString(txtMax, "text", Double.toString(arrayValoresMax[indiceAtual]));
		thinlet.setString(txtMin, "text", Double.toString(arrayValoresMin[indiceAtual]));
		thinlet.setString(txtMean, "text", Double.toString(arrayValoresMean[indiceAtual]));
		thinlet.setBoolean(txtMax, "enabled", !arrayAutoMax[indiceAtual]);
		thinlet.setBoolean(txtMax, "editable", !arrayAutoMax[indiceAtual]);
		thinlet.setBoolean(txtMin, "enabled", !arrayAutoMin[indiceAtual]);
		thinlet.setBoolean(txtMin, "editable", !arrayAutoMin[indiceAtual]);
		thinlet.setBoolean(txtMean, "enabled", !arrayAutoMean[indiceAtual]);
		thinlet.setBoolean(txtMean, "editable", !arrayAutoMean[indiceAtual]);
    }
    
	private void init() {
		this.thinlet = new AntiAliasedThinlet();
		Object panel = null;
		try {
			panel = thinlet.parse("/visao/gui/telas/configurarNormalizacao.xml", this);
		} catch (IOException e) {
			new MessageDialog(dialog, "Erro ao abrir a janela", "Erro ao tentar abrir a configura��o de normaliza��o").show();
			e.printStackTrace();
			
		}
        thinlet.add(panel);
        dialog.setContent(thinlet);
        dialog.setModal(true);
	}
	
	public void show() {
		
		try {
			if (App.getGerenciadorPadroes().getConjuntoTreinamentoRede().size() <= 0) {
				//TODO abrir mensagem de erro
			}
			else {
				dialog.pack();
				dialog.setSize(270,210);
				dialog.setAlwaysOnTop(true);
		        dialog.setLocationRelativeTo(dialog.getOwner());
		        dialog.setVisible(true);
			}      
        
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
    public void confirmarNormalizacao(){
    	dialog.setVisible(false);
    	dialog.dispose();
    	//EvtNormalizacao.arrumarParametrosNormalizacao();
    }   
    public void cancelar(){
    	dialog.setVisible(false);
    	dialog.dispose();
    }
    public void comboChanged() {
    	indiceAtual = thinlet.getInteger(cmbCaracteristica, "selected");
    	loadData();
    }
    
    public void maxCheck() {
    	boolean b = thinlet.getBoolean(chkMax, "selected");
    	if (b) {
    		thinlet.setBoolean(txtMax, "enabled", false);
    		thinlet.setBoolean(txtMax, "editable", false);
    	}
    	else {
    		thinlet.setBoolean(txtMax, "enabled", true);
    		thinlet.setBoolean(txtMax, "editable", true);
    	}
    	arrayAutoMax[indiceAtual] = b;
    	App.setPrecisaNormalizar(true);
    	EvtNormalizacao.arrumarParametrosNormalizacao();
    	loadData();
    }
    
    public void minCheck() {
    	boolean b = thinlet.getBoolean(chkMin, "selected");
    	if (b) {
    		thinlet.setBoolean(txtMin, "enabled", false);
    		thinlet.setBoolean(txtMin, "editable", false);
    	}
    	else {
    		thinlet.setBoolean(txtMin, "enabled", true);
    		thinlet.setBoolean(txtMin, "editable", true);
    	}
    	arrayAutoMin[indiceAtual] = b;
    	App.setPrecisaNormalizar(true);
    	EvtNormalizacao.arrumarParametrosNormalizacao();
    	loadData();
    }
    
    public void meanCheck() {
    	boolean b = thinlet.getBoolean(chkMean, "selected");
    	if (b) {
    		thinlet.setBoolean(txtMean, "enabled", false);
    		thinlet.setBoolean(txtMean, "editable", false);
    	}
    	else {
    		thinlet.setBoolean(txtMean, "enabled", true);
    		thinlet.setBoolean(txtMean, "editable", true);
    	}
    	arrayAutoMean[indiceAtual] = b;
    	App.setPrecisaNormalizar(true);
    	EvtNormalizacao.arrumarParametrosNormalizacao();
    	loadData();
    }
    
    public void maxChange() {
    	String s = thinlet.getString(txtMax, "text");
    	
    	if (s != null && !s.equalsIgnoreCase("")) {
    		try {
    			double d = Double.parseDouble(s);
    			char ultimo = s.charAt(s.length()-1);
				if (ultimo == 'd' || ultimo == 'f') {
					s = s.substring(0, s.length()-1);
					thinlet.setString(txtMax,"text", s);
					return;
				}
    			arrayValoresMax[indiceAtual] = d;
    		}
    		catch (NumberFormatException e) {
    			s = s.substring(0, s.length() - 1);
				setString(txtMax, "text", s);
    		}
    	}
    	App.setPrecisaNormalizar(true);
    }
    
    public void minChange() {
    	String s = thinlet.getString(txtMin, "text");
    	
    	if (s != null && !s.equalsIgnoreCase("")) {
    		try {
    			double d = Double.parseDouble(s);
    			char ultimo = s.charAt(s.length()-1);
				if (ultimo == 'd' || ultimo == 'f') {
					s = s.substring(0, s.length()-1);
					thinlet.setString(txtMin,"text", s);
					return;
				}
    			arrayValoresMin[indiceAtual] = d;
    		}
    		catch (NumberFormatException e) {
    			s = s.substring(0, s.length() - 1);
				setString(txtMin, "text", s);
    		}
    	}
    	App.setPrecisaNormalizar(true);
    }
    
    public void meanChange() {
    	String s = thinlet.getString(txtMean, "text");
    	
    	if (s != null && !s.equalsIgnoreCase("")) {
    		try {
    			double d = Double.parseDouble(s);
    			char ultimo = s.charAt(s.length()-1);
				if (ultimo == 'd' || ultimo == 'f') {
					s = s.substring(0, s.length()-1);
					thinlet.setString(txtMean,"text", s);
					return;
				}
    			arrayValoresMean[indiceAtual] = d;
    		}
    		catch (NumberFormatException e) {
    			s = s.substring(0, s.length() - 1);
				setString(txtMean, "text", s);
    		}
    	}
    	App.setPrecisaNormalizar(true);
    }
    
    
}
