package visao.gui.telas.classes;

import java.awt.Frame;
import java.io.IOException;
import java.util.ArrayList;

import jfan.fan.NeuronioFAN;
import jfan.fan.utilitarias.RecalculadorClasses;
import jfan.io.arquivos.GerenciadorPadroes;
import thinlet.Thinlet;
import thinletcommons.AntiAliasedThinlet;
import thinletcommons.ThinletDialog;
import controle.main.App;

public class ConfigPesos extends AntiAliasedThinlet {
	
	private Object pnl;
	private Object[] txts;
	private Thinlet thinlet;
	private ThinletDialog dialog;
	
	private ArrayList<NeuronioFAN> neuronios = App.getMonitorFAN().getNeuroniosAtuais(); 
	
	public void initParameters(Object pnl) {
		this.pnl = pnl;
	}
	
	public ConfigPesos(Frame ower, String title) {
		this.dialog = new ThinletDialog(ower,title,true);
		this.init();	
	}
	
	private void init() {
		this.thinlet = new AntiAliasedThinlet();
		Object panel = null;
		try {
			panel = thinlet.parse(
					"/visao/gui/telas/ConfigPesos.xml", this);
		} catch (IOException e) {
			// TODO Criar mensagem de erro na constura��o
			e.printStackTrace();

		}
		thinlet.add(panel);
		dialog.setContent(thinlet);
		Object label,label2;
		int fim = neuronios.size();
		txts = new Object[fim];
		GerenciadorPadroes gp = App.getGerenciadorPadroes();
		for (int i = 0; i < fim; i++) {
			label = thinlet.create("label");
			label2 = thinlet.create("label");
			thinlet.setString(label2, "text", "0 - 1000");
			int classMapeada = RecalculadorClasses.getClassesMapIndexReal().get(neuronios.get(i).getClasseAssociada());
			String classe = gp.getMapaClasses().get(classMapeada);
			if (classe == null) {
				classe = Integer.toString(classMapeada);
			}
			thinlet.setString(label, "text", classe);
			thinlet.add(pnl, label);
			txts[i] = thinlet.create("textfield");
			thinlet.setString(txts[i], "text", Integer.toString(neuronios.get(i).getPesoPenalizacao()));
			thinlet.setMethod(txts[i], "action", "validarPeso(this)",thinlet,this);
			thinlet.add(pnl,txts[i]);
			thinlet.add(pnl,label2);
		}
	}
	
	public void validarPeso(Object textField) {
		String s = getString(textField, "text");
		int pesoBase = 1000;
			try {
				if (s != null && !s.equals(""))
					pesoBase = Integer.parseInt(s);
				if (pesoBase > 1000) {
					s = s.substring(0, s.length() - 1);
					setString(textField, "text", s);
				}
			} catch (NumberFormatException e) {
				StringBuilder sb = new StringBuilder(s);
				int j = 0;
				while (j < sb.length()) {
					try {
						int z = Integer.parseInt(Character.toString(sb
								.charAt(j)));
						j++;
					} catch (NumberFormatException ex) {
						sb.deleteCharAt(j);
					}
				}

				setString(textField, "text", sb.toString());
			}
	}
	
	
	
	public void show() {
		dialog.pack();
		//dialog.setSize(210, 175);
		//dialog.setAlwaysOnTop(true);
		dialog.setModal(true);
		dialog.setLocationRelativeTo(dialog.getOwner());
		dialog.setVisible(true);
	}
	
	public void confirmar() {
		int fim = neuronios.size();
		for (int i = 0; i < fim; i++ ) {
			String s = thinlet.getString(txts[i], "text");
			neuronios.get(i).setPesoPenalizacao(Integer.parseInt(s));
		}
		cancelar();
	}
	
	public void cancelar() {
		dialog.setVisible(false);
		dialog.dispose();
	}
	
	
}
