package visao.gui.telas.classes;

import java.awt.Dialog;
import java.awt.Frame;
import java.io.IOException;

import controle.main.App;
import thinlet.Thinlet;
import thinletcommons.AntiAliasedThinlet;
import thinletcommons.MessageDialog;
import thinletcommons.ThinletDialog;

public class ConfigRede {

	private Thinlet thinlet;
	private ThinletDialog dialog;
	private int raioDifuso, suporteConjuntoDifuso;
	private Object txtRaioDifuso, txtSuporteConjuntoDifuso;
	
	public ConfigRede(Dialog owner) {
		this.dialog = new ThinletDialog(owner,false);
		this.init();
	}
	
	public ConfigRede(Dialog owner, String title) {
		this.dialog = new ThinletDialog(owner,title,false);
		this.init();
	}
	
	public ConfigRede(Frame owner) {
		this.dialog = new ThinletDialog(owner,false);
		this.init();
	}
	public ConfigRede(Frame owner, String title) {
		this.dialog = new ThinletDialog(owner,title,false);
		this.init();
	}
	
	private void init() {
		this.thinlet = new AntiAliasedThinlet();
		Object panel = null;
		try {
			panel = thinlet.parse("/visao/gui/telas/ConfiguracoesRede.xml", this);
		} catch (IOException e) {
			e.printStackTrace();
			
		}
		raioDifuso = App.getProjetoConfig().getRedeConf().getRaioDifuso();
		thinlet.setString(txtRaioDifuso, "text", Integer.toString(raioDifuso));
		suporteConjuntoDifuso = App.getProjetoConfig().getRedeConf().getSuporteConjuntosDifusos();
		thinlet.setString(txtSuporteConjuntoDifuso, "text", Integer.toString(suporteConjuntoDifuso));
		
        thinlet.add(panel);
        dialog.setContent(thinlet);
	}
	
	public void initParameters(Object txtRaioDifuso, Object txtSuporte) {
		this.txtRaioDifuso = txtRaioDifuso;
		this.txtSuporteConjuntoDifuso = txtSuporte;
	}
	
	public void show() {
		dialog.pack();
		dialog.setSize(315, 135);
		dialog.setAlwaysOnTop(true);
        dialog.setLocationRelativeTo(dialog.getOwner());
        dialog.setVisible(true);
    }
	
	public void changeRaioDifuso() {
		String s = thinlet.getString(txtRaioDifuso, "text");
		try {
			if (s != null && !s.equals(""))
				raioDifuso = Integer.parseInt(s);
		} catch (NumberFormatException e) {
			StringBuilder sb = new StringBuilder(s);
			int j = 0;
			while (j < sb.length()) {
				try {
					int z = Integer.parseInt(Character.toString(sb
							.charAt(j)));
					j++;
				} catch (NumberFormatException ex) {
					sb.deleteCharAt(j);
				}
			}
			thinlet.setString(txtRaioDifuso, "text", sb.toString());
		}
	}
	
	public void changeSuporteConjuntoDisfuso() {
		String s = thinlet.getString(txtSuporteConjuntoDifuso, "text");
		try {
			if (s != null && !s.equals(""))
				suporteConjuntoDifuso = Integer.parseInt(s);
		} catch (NumberFormatException e) {
			StringBuilder sb = new StringBuilder(s);
			int j = 0;
			while (j < sb.length()) {
				try {
					int z = Integer.parseInt(Character.toString(sb
							.charAt(j)));
					j++;
				} catch (NumberFormatException ex) {
					sb.deleteCharAt(j);
				}
			}
			thinlet.setString(txtSuporteConjuntoDifuso, "text", sb.toString());
		}
	}
	
	public void confirmar(){
		MessageDialog msg = new MessageDialog(dialog, "Atenção","Para aplicar essa configuração a rede será reiniciada.\n Clique em OK para confirmar.",MessageDialog.MODE_OK_CANCEL);
		int resposta = msg.show();
		if (resposta == MessageDialog.ACTION_OK) {
			try {
				App.getProjetoConfig().getRedeConf().setRaioDifuso(raioDifuso);
				App.getProjetoConfig().getRedeConf().setSuporteConjuntosDifusos(suporteConjuntoDifuso);
				App.iniciaRede();
				App.setPrecisaNormalizar(true);
				if (App.getGerenciadorPadroes().getConjuntoTreinamentoRede().size() > 0)
					App.getMonitorFAN().setClasses(App.getGerenciadorPadroes().getClassesConjuntoTreinamento());
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}	
		dialog.setVisible(false);
	}
	
	public void cancelar(){
		dialog.setVisible(false);
	}
	
	public static void main(String[] args) {
		ConfigRede cr = new ConfigRede(new Frame(),"Configura��es de Rede");
		cr.show();
		while (cr.dialog.isShowing()) {}
		cr.dialog.dispose();
		
		System.exit(0);
		
	}

}
