package visao.gui.telas.classes;

import java.awt.Dialog;
import java.awt.Frame;
import java.io.IOException;
import thinlet.Thinlet;
import thinletcommons.AntiAliasedThinlet;
import thinletcommons.MessageDialog;
import thinletcommons.ThinletDialog;

import controle.eventos.EvtTreinamento;
import controle.main.App;

public class ConfigTempera extends AntiAliasedThinlet{

	private Thinlet thinlet;
	private ThinletDialog dialog;
	private EvtTreinamento evtTreinamento;
	private Object txtMaxLimit;
	private Object txtMinLimit;
	private Object txtStep;
	

   public void ConfigTempera(Frame ower, String title, EvtTreinamento evtTreinamento) {
		this.dialog = new ThinletDialog(ower,title,false);
		this.init();
		this.evtTreinamento = evtTreinamento;
	}
   
   public void initParameters(Object txtMaxLimit,Object txtMinLimit,Object txtStep) {
	   this.txtMaxLimit = txtMaxLimit;
	   this.txtMinLimit = txtMinLimit;
	   this.txtStep = txtStep;
   }
	

   private void init() {
		this.thinlet = new AntiAliasedThinlet();
		Object panel = null;
		try {
			panel = thinlet.parse("/visao/gui/telas/configurarTempera.xml", this);
		} catch (IOException e) {
			new MessageDialog(dialog, "Erro ao abrir a janela", "Erro ao tentar abrir a configura��o de t�mpera").show();
			e.printStackTrace();
			
		}
       thinlet.add(panel);
       dialog.setContent(thinlet);
       dialog.setModal(true);
	}
	
	public void show() {
		dialog.pack();
		dialog.setSize(200,155);
		dialog.setAlwaysOnTop(true);
        dialog.setLocationRelativeTo(dialog.getOwner());
        thinlet.setString(txtMaxLimit,"text",Double.toString(App.getProjetoConfig().getTreinoConf().getTempera().getLimiteMaximo()));
        thinlet.setString(txtMinLimit,"text",Double.toString(App.getProjetoConfig().getTreinoConf().getTempera().getLimiteMinimo()));
        thinlet.setString(txtStep,"text",Double.toString(App.getProjetoConfig().getTreinoConf().getTempera().getStepValue()));
        dialog.setVisible(true);
	}
	
   public void eventTrocarStepTempera(Object txtStepTempera) {
    	String s = thinlet.getString(txtStepTempera, "text");
    	if (s != null && !s.equals("")) {
	    	double step;
	    	try {
				step = Double.parseDouble(s);
				char ultimo = s.charAt(s.length()-1);
				if (ultimo == 'd' || ultimo == 'f') {
					s = s.substring(0, s.length()-1);
					thinlet.setString(txtStepTempera,"text", s);
					return;
				}
				evtTreinamento.trocarStepTempera(step);
			}
			catch (NumberFormatException e) {
				s = s.substring(0, s.length()-1);
				thinlet.setString(txtStepTempera,"text", s);
			}
    	}
    }
    
   public void eventTrocarLimiteMaximoTempera(Object txt) {
    	String s = thinlet.getString(txt, "text");
    	if (s != null && !s.equals("")) {
	    	double d;
	    	try {
				d = Double.parseDouble(s);
				char ultimo = s.charAt(s.length()-1);
				if (ultimo == 'd' || ultimo == 'f') {
					s = s.substring(0, s.length()-1);
					thinlet.setString(txt,"text", s);
					return;
				}
				evtTreinamento.trocarLimiteMaximoTempera(d);
			}
			catch (NumberFormatException e) {
				s = s.substring(0, s.length()-1);
				thinlet.setString(txt,"text", s);
			}
    	}
    }
    
    public void eventTrocarLimiteMinimoTempera(Object txt) {
    	String s = thinlet.getString(txt, "text");
    	if (s != null && !s.equals("")) {
	    	double d;
	    	try {
				d = Double.parseDouble(s);
				char ultimo = s.charAt(s.length()-1);
				if (ultimo == 'd' || ultimo == 'f') {
					s = s.substring(0, s.length()-1);
					thinlet.setString(txt,"text", s);
					return;
				}
				evtTreinamento.trocarLimiteMinimoTempera(d);
			}
			catch (NumberFormatException e) {
				s = s.substring(0, s.length()-1);
				thinlet.setString(txt,"text", s);
			}
    	}
    }

    public void confirmarTempera(){
    	dialog.setVisible(false);
    }  
    public void cancelar(){
    	dialog.setVisible(false);
    }
}

