package visao.gui.telas.classes;
import java.awt.Dialog;
import java.awt.Frame;
import java.io.IOException;

import controle.eventos.EvtTeste;
import thinlet.Thinlet;
import thinletcommons.AntiAliasedThinlet;
import thinletcommons.ThinletDialog;

public class ConfigTeste {

	private Thinlet thinlet;
	private ThinletDialog dialog;
	private Object txtNumEpocas,rdContinuamente, rdNumEpocas,rdTempo,txtDiasTs,txtHorasTs,txtMinutosTs,txtSegundosTs;

	public ConfigTeste(Dialog owner) {
		this.dialog = new ThinletDialog(owner,false);
		this.init();
	}
	
	public ConfigTeste(Dialog owner, String title) {
		this.dialog = new ThinletDialog(owner,title,false);
		this.init();
	}
	
	public ConfigTeste(Frame owner) {
		this.dialog = new ThinletDialog(owner,false);
		this.init();
	}
	public ConfigTeste(Frame owner, String title) {
		this.dialog = new ThinletDialog(owner,title,false);
		this.init();
	}
	
	private void init() {
		this.thinlet = new AntiAliasedThinlet();
		Object panel = null;
		try {
			panel = thinlet.parse("/visao/gui/telas/ParametrosTeste.xml", this);
		} catch (IOException e) {
			// TODO Criar mensagem de erro na constura��o
			e.printStackTrace();
			
		}
        thinlet.add(panel);
        dialog.setContent(thinlet);
	}
	public void initParameters(Object txtNumEpocas, Object rdContinuamente, Object rdNumEpocas,Object rdTempo,Object txtDiasTs,Object txtHorasTs,Object txtMinutosTs,Object txtSegundosTs) {
		this.txtNumEpocas = txtNumEpocas;
		this.rdContinuamente = rdContinuamente;
		this.rdNumEpocas = rdNumEpocas;
		this.rdTempo = rdTempo;
		this.txtDiasTs = txtDiasTs;
		this.txtHorasTs = txtHorasTs;
		this.txtMinutosTs = txtMinutosTs;
		this.txtSegundosTs = txtSegundosTs;
	}	
	
	public void trocarNumEpocasTestar(){
	
		thinlet.setBoolean(txtNumEpocas, "enabled", true);
		thinlet.setBoolean(txtNumEpocas, "editable", true);
		thinlet.setBoolean(txtDiasTs, "enabled", false);
		thinlet.setBoolean(txtDiasTs, "editable", false);
		thinlet.setBoolean(txtHorasTs, "enabled", false);
		thinlet.setBoolean(txtHorasTs, "editable", false);
		thinlet.setBoolean(txtMinutosTs, "enabled", false);
		thinlet.setBoolean(txtMinutosTs, "editable", false);
		thinlet.setBoolean(txtSegundosTs, "enabled", false);
		thinlet.setBoolean(txtSegundosTs, "editable", false);
		
		thinlet.repaint();
	}
	
	public void testarContinuamente() {
		thinlet.setBoolean(txtNumEpocas, "enabled", false);
		thinlet.setBoolean(txtNumEpocas, "editable", false);
		thinlet.setBoolean(txtDiasTs, "enabled", false);
		thinlet.setBoolean(txtDiasTs, "editable", false);
		thinlet.setBoolean(txtHorasTs, "enabled", false);
		thinlet.setBoolean(txtHorasTs, "editable", false);
		thinlet.setBoolean(txtMinutosTs, "enabled", false);
		thinlet.setBoolean(txtMinutosTs, "editable", false);
		thinlet.setBoolean(txtSegundosTs, "enabled", false);
		thinlet.setBoolean(txtSegundosTs, "editable", false);
		
		thinlet.repaint();
		
	}
	
   public void testarTempo(){
	    thinlet.setBoolean(txtNumEpocas, "enabled", false);
		thinlet.setBoolean(txtNumEpocas, "editable", false);
		thinlet.setBoolean(txtDiasTs, "enabled", true);
		thinlet.setBoolean(txtDiasTs, "editable", true);
		thinlet.setBoolean(txtHorasTs, "enabled", true);
		thinlet.setBoolean(txtHorasTs, "editable", true);
		thinlet.setBoolean(txtMinutosTs, "enabled", true);
		thinlet.setBoolean(txtMinutosTs, "editable", true);
		thinlet.setBoolean(txtSegundosTs, "enabled", true);
		thinlet.setBoolean(txtSegundosTs, "editable", true);
		thinlet.repaint();
   }
	public void show() {
		dialog.pack();
		dialog.setSize(270, 160);
		dialog.setModal(true);
		dialog.setAlwaysOnTop(true);
        dialog.setLocationRelativeTo(dialog.getOwner());
        dialog.setVisible(true);
    }
	public void confirmar(){
		
	}
	
	public void cancelar(){
		dialog.setVisible(false);
	}
	
	public static void main(String[] args) {
		ConfigTeste ct = new ConfigTeste(new Frame(),"Configura��es de Teste");
		ct.show();
		while (ct.dialog.isShowing()) {}
		ct.dialog.dispose();
		
		System.exit(0);
		
	}

}
