package visao.gui.telas.classes;

import java.awt.Dialog;
import java.awt.Frame;
import java.io.IOException;

import thinlet.Thinlet;
import thinletcommons.AntiAliasedThinlet;
import thinletcommons.ThinletDialog;
import controle.eventos.EvtTreinamento;
import controle.main.App;

public class ConfigTreinamento {

	private Thinlet thinlet;

	private ThinletDialog dialog;

	private EvtTreinamento evtTreinamento;

	private Object txtNumEpocas, rdContinuamente, rdNumEpocas, rdTempo,
			txtDiasTr, txtHorasTr, txtMinutosTr, txtSegundosTr;

	private boolean paradaPorTempo;

	private int diasParada;

	private int horasParada;

	private int segundosParada;

	private int minutosParada;

	public ConfigTreinamento(Dialog owner, EvtTreinamento evt) {
		this.dialog = new ThinletDialog(owner, false);
		evtTreinamento = evt;
		this.init();
	}

	public ConfigTreinamento(Dialog owner, String title, EvtTreinamento evt) {
		this.dialog = new ThinletDialog(owner, title, false);
		evtTreinamento = evt;
		this.init();
	}

	public ConfigTreinamento(Frame owner, EvtTreinamento evt) {
		this.dialog = new ThinletDialog(owner, false);
		evtTreinamento = evt;
		this.init();
	}

	public ConfigTreinamento(Frame owner, String title, EvtTreinamento evt) {
		this.dialog = new ThinletDialog(owner, title, false);
		evtTreinamento = evt;
		this.init();
	}

	private void init() {
		this.thinlet = new AntiAliasedThinlet();
		Object panel = null;
		try {
			panel = thinlet.parse("/visao/gui/telas/ParametrosTreinamento.xml",
					this);
		} catch (IOException e) {
			// TODO Criar mensagem de erro na constura��o
			e.printStackTrace();

		}
		if (App.getProjetoConfig().getTreinoConf().getNumeroEpocasTreinar() > 0) {
			thinlet.setBoolean(rdNumEpocas, "selected", true);
			thinlet.setBoolean(txtNumEpocas, "enabled", true);
			thinlet.setBoolean(txtNumEpocas, "editable", true);
			thinlet.setString(txtNumEpocas, "text", Integer.toString(App
					.getProjetoConfig().getTreinoConf()
					.getNumeroEpocasTreinar()));
		}
		else if (App.getProjetoConfig().getTreinoConf().getDiasParada() > 0 || App.getProjetoConfig().getTreinoConf().getHorasParada() > 0 || App.getProjetoConfig().getTreinoConf().getMinutosParada() > 0 || App.getProjetoConfig().getTreinoConf().getSegundosParada() > 0) {
			thinlet.setBoolean(rdTempo, "selected", true);
			thinlet.setBoolean(rdContinuamente, "selected", false);
			thinlet.setBoolean(txtDiasTr, "enabled", true);
			thinlet.setBoolean(txtDiasTr, "editable", true);
			thinlet.setBoolean(txtHorasTr, "enabled", true);
			thinlet.setBoolean(txtHorasTr, "editable", true);
			thinlet.setBoolean(txtMinutosTr, "enabled", true);
			thinlet.setBoolean(txtMinutosTr, "editable", true);
			thinlet.setBoolean(txtSegundosTr, "enabled", true);
			thinlet.setBoolean(txtSegundosTr, "editable", true);
			
		}
		
		thinlet.setString(txtDiasTr, "text", Integer.toString(App.getProjetoConfig().getTreinoConf().getDiasParada()));
		thinlet.setString(txtHorasTr, "text", Integer.toString(App.getProjetoConfig().getTreinoConf().getHorasParada()));
		thinlet.setString(txtMinutosTr, "text", Integer.toString(App.getProjetoConfig().getTreinoConf().getMinutosParada()));
		thinlet.setString(txtSegundosTr, "text", Integer.toString(App.getProjetoConfig().getTreinoConf().getSegundosParada()));
				
		thinlet.add(panel);
		dialog.setContent(thinlet);
	}

	public void initParameters(Object txtNumEpocas, Object rdContinuamente,
			Object rdNumEpocas, Object rdTempo, Object txtDiasTr,
			Object txtHorasTr, Object txtMinutosTr, Object txtSegundosTr) {
		this.txtNumEpocas = txtNumEpocas;
		this.rdContinuamente = rdContinuamente;
		this.rdNumEpocas = rdNumEpocas;
		this.rdTempo = rdTempo;
		this.txtDiasTr = txtDiasTr;
		this.txtHorasTr = txtHorasTr;
		this.txtMinutosTr = txtMinutosTr;
		this.txtSegundosTr = txtSegundosTr;

	}

	public void show() {
		dialog.pack();
		dialog.setModal(true);
		dialog.setLocationRelativeTo(dialog.getOwner());
		dialog.setVisible(true);
	}

	public void trocarNumEpocasTreinar() {
		String s = thinlet.getString(txtNumEpocas, "text");
		if (!s.trim().equals("") && s != null) {
			try {
				int i = Integer.parseInt(s);
				evtTreinamento.setNumeroEpocasTreinar(i);
			} catch (NumberFormatException e) {
				StringBuilder sb = new StringBuilder(s);
				int j = 0;
				while (j < sb.length()) {
					if (Character.isLetter(sb.charAt(j))) {
						sb.deleteCharAt(j);
					} else {
						j++;
					}
				}
				thinlet.setString(txtNumEpocas, "text", sb.toString());
			}
		}
		thinlet.setBoolean(txtNumEpocas, "enabled", true);
		thinlet.setBoolean(txtNumEpocas, "editable", true);
		thinlet.setBoolean(txtDiasTr, "enabled", false);
		thinlet.setBoolean(txtDiasTr, "editable", false);
		thinlet.setBoolean(txtHorasTr, "enabled", false);
		thinlet.setBoolean(txtHorasTr, "editable", false);
		thinlet.setBoolean(txtMinutosTr, "enabled", false);
		thinlet.setBoolean(txtMinutosTr, "editable", false);
		thinlet.setBoolean(txtSegundosTr, "enabled", false);
		thinlet.setBoolean(txtSegundosTr, "editable", false);
		this.paradaPorTempo = false;
		thinlet.repaint();
	}

	public void treinarContinuamente() {
		evtTreinamento.treinarContinuamente();
		thinlet.setBoolean(txtNumEpocas, "enabled", false);
		thinlet.setBoolean(txtNumEpocas, "editable", false);
		thinlet.setBoolean(txtDiasTr, "enabled", false);
		thinlet.setBoolean(txtDiasTr, "editable", false);
		thinlet.setBoolean(txtHorasTr, "enabled", false);
		thinlet.setBoolean(txtHorasTr, "editable", false);
		thinlet.setBoolean(txtMinutosTr, "enabled", false);
		thinlet.setBoolean(txtMinutosTr, "editable", false);
		thinlet.setBoolean(txtSegundosTr, "enabled", false);
		thinlet.setBoolean(txtSegundosTr, "editable", false);
		this.paradaPorTempo = false;
		thinlet.repaint();

	}

	public void treinarTempo() {
		thinlet.setBoolean(txtNumEpocas, "enabled", false);
		thinlet.setBoolean(txtNumEpocas, "editable", false);
		thinlet.setBoolean(txtDiasTr, "enabled", true);
		thinlet.setBoolean(txtDiasTr, "editable", true);
		thinlet.setBoolean(txtHorasTr, "enabled", true);
		thinlet.setBoolean(txtHorasTr, "editable", true);
		thinlet.setBoolean(txtMinutosTr, "enabled", true);
		thinlet.setBoolean(txtMinutosTr, "editable", true);
		thinlet.setBoolean(txtSegundosTr, "enabled", true);
		thinlet.setBoolean(txtSegundosTr, "editable", true);
		this.paradaPorTempo = true;
		thinlet.repaint();
	}

	public void diasEdited() {
		String s = thinlet.getString(txtDiasTr, "text");
		if (!s.trim().equals("") && s != null) {
			try {
				int i = Integer.parseInt(s);
				if (s.length() > 2) {
					thinlet.setString(txtDiasTr, "text", s.substring(0, s
							.length() - 1));
				} else {
					this.diasParada = i;
				}
			} catch (NumberFormatException e) {
				StringBuilder sb = new StringBuilder(s);
				int j = 0;
				while (j < sb.length()) {
					if (Character.isLetter(sb.charAt(j))) {
						sb.deleteCharAt(j);
					} else {
						j++;
					}
				}
				thinlet.setString(txtDiasTr, "text", sb.toString());
			}
		}
	}

	public void horasEdited() {
		String s = thinlet.getString(txtHorasTr, "text");
		if (!s.trim().equals("") && s != null) {
			try {
				int i = Integer.parseInt(s);
				if (s.length() > 2) {
					thinlet.setString(txtHorasTr, "text", s.substring(0, s
							.length() - 1));
				} else {
					this.horasParada = i;
				}
			} catch (NumberFormatException e) {
				StringBuilder sb = new StringBuilder(s);
				int j = 0;
				while (j < sb.length()) {
					if (Character.isLetter(sb.charAt(j))) {
						sb.deleteCharAt(j);
					} else {
						j++;
					}
				}
				thinlet.setString(txtHorasTr, "text", sb.toString());
			}
		}
	}

	public void minutosEdited() {
		String s = thinlet.getString(txtMinutosTr, "text");
		if (!s.trim().equals("") && s != null) {
			try {
				int i = Integer.parseInt(s);
				if (s.length() > 2) {
					thinlet.setString(txtMinutosTr, "text", s.substring(0, s
							.length() - 1));
				} else {
					this.minutosParada = i;
				}
			} catch (NumberFormatException e) {
				StringBuilder sb = new StringBuilder(s);
				int j = 0;
				while (j < sb.length()) {
					if (Character.isLetter(sb.charAt(j))) {
						sb.deleteCharAt(j);
					} else {
						j++;
					}
				}
				thinlet.setString(txtMinutosTr, "text", sb.toString());
			}
		}
	}

	public void segundosEdited() {
		String s = thinlet.getString(txtSegundosTr, "text");
		if (!s.trim().equals("") && s != null) {
			try {
				int i = Integer.parseInt(s);
				if (s.length() > 2) {
					thinlet.setString(txtSegundosTr, "text", s.substring(0, s
							.length() - 1));
				} else {
					this.segundosParada = i;
				}
			} catch (NumberFormatException e) {
				StringBuilder sb = new StringBuilder(s);
				int j = 0;
				while (j < sb.length()) {
					if (Character.isLetter(sb.charAt(j))) {
						sb.deleteCharAt(j);
					} else {
						j++;
					}
				}
				thinlet.setString(txtSegundosTr, "text", sb.toString());
			}
		}
	}

	public void confirmar() {
		
		if (paradaPorTempo) {
			evtTreinamento.ativarParadaPorTempo(diasParada, horasParada, minutosParada, segundosParada);
		}
		else {
			evtTreinamento.desativarParadaPorTempo();
		}
		
		dialog.setVisible(false);
	}

}
