package visao.gui.telas.classes;

import java.awt.Dialog;
import java.awt.Frame;
import java.io.IOException;

import jfan.fan.StoredNetworkType;

import controle.main.App;
import thinlet.Thinlet;
import thinletcommons.AntiAliasedThinlet;
import thinletcommons.ThinletDialog;

public class ConfigValidacao {

	private Thinlet thinlet;

	private ThinletDialog dialog;
	
	private Object txtNumEpocasVl,rdNuncaVl,rdNumEpocasVl,lbEpocas,rdValidaAtual,rdValidaMedHarm,rdValidaMedArit,rdValidaMaxMin;
	
	private StoredNetworkType tipoRede = StoredNetworkType.BestHarmonicMean;
	
	int epocas = 0;
	
	public void initParameters(Object txtNumEpocasVl,Object rdNuncaVl,Object rdNumEpocasVl,Object lbEpocas,Object rdValidaAtual, Object rdValidaMedHarm,Object rdValidaMedArit, Object rdValidaMaxMin) {
	    this.txtNumEpocasVl = txtNumEpocasVl;
	    this.rdNuncaVl = rdNuncaVl;
	    this.rdNumEpocasVl = rdNumEpocasVl;
	    this.lbEpocas = lbEpocas;
	    this.rdValidaAtual = rdValidaAtual;
	    this.rdValidaMedHarm = rdValidaMedHarm;
	    this.rdValidaMedArit = rdValidaMedArit;
	    this.rdValidaMaxMin = rdValidaMaxMin;
	    
	}
	
	public void selecionarTipoRedeAtual() {
		tipoRede = StoredNetworkType.Actual;
	}
	
	public void selecionarTipoRedeHarmonica() {
		tipoRede = StoredNetworkType.BestHarmonicMean;
	}
	
	public void selecionarTipoRedeAritmetica() {
		tipoRede = StoredNetworkType.BestAritmethicMean;
	}
	
	public void selecionarTipoRedeMaxMin() {
		tipoRede = StoredNetworkType.BestMaxMin;
	}
	
	public void nuncaValidar() {
		epocas = -1;
		thinlet.setBoolean(txtNumEpocasVl, "enabled", false);
		thinlet.setBoolean(txtNumEpocasVl, "editable", false);
		thinlet.repaint();
		
	}
	
	public void trocarNumEpocasValidar(){
		//App.getTelaEasyFAN().getEvtValidacao().validarCadaEpocas(epocas);
		thinlet.setBoolean(txtNumEpocasVl, "enabled", true);
		thinlet.setBoolean(txtNumEpocasVl, "editable", true);
		thinlet.setBoolean(lbEpocas, "enabled", true);
		thinlet.repaint();
		
	}	
	
	public void trocarTxtNumEpocasValidar() {
		String s = thinlet.getString(txtNumEpocasVl, "text");
		epocas = 0;
		try {
			if (s != null && !s.equals(""))
				epocas = Integer.parseInt(s);
				//App.getTelaEasyFAN().getEvtValidacao().validarCadaEpocas(epocas);
		} catch (NumberFormatException e) {
			// MessageDialog message = new MessageDialog(this.frame, "Dado
			// em formato inadequado","O campo com o número de épocas da
			// opção Embaralhar Padrões deve conter somente
			// números");
			// message.show();
			StringBuilder sb = new StringBuilder(s);
			int j = 0;
			while (j < sb.length()) {
				try {
					int z = Integer.parseInt(Character.toString(sb
							.charAt(j)));
					j++;
				} catch (NumberFormatException ex) {
					sb.deleteCharAt(j);
				}
			}
			thinlet.setString(txtNumEpocasVl, "text", sb.toString());
		}
	}
	
	public ConfigValidacao(Dialog owner) {
		this.dialog = new ThinletDialog(owner, false);
		this.init();
	}

	public ConfigValidacao(Dialog owner, String title) {
		this.dialog = new ThinletDialog(owner, title, false);
		this.init();
	}

	public ConfigValidacao(Frame owner) {
		this.dialog = new ThinletDialog(owner, false);
		this.init();
	}

	public ConfigValidacao(Frame owner, String title) {
		this.dialog = new ThinletDialog(owner, title, false);
		this.init();
	}

	private void init() {
		this.thinlet = new AntiAliasedThinlet();
		Object panel = null;
		try {
			panel = thinlet.parse("/visao/gui/telas/ParametrosValidacao.xml",
					this);
		} catch (IOException e) {
			// TODO Criar mensagem de erro na constura��o
			e.printStackTrace();

		}
		thinlet.add(panel);
		dialog.setContent(thinlet);
		
		int numEpocas = App.getProjetoConfig().getValidacaoConfig().getCadaEpocaValidar();
		
		if (numEpocas > 0) {
			trocarNumEpocasValidar();
			thinlet.setString(txtNumEpocasVl, "text", Integer.toString(numEpocas));
			thinlet.setBoolean(rdNumEpocasVl, "selected", true);
			thinlet.setBoolean(rdNuncaVl, "selected", false);
		}
		
		tipoRede = App.getProjetoConfig().getValidacaoConfig().getTipoRedeValidacao();
		switch (tipoRede) {
		case Actual:
			thinlet.setBoolean(rdValidaAtual, "selected", true);
			thinlet.setBoolean(rdValidaMaxMin, "selected", false);
			thinlet.setBoolean(rdValidaMedArit, "selected", false);
			thinlet.setBoolean(rdValidaMedHarm, "selected", false);
			break;
		case BestAritmethicMean:
			thinlet.setBoolean(rdValidaAtual, "selected", false);
			thinlet.setBoolean(rdValidaMaxMin, "selected", false);
			thinlet.setBoolean(rdValidaMedArit, "selected", true);
			thinlet.setBoolean(rdValidaMedHarm, "selected", false);
			break;
		case BestHarmonicMean:
			thinlet.setBoolean(rdValidaAtual, "selected", false);
			thinlet.setBoolean(rdValidaMaxMin, "selected", false);
			thinlet.setBoolean(rdValidaMedArit, "selected", false);
			thinlet.setBoolean(rdValidaMedHarm, "selected", true);
			break;
		case BestMaxMin:
			thinlet.setBoolean(rdValidaAtual, "selected", false);
			thinlet.setBoolean(rdValidaMaxMin, "selected", true);
			thinlet.setBoolean(rdValidaMedArit, "selected", false);
			thinlet.setBoolean(rdValidaMedHarm, "selected", false);
			break;
		}
		
	}

	public void show() {
		dialog.pack();
		//dialog.setSize(270, 150);
		dialog.setAlwaysOnTop(true);
		dialog.setLocationRelativeTo(dialog.getOwner());
		dialog.setVisible(true);
		dialog.setModal(true);
	}

	public void confirmar() {
		if (epocas <= 0) {
			App.getTelaEasyFAN().getEvtValidacao().desativarValidarCadaEpocas();
		}
		else {
			App.getTelaEasyFAN().getEvtValidacao().validarCadaEpocas(epocas);
		}
		App.getTelaEasyFAN().getEvtValidacao().setTipoRedeValidacao(tipoRede);
		dialog.setVisible(false);
	}

	public void cancelar() {
		dialog.setVisible(false);
	}

	public static void main(String[] args) {
		ConfigValidacao cv = new ConfigValidacao(new Frame(),
				"Configura��es de Valida��o");
		cv.show();
		while (cv.dialog.isShowing()) {
		}
		cv.dialog.dispose();

		System.exit(0);

	}

}
