package visao.gui.telas.classes;

import java.awt.Frame;
import java.awt.Image;
import java.awt.Toolkit;
import java.io.File;
import java.io.IOException;

import jfan.fan.normalizadores.NormalizatorTypes;
import jfan.fan.temperas.ITemperaSimulada;
import jfan.fan.temperas.TemperaAleatoria;
import jfan.fan.temperas.TemperaSimuladaFAN;
import thinlet.FrameLauncher;
import thinletcommons.AntiAliasedThinlet;
import thinletcommons.FileChooser;
import thinletcommons.MessageDialog;
import visao.gui.telas.graficos.classes.GraphicChooser;
import visao.gui.telas.utils.CarregarTabela;
import visao.gui.telas.utils.DataView;
import visao.gui.wizard.Wizard;
import controle.eventos.EvtAbrirArquivo;
import controle.eventos.EvtClassificacao;
import controle.eventos.EvtLimparConjunto;
import controle.eventos.EvtNormalizacao;
import controle.eventos.EvtSalvarArquivo;
import controle.eventos.EvtTeste;
import controle.eventos.EvtTreinamento;
import controle.eventos.EvtValidacao;
import controle.eventos.auxiliares.ContainerMatrizConfusao;
import controle.main.App;

public class EasyFan extends AntiAliasedThinlet {

	private static final long serialVersionUID = 1L;

	private Frame frame;

	private CarregarTabela carregarTabelaTeste = null;

	private CarregarTabela carregarTabelaValidacao = null;

	private CarregarTabela carregarTabelaClassificacao = null;

	private final EvtTreinamento evtTreinamento;

	private final EvtTeste evtTeste;
	
	private final EvtValidacao evtValidacao;
	
	private final EvtClassificacao evtClassificacao;

	private boolean pararTreinamento = false;

	public String[][] array = null;

	private EvtAbrirArquivo evtAbrirArquivo = new EvtAbrirArquivo();

	private Object screen;

	private viewHelp vHelp;// = new viewHelp();

	private Wizard abrirWizard = new Wizard();

	private ConfigTempera confTempera = new ConfigTempera();

	private salvarRede salvarRede = new salvarRede();

	private CarregarRede carregarRede = new CarregarRede();

	// CheckBox
	private Object chkEmbaralharPadroes, chkPorcentagemPadroes,
			chkNormalizarCadaEpoca, chkChanceNormalizar, chkRandomizarPesos,
			chkVisualizarTs,chkVisualizarVl,
			chkVisualizarCl;

	// TextField
	private Object txtPorcentagemPadroes, txtEmbaralharPadroes,
			txtNormalizarCadaEpoca, txtChanceNormalizar, txtRandomizarPesos, txtStep, txtReiniciarTempera;

	// Label
	private Object lblEmbaralharPadroes1, lblPorcentagemPadroes1,
			lblNormalizarCadaEpoca1, lblChanceNormalizar1, lblRandomizarPesos,
			lblNormalizacaoUtilizada, lblHarmonicaTeste, lblMaxMinTeste,
			lblAritmeticaTeste, lblAcertosTs, lblErrosTs, lblHarmonicaVl,lblMaxMinVl,
			lblAritmeticaVl,lblAcertosVl,lblErrosVl,lblEpocaValidada,lblTipoRedeValidacao;

	// Botão
	private Object btConfigRede, btAbrirProjeto, btWizard, btAbaTreino,
			btAbaTeste, btAbaValida, btAbaClassifica,
			btnConfigNormalizacaoUtilizada, btSalvarTr, btConfigurarTr,
			btVisualizarDadosTr, btTreinar, btDescarregarTr, btAbrirTr,
			btMatrizConfusaoTr, btTempera, btConfigNormalizacao, btAbrirTs,
			btDescarregarTs, btSalvarTs, btConfigurarTs, btTestarRede,
			btMatrizConfusaoTs, btGrafico, btAbrirVl, btDescarregarVl,
			btSalvarVl, btConfigurarVl, btResultadosVl, btValidar, btAbrirCl,
			btDescarregarCl, btSalvarCl, btCarregarRedeCl, btResultadosCl,
			btClassificar, antPagTs, proxPagTs, antPagVl, proxPagVl, antPagCl,
			proxPagCl,btValidarRede,btMatrizConfusaoVl, btCarregarRedeTr, btSalvarRedeTr ;

	// ComboBox
	private Object cmbNormalizacaoUtilizada, cmbNormaUtil;

	// Tabelas
	private Object tabelaTr, tabelaTs, tabelaVl, tabelaCl;

	public EasyFan() throws IOException {
		// TODO Ver se o arquivo existe senão mostrar mensagem de erro e sair;
		// this.setLocale(new Locale("pt","br"));
		screen = parse("/visao/gui/telas/EasyFan.xml");
		add(screen);
		// Prepara evtTreinamento
		evtTreinamento = new EvtTreinamento(this);
		evtTeste = new EvtTeste(this, this.find("lblHarmonicaTeste"), this
				.find("lblMaxMinTeste"), this.find("lblAritmeticaTeste"));
		evtValidacao = new EvtValidacao(this);
		evtClassificacao = new EvtClassificacao(this);
		init();
	}

	/**
	 * Retorna o frame que cont�m essa tela do EasyFAN.
	 * 
	 * @return
	 */

	public Frame getFrame() {
		return frame;
	}

	public Object getSreen() {
		return screen;
	}

	public void initParameters(Object chkEmbaralharPadroes,
			Object txtEmbaralharPadroes, Object lblEmbaralharPadroes1,
			Object chkPorcentagemPadroes, Object txtPorcentagemPadroes,
			Object lblPorcentagemPadroes1, Object chkNormalizarCadaEpoca,
			Object txtNormalizarCadaEpoca, Object lblNormalizarCadaEpoca1,
			Object chkChanceNormalizar, Object txtChanceNormalizar,
			Object lblChanceNormalizar1, Object chkRandomizarPesos,
			Object txtRandomizarPesos, Object lblRandomizarPesos1,
			Object lblNormalizacaoUtilizada, Object cmbNormalizacaoUtilizada,
			Object btnConfigNormalizacaoUtilizada, Object btSalvarTr,
			Object btConfigurarTr, Object btVisualizarDadosTr,
			Object btTreinar, Object btDescarregarTr, Object btCarregarRedeTr,
			Object btMatrizConfusaoTr, Object cmbNormaUtil,
			Object btConfigNormalizacao, Object btSalvarRedeTr, Object tabelaTs,
			Object chkVisualizarTs, Object btDescarregarTs, Object btSalvarTs,
			Object btConfigurarTs, Object btGrafico, Object tabelaTr,
			Object btConfigRede, Object btAbrirProjeto, Object btWizard,
			Object btAbaTreino, Object btAbaTeste, Object btAbaValida,
			Object btAbaClassifica, Object btAbrirTr, Object btAbrirTs,
			Object btTestarRede, Object btMatrizConfusaoTs,
			Object lblHarmonicaTeste, Object lblMaxMinTeste,
			Object lblAritmeticaTeste, Object lblAcertosTs, Object lblErrosTs,
			Object btAbrirVl, Object btDescarregarVl, Object btSalvarVl,
			Object btConfigurarVl, Object btResultadosVl,
			Object chkVisualizarVl, Object btValidar, Object tabelaVl,
			Object btAbrirCl, Object btDescarregarCl, Object btSalvarCl,
			Object btCarregarRedeCl, Object btResultadosCl,
			Object chkVisualizarCl, Object btClassificar, Object tabelaCl,
			Object antPagTs, Object proxPagTs, Object antPagVl,
			Object proxPagVl, Object antPagCl, Object proxPagCl,
			Object lblHarmonicaVl, Object lblMaxMinVl, Object lblAritmeticaVl,
			Object lblAcertosVl, Object lblErrosVl, Object btValidarRede, Object btMatrizConfusaoVl,
			Object txtStep, Object txtReiniciarTempera, Object lblEpocaValidada, Object lblTipoRedeValidacao) {

		this.chkEmbaralharPadroes = chkEmbaralharPadroes;
		this.txtEmbaralharPadroes = txtEmbaralharPadroes;
		this.lblEmbaralharPadroes1 = lblEmbaralharPadroes1;

		this.chkPorcentagemPadroes = chkPorcentagemPadroes;
		this.txtPorcentagemPadroes = txtPorcentagemPadroes;
		this.lblPorcentagemPadroes1 = lblPorcentagemPadroes1;

		this.chkNormalizarCadaEpoca = chkNormalizarCadaEpoca;
		this.txtNormalizarCadaEpoca = txtNormalizarCadaEpoca;
		this.lblNormalizarCadaEpoca1 = lblNormalizarCadaEpoca1;

		this.chkChanceNormalizar = chkChanceNormalizar;
		this.txtChanceNormalizar = txtChanceNormalizar;
		this.lblChanceNormalizar1 = lblChanceNormalizar1;

		this.chkRandomizarPesos = chkRandomizarPesos;
		this.txtRandomizarPesos = txtRandomizarPesos;
		this.lblRandomizarPesos = lblRandomizarPesos1;

		this.lblNormalizacaoUtilizada = lblNormalizacaoUtilizada;
		this.cmbNormalizacaoUtilizada = cmbNormalizacaoUtilizada;
		this.btnConfigNormalizacaoUtilizada = btnConfigNormalizacaoUtilizada;

		this.btConfigRede = btConfigRede;
		this.btAbrirProjeto = btAbrirProjeto;
		this.btWizard = btWizard;
		this.btAbaTreino = btAbaTreino;
		this.btAbaTeste = btAbaTeste;
		this.btAbaValida = btAbaValida;
		this.btAbaClassifica = btAbaClassifica;
		this.btAbrirTr = btAbrirTr;
		this.btDescarregarTr = btDescarregarTr;
		this.btSalvarTr = btSalvarTr;
		this.btConfigurarTr = btConfigurarTr;
		this.btVisualizarDadosTr = btVisualizarDadosTr;
		this.btGrafico = btGrafico;

		this.btTreinar = btTreinar;
		this.btCarregarRedeTr = btCarregarRedeTr;

		this.btMatrizConfusaoTr = btMatrizConfusaoTr;
		this.cmbNormaUtil = cmbNormaUtil;

		this.btConfigNormalizacao = btConfigNormalizacao;
		this.btSalvarRedeTr = btSalvarRedeTr;

		this.tabelaTs = tabelaTs;
		this.btAbrirTs = btAbrirTs;
		this.btDescarregarTs = btDescarregarTs;
		this.btSalvarTs = btSalvarTs;
		this.btConfigurarTs = btConfigurarTs;
		this.chkVisualizarTs = chkVisualizarTs;
		this.btTestarRede = btTestarRede;
		this.btMatrizConfusaoTs = btMatrizConfusaoTs;
		this.lblHarmonicaTeste = lblHarmonicaTeste;
		this.lblMaxMinTeste = lblMaxMinTeste;
		this.lblAritmeticaTeste = lblAritmeticaTeste;
		this.lblAcertosTs = lblAcertosTs;
		this.lblErrosTs = lblErrosTs;
		this.antPagTs = antPagTs;
		this.proxPagTs = proxPagTs;

		this.btAbrirVl = btAbrirVl;
		this.btDescarregarVl = btDescarregarVl;
		this.btSalvarVl = btSalvarVl;
		this.btConfigurarVl = btConfigurarVl;
		this.btResultadosVl = btResultadosVl;
		this.chkVisualizarVl = chkVisualizarVl;
		this.btValidar = btValidar;
		this.tabelaVl = tabelaVl;
		this.antPagVl = antPagVl;
		this.proxPagVl = proxPagVl;
		this.btValidarRede = btValidarRede;
		this.btMatrizConfusaoVl = btMatrizConfusaoVl;
		this.lblHarmonicaVl = lblHarmonicaVl;
		this.lblMaxMinVl = lblMaxMinVl;
		this.lblAritmeticaVl = lblAritmeticaVl;
		this.lblAcertosVl = lblAcertosVl;
		this.lblErrosVl = lblErrosVl;
		this.lblEpocaValidada = lblEpocaValidada;
		this.lblTipoRedeValidacao = lblTipoRedeValidacao;
				
		this.btAbrirCl = btAbrirCl;
		this.btDescarregarCl = btDescarregarCl;
		this.btSalvarCl = btSalvarCl;
		this.btCarregarRedeCl = btCarregarRedeCl;
		this.btResultadosCl = btResultadosCl;
		this.chkVisualizarCl = chkVisualizarCl;
		this.btClassificar = btClassificar;
		this.tabelaCl = tabelaCl;
		this.antPagCl = antPagCl;
		this.proxPagCl = proxPagCl;

		this.txtStep = txtStep;
		this.txtReiniciarTempera = txtReiniciarTempera;
	}

	private void init() {
		initAbaTreinamento();
	}
	
	private void initAbaTreinamento() {
		setBoolean(chkEmbaralharPadroes, "selected", App.getProjetoConfig()
				.getTreinoConf().getCadaEpocaEmbaralharPadroes() > 0);
		setBoolean(chkChanceNormalizar, "selected", App.getProjetoConfig()
				.getTreinoConf().getChanceRenormalizar() > 0);
		setBoolean(chkNormalizarCadaEpoca, "selected", App.getProjetoConfig()
				.getTreinoConf().getCadaEpocaRenormalizar() > 0);
		setBoolean(chkRandomizarPesos, "selected", App.getProjetoConfig()
				.getTreinoConf().isRandomizarPesos());
		setBoolean(chkPorcentagemPadroes, "selected", App.getProjetoConfig()
				.getTreinoConf().getNumeroPadroesTreino() > 0);

		if (App.getProjetoConfig().getTreinoConf().getChanceRenormalizar() > 0) {
			setString(txtChanceNormalizar, "text", Integer
					.toString(App.getProjetoConfig().getTreinoConf()
							.getChanceRenormalizar()));
			setBoolean(txtChanceNormalizar, "enabled", true);
			setBoolean(txtChanceNormalizar, "editable", true);
			setBoolean(lblChanceNormalizar1, "enabled", true);
			setBoolean(lblChanceNormalizar1, "editable", true);
		}

		if (App.getProjetoConfig().getTreinoConf()
				.getCadaEpocaEmbaralharPadroes() > 0) {
			setString(txtEmbaralharPadroes, "text", Integer.toString(App
					.getProjetoConfig().getTreinoConf()
					.getCadaEpocaEmbaralharPadroes()));
			setBoolean(txtEmbaralharPadroes, "enabled", true);
			setBoolean(txtEmbaralharPadroes, "editable", true);
			setBoolean(lblEmbaralharPadroes1, "enabled", true);
			// setBoolean(lblEmbaralharPadroes1, "editable", true);
		}

		if (App.getProjetoConfig().getTreinoConf().getCadaEpocaRenormalizar() > 0) {
			setString(txtNormalizarCadaEpoca, "text", Integer.toString(App
					.getProjetoConfig().getTreinoConf()
					.getCadaEpocaRenormalizar()));
			setBoolean(txtNormalizarCadaEpoca, "enabled", true);
			setBoolean(txtNormalizarCadaEpoca, "editable", true);
			setBoolean(lblNormalizarCadaEpoca1, "enabled", true);
			// setBoolean(lblNormalizarCadaEpoca1, "editable", true);
		}

		if (App.getProjetoConfig().getTreinoConf().getNumeroPadroesTreino() > 0) {
			setString(txtPorcentagemPadroes, "text", Integer.toString(App
					.getProjetoConfig().getTreinoConf()
					.getPorcentagemPadroesTreino()));
			setBoolean(txtPorcentagemPadroes, "enabled", true);
			setBoolean(txtPorcentagemPadroes, "editable", true);
			setBoolean(lblPorcentagemPadroes1, "enabled", true);
			// setBoolean(lblPorcentagemPadroes1, "editable", true);
		}

		if (App.getProjetoConfig().getTreinoConf().isRandomizarPesos()) {
			setString(txtRandomizarPesos, "text", Integer.toString(App
					.getProjetoConfig().getTreinoConf().getPesoBase()));
			setBoolean(txtRandomizarPesos, "enabled", true);
			setBoolean(txtRandomizarPesos, "editable", true);
			setBoolean(lblRandomizarPesos, "enabled", true);
			// setBoolean(lblRandomizarPesos, "editable", true);
		}

		NormalizatorTypes norm = App.getProjetoConfig().getRedeConf()
				.getTipoNormalizador();
		int index = 0;
		/*
		 * if (norm == NormalizatorTypes.NormalizatorMaxMin) { index = 0; } else
		 */if (norm == NormalizatorTypes.NormalizatorMax) {
			index = 1;
		} else if (norm == NormalizatorTypes.NormalizatorMaxMean) {
			index = 2;
		}
		Object choice = getItem(cmbNormalizacaoUtilizada, index);
		setInteger(cmbNormalizacaoUtilizada, "selected", index);
		setString(cmbNormalizacaoUtilizada, "text", getString(choice, "text"));
		
		setString(txtStep,"text",Integer.toString(App.getProjetoConfig().getTreinoConf().getCadaEpocaStepTempera()));
		
		setString(txtReiniciarTempera, "text", Integer.toString(App.getProjetoConfig().getTreinoConf().getCadaEpocaResetTempera()));
	}

	// **********FUNÇÕES
	// GERAIS*******************************************************************************
	public void abrirProjeto() {
		try {
			FileChooser f = new FileChooser(new Frame(), "Abrir",
					FileChooser.MODE_OPEN);
			f.show();
			this.repaint();
			File file;
			file = f.getSelectedFile();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void mudaAba(Object tabbedpane, Object button) {
		String s = this.getProperty(button, "indice").toString();
		this.setInteger(tabbedpane, "selected", Integer.parseInt(s));
	}

	
	public void abrirTreinamento() {
		array = evtAbrirArquivo.abrirTreinamento();
		if (array != null) {
			setBoolean(btSalvarTr, "enabled", true);
			setBoolean(btConfigurarTr, "enabled", true);
			setBoolean(btVisualizarDadosTr, "enabled", true);
			setBoolean(btTreinar, "enabled", true);
			setBoolean(btDescarregarTr, "enabled", true);
		}
	}

	public void descarregarArquivo() {
		array = null;
		//final DataView dv = new visao.gui.telas.utils.DataView(new Frame(), "");
		//dv.clearTable();
		setBoolean(btDescarregarTr, "enabled", false);
		setBoolean(btSalvarTr, "enabled", false);
		setBoolean(btConfigurarTr, "enabled", false);
		setBoolean(btVisualizarDadosTr, "enabled", false);
		setBoolean(btMatrizConfusaoTr, "enabled", false);
		setBoolean(btTreinar, "enabled", false);
		setBoolean(btGrafico, "enabled", false);
		setBoolean(btSalvarRedeTr, "enabled", false);
		setBoolean(btCarregarRedeTr, "enabled", false);
		// pararTreinamento(button1);
		EvtLimparConjunto.limparConjuntoTreinamento();
	}

	public void limparDados(Object button) {
		array = null;
		String opcao = this.getProperty(button, "indice").toString();
		if ((opcao.equals("btDescarregarTs")) && (carregarTabelaTeste != null)) {
			carregarTabelaTeste.clearTable();
			EvtLimparConjunto.limparConjuntoTeste();
			setBoolean(chkVisualizarTs, "enabled", false);
			setBoolean(chkVisualizarTs, "selected", false);
			setBoolean(btDescarregarTs, "enabled", false);
			setBoolean(btSalvarTs, "enabled", false);
			setBoolean(btConfigurarTs, "enabled", false);
			this.setString(this.find("pagAtualTs"), "text", "");
			this.setString(this.find("pagMaxTs"), "text", "");
			setBoolean(antPagTs, "enabled", false);
			setBoolean(proxPagTs, "enabled", false);
			setBoolean(btTestarRede, "enabled", false);
			setBoolean(btMatrizConfusaoTs, "enabled", false);

		} else if ((opcao.equals("btDescarregarVl"))
				&& (carregarTabelaValidacao != null)) {
			carregarTabelaValidacao.clearTable();
			EvtLimparConjunto.limparConjuntoValidacao();
			setBoolean(chkVisualizarVl, "enabled", false);
			setBoolean(chkVisualizarVl, "selected", false);
			setBoolean(btDescarregarVl, "enabled", false);
			setBoolean(btSalvarVl, "enabled", false);
			setBoolean(btConfigurarVl, "enabled", false);
			this.setString(this.find("pagAtualVl"), "text", "");
			this.setString(this.find("pagMaxVl"), "text", "");
			setBoolean(antPagVl, "enabled", false);
			setBoolean(proxPagVl, "enabled", false);

		} else if ((opcao.equals("btDescarregarCl"))
				&& (carregarTabelaClassificacao != null)) {
			carregarTabelaClassificacao.clearTable();
			EvtLimparConjunto.limparConjuntoClassificacao();
			setBoolean(chkVisualizarCl, "enabled", false);
			setBoolean(chkVisualizarCl, "selected", false);
			setBoolean(btDescarregarCl, "enabled", false);
			setBoolean(btSalvarCl, "enabled", false);
			setBoolean(btCarregarRedeCl, "enabled", false);
			setBoolean(btResultadosCl, "enabled", false);
			setBoolean(btClassificar, "enabled", false);
			this.setString(this.find("pagAtualCl"), "text", "");
			this.setString(this.find("pagMaxCl"), "text", "");
			setBoolean(antPagCl, "enabled", false);
			setBoolean(proxPagCl, "enabled", false);

		}

		this.repaint();
	}

	public void abrirTeste() {
		array = evtAbrirArquivo.abrirTeste();
		if (array != null) {
			try {
				if (carregarTabelaTeste == null)
					carregarTabelaTeste = new CarregarTabela(this, tabelaTs,
							this.find("pagAtualTs"), this.find("pagMaxTs"));
				carregarTabelaTeste.carregaDados(array);
				this.repaint();
			} catch (Exception e) {
				e.printStackTrace();
			}
			setBoolean(chkVisualizarTs, "enabled", true);
			setBoolean(chkVisualizarTs, "selected", true);
			setBoolean(btDescarregarTs, "enabled", true);
			setBoolean(btSalvarTs, "enabled", true);
			setBoolean(btConfigurarTs, "enabled", true);
			setBoolean(antPagTs, "enabled", true);
			setBoolean(proxPagTs, "enabled", true);
			setBoolean(btTestarRede, "enabled", true);
			setBoolean(btMatrizConfusaoTs, "enabled", true);
			this.repaint();
		}
	}

	public void abrirValidacao(Object table) {
		array = evtAbrirArquivo.abrirValidacao();
		if (array != null) {
			try {
				if (carregarTabelaValidacao == null)
					carregarTabelaValidacao = new CarregarTabela(this, table,
							this.find("pagAtualVl"), this.find("pagMaxVl"));
				carregarTabelaValidacao.carregaDados(array);
				this.repaint();

			} catch (Exception e) {
				e.printStackTrace();
			}
			setBoolean(chkVisualizarVl, "enabled", true);
			setBoolean(chkVisualizarVl, "selected", true);
			setBoolean(btDescarregarVl, "enabled", true);
			setBoolean(btSalvarVl, "enabled", true);
			setBoolean(btConfigurarVl, "enabled", true);
			setBoolean(antPagVl, "enabled", true);
			setBoolean(proxPagVl, "enabled", true);

			this.repaint();

		}
	}

	public void abrirClassificacao(Object table) {
		array = evtAbrirArquivo.abrirClassificacao();
		if (array != null) {
			try {
				if (carregarTabelaClassificacao == null)
					carregarTabelaClassificacao = new CarregarTabela(this,
							table, this.find("pagAtualCl"), this
									.find("pagMaxCl"));
				carregarTabelaClassificacao.carregaDados(array);
				this.repaint();
			} catch (Exception e) {
				e.printStackTrace();
			}
			setBoolean(chkVisualizarCl, "enabled", true);
			setBoolean(chkVisualizarCl, "selected", true);
			setBoolean(btDescarregarCl, "enabled", true);
			setBoolean(btSalvarCl, "enabled", true);
			setBoolean(btResultadosCl, "enabled", true);
			setBoolean(btClassificar, "enabled", true);
			setBoolean(btCarregarRedeCl, "enabled", true);
			setBoolean(antPagCl, "enabled", true);
			setBoolean(proxPagCl, "enabled", true);

			this.repaint();
		}
	}


	public void confirmar() {

	}

	public void cancelar(Object dialog) throws IOException {
		remove(dialog);
	}

	public void sairSistema() {
		SaidaSistema saidaSistema = new SaidaSistema(new Frame(),
				"Fechar o Sistema");
		saidaSistema.show();
	}

	public void configurarRede() {
		ConfigRede configRede = new ConfigRede(frame,
				"Configura��es de Rede");
		configRede.show();
	}

	public void selecionarCaracteristica() {
		CaracteristicasUtilizadas caracteristicasUtilizadas = new CaracteristicasUtilizadas(
				new Frame(), "Sele��o de Caracter�sticas");
		caracteristicasUtilizadas.show();
	}

	public void reiniciarConfiguracao() {
		ReiniciarConfig reiniciarConfig = new ReiniciarConfig(new Frame(),
				"Reiniciar Configura��es");
		reiniciarConfig.show();
	}

	public void configurar(Object Button) {
		String Aba = this.getProperty(Button, "indice").toString();
		if (Aba.equals("configurarTr")) {
			ConfigTreinamento configTreinamento = new ConfigTreinamento(frame,
					"Configura��es de Treinamento", evtTreinamento);
			configTreinamento.show();

		}
		if (Aba.equals("configurarTs")) {
			ConfigTeste configTeste = new ConfigTeste(frame,
					"Configura��es de Teste");
			configTeste.show();

		}
		if (Aba.equals("configurarVl")) {
			ConfigValidacao configValidacao = new ConfigValidacao(frame,
					"Configura��es de Valida��o");
			configValidacao.show();

		}
	}

	public void exibirResultados() {
			ResultadosClassificacao resultadosClassificacao = new ResultadosClassificacao(
					new Frame(), "Resultados - Classificação");
			resultadosClassificacao.show();
		}

	public void chamarMatriz() {

		if (ContainerMatrizConfusao.getMatriz() != null) {
			int epoca = ContainerMatrizConfusao.getEpoca();
			int[][] matriz = ContainerMatrizConfusao.getMatriz();
			float harmonica = ContainerMatrizConfusao.getHarmonica();
			float aritmetica = ContainerMatrizConfusao.getAritmetica();
			float maxmin = ContainerMatrizConfusao.getMaxMin();
			MatrizConfusaoTela matrizConfusao = new MatrizConfusaoTela(frame,
					"Matriz de Confus�o", epoca,
					matriz,
					harmonica,
					aritmetica,
					maxmin, null);
			matrizConfusao.show();
		} else {

			MessageDialog msgdlg = new MessageDialog(frame, "Aten��o",
					"Para exibir a matriz de confus�o deve-se treinar a rede.");
			msgdlg.show();

		}

	}
	
	

	public void abrirMatrixConfusaoTeste() {
		evtTeste.chamarTelaMatrizConfusao();
	}
	
	public void abrirMatrixConfusaoValidacao() {
		evtValidacao.chamarTelaMatrizConfusao();
	}

	// habilitar e desabilitar campos com checkbox Treinamento
	public void habilitaCampo(Object checkbox, Object text1, Object label1) {
		boolean s = this.getBoolean(checkbox, "selected");
		if (s == true) {
			setBoolean(text1, "enabled", true);
			setBoolean(text1, "editable", true);
			setBoolean(label1, "enabled", true);
		} else {
			// setString(text1, "text", "");
			setBoolean(text1, "enabled", false);
			setBoolean(text1, "editable", false);
			setBoolean(label1, "enabled", false);
		}

	}

	// habilitar e desabilitar campos com combobox tempera treinamento
	public void habilitarTempera(Object combobox, Object label1, Object text1,
			Object label2, Object label3, Object text2, Object label4) {
		int i = this.getInteger(combobox, "selected");
		if (i == 0) {
			setBoolean(label1, "enabled", false);
			setBoolean(text1, "editable", false);
			setBoolean(text1, "enabled", false);
			setBoolean(label2, "enabled", false);
			setBoolean(label3, "enabled", false);
			setBoolean(text2, "editable", false);
			setBoolean(text2, "enabled", false);
			setBoolean(label4, "enabled", false);
		} else {
			setBoolean(label1, "enabled", true);
			setBoolean(text1, "editable", true);
			setBoolean(text1, "enabled", true);
			setBoolean(label2, "enabled", true);
			setBoolean(label3, "enabled", true);
			setBoolean(text2, "editable", true);
			setBoolean(text2, "enabled", true);
			setBoolean(label4, "enabled", true);
		}
	}

	private void iniciarTreinamento() {
		evtTreinamento.iniciarTreinamento();
	}

	private void pararTreinamento(Object button1) {
		// Ativa a combo de renormalização
		evtTreinamento.pararTreinamento();
		Object cmbNormalizador = find("cmbNormaUtil");

		setBoolean(cmbNormalizador, "enabled", true);
	}

	public void clickBotaoTreinarParar() {
	setBoolean(btMatrizConfusaoTr, "enabled", true);
		setBoolean(btGrafico, "enabled", true);
	    try {
			if(App.getGerenciadorPadroes().getConjuntoTesteRede().size()==0){
				MessageDialog ms = new MessageDialog(frame,"Erro de Treinamento","O Conjunto de Teste est� nulo. Adicione um conjunto de Teste antes de iniciar o treinamento"); 
				ms.show();
			}
			else{
			if (pararTreinamento) {
				setBoolean(btSalvarRedeTr, "enabled", true);
				setBoolean(btCarregarRedeTr, "enabled", true);
				setBoolean(btConfigurarTr, "enabled", true);
				setBoolean(btCarregarRedeTr, "enabled", true);
				try {
					if(App.getGerenciadorPadroes().getConjuntoTreinamentoRede().size()>0){
						setBoolean(btDescarregarTr, "enabled", true);
					}
					if(App.getGerenciadorPadroes().getConjuntoTesteRede().size()>0){
						setBoolean(btDescarregarTs, "enabled", true);
					}
					if(App.getGerenciadorPadroes().getConjuntoValidacaoRede().size()>0){
					setBoolean(btDescarregarVl, "enabled", true);
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
				
				this.pararTreinamento(btTreinar);
			} else {
				setBoolean(cmbNormaUtil, "enabled", false);
				setBoolean(btConfigNormalizacao, "enabled", false);
				setBoolean(btDescarregarTr, "enabled", false);
				setBoolean(btDescarregarTs, "enabled", false);
				setBoolean(btDescarregarVl, "enabled", false);
				setBoolean(btConfigurarTr, "enabled", false);
				setBoolean(btCarregarRedeTr, "enabled", false);
				this.iniciarTreinamento();
				this.pararTreinamento = true;
			}
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void configurarTelaPararTreinamento() {
		setBoolean(cmbNormaUtil, "enabled", true);
		setBoolean(btConfigNormalizacao, "enabled", true);
		this.pararTreinamento = false;
	}

	public void visualizarDadosTr(Object table, Object button) {
		String nomeDialogo = getProperty(button, "nomeDialogo").toString();
		final DataView dv = new visao.gui.telas.utils.DataView(new Frame(),
				nomeDialogo);
		try {
			final String[][] arrayDados = App.getGerenciadorPadroes()
					.getConjuntoTreinamento();

			Runnable rodar = new Runnable() {
				public void run() {
					dv.addRows(arrayDados);
				}
			};

			Thread thread = new Thread(rodar);
			thread.start();
			dv.show();
			this.repaint();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void visualizarGrafico() {
		GraphicChooser gc = new GraphicChooser(frame,
				"Escolha o Gr�fico");
		gc.show();
		this.repaint();
	}

	public void iniciarSobre() {
		SobreEasyFAN sef = new SobreEasyFAN(new Frame(), "EasyFAN");
		sef.show();
	}

	// ********************************************************************************************************

	public void open() {
		Frame f = new FrameLauncher("EasyFAN", this, 850, 600);
		f.setExtendedState(Frame.MAXIMIZED_BOTH);
		frame = f;
		File file = new File("./src/visao/gui/telas/icones/logo1.png");
		Image bf = Toolkit.getDefaultToolkit().createImage(
				file.getAbsolutePath());
		frame.setIconImage(bf);
	}

	public void proximaPaginaTeste() {
		this.carregarTabelaTeste.nextPage();
	}

	public void anteriorPaginaTeste() {
		this.carregarTabelaTeste.beforePage();
	}

	public void proximaPaginaValidacao() {
		this.carregarTabelaValidacao.nextPage();
	}

	public void anteriorPaginaValidacao() {
		this.carregarTabelaValidacao.beforePage();
	}

	public void proximaPaginaClassificacao() {
		this.carregarTabelaClassificacao.nextPage();
	}

	public void anteriorPaginaClassificacao() {
		this.carregarTabelaClassificacao.beforePage();
	}

	public void eventTrocaNormalizador(Object cmbNormalizador) {
		int i = this.getInteger(cmbNormalizador, "selected");
		switch (i) {
		case 0: // índice para Max Min
			evtTreinamento
					.trocarTipoNormalizacao(NormalizatorTypes.NormalizatorMaxMin);
			break;
		case 1: // índice para Max
			evtTreinamento
					.trocarTipoNormalizacao(NormalizatorTypes.NormalizatorMax);
			break;
		case 2: // índice para Max Média
			evtTreinamento
					.trocarTipoNormalizacao(NormalizatorTypes.NormalizatorMaxMean);
			break;
		// default:
		// TODO averiguar se existe um padrão
		// break;
		}
	}

	public void eventTrocaTempera(Object cmbTempera, Object label1,
			Object text1, Object label2, Object label3, Object text2,
			Object label4) {
		habilitarTempera(cmbTempera, label1, text1, label2, label3, text2,
				label4);
		int i = this.getInteger(cmbTempera, "selected");
		ITemperaSimulada tempera = null;
		switch (i) {
		// case 0: // índice para nenhuma
		// tempera = null;
		// evtTreinamento.trocarTempera(tempera);
		// break;
		case 1: // índice para aleatória
			tempera = new TemperaAleatoria();
			// evtTreinamento.trocarTempera(tempera);
			break;
		case 2: // índice para padrão
			tempera = new TemperaSimuladaFAN();
			// evtTreinamento.trocarTempera(tempera);
			break;
		// default:
		// TODO averiguar se existe um padrão
		// break;
		}
		evtTreinamento.trocarTempera(tempera);
		if (tempera != null) {
			// TODO carregar config das caixinhas de texto
		}
	}

	public void eventEmbaralharPadroes(Object checkbox, Object textField,
			Object label) {
		String s = getString(textField, "text");
		
		habilitaCampo(checkbox, textField, label);
		if (getBoolean(checkbox, "selected")) {
			int epocas = 0;
			try {
				if (s != null && !s.equals(""))
					epocas = Integer.parseInt(getString(textField, "text"));
				evtTreinamento.alterarCadaEpocaEmbaralharPadores(epocas);
			} catch (NumberFormatException e) {
				// MessageDialog message = new MessageDialog(this.frame, "Dado
				// em formato inadequado","O campo com o número de épocas da
				// opção Embaralhar Padrões deve conter somente
				// números");
				// message.show();
				StringBuilder sb = new StringBuilder(s);
				int j = 0;
				while (j < sb.length()) {
					try {
						int z = Integer.parseInt(Character.toString(sb
								.charAt(j)));
						j++;
					} catch (NumberFormatException ex) {
						sb.deleteCharAt(j);
					}
				}
				setString(textField, "text", sb.toString());
			}

		} else {
			evtTreinamento.desativarCadaEpocaEmbaralharPadores();
		}
	}

	public void eventRenormalizar(Object checkbox, Object textField,
			Object label) {
		String s = getString(textField, "text");
		;
		habilitaCampo(checkbox, textField, label);
		if (getBoolean(checkbox, "selected")) {
			int epocas = 0;
			try {
				if (s != null && !s.equals(""))
					epocas = Integer.parseInt(getString(textField, "text"));
				evtTreinamento.alterarCadaEpocaRenormalizar(epocas);
			} catch (NumberFormatException e) {
				// MessageDialog message = new MessageDialog(this.frame, "Dado
				// em formato inadequado","O campo com o número de épocas da
				// opção Embaralhar Padrões deve conter somente
				// números");
				// message.show();
				StringBuilder sb = new StringBuilder(s);
				int j = 0;
				while (j < sb.length()) {
					try {
						int z = Integer.parseInt(Character.toString(sb
								.charAt(j)));
						j++;
					} catch (NumberFormatException ex) {
						sb.deleteCharAt(j);
					}
				}

			}

		} else {
			evtTreinamento.desativarCadaEpocaRenormalizar();
		}
	}

	public void eventPesosAleatorios(Object checkbox, Object textField,
			Object label) {
		String s = getString(textField, "text");
		habilitaCampo(checkbox, textField, label);
		if (getBoolean(checkbox, "selected")) {
			int pesoBase = -1;
			try {
				if (s != null && !s.equals(""))
					pesoBase = Integer.parseInt(s);
				if (pesoBase > 1000) {
					s = s.substring(0, s.length() - 1);
					setString(textField, "text", s);
				} else {
					evtTreinamento.ativarPesosAleatorios(pesoBase);
				}
			} catch (NumberFormatException e) {
				// MessageDialog message = new MessageDialog(this.frame, "Dado
				// em formato inadequado","O campo com o n�mero de �pocas da
				// op��o Embaralhar Padr�es deve conter somente
				// n�meros");
				// message.show();
				StringBuilder sb = new StringBuilder(s);
				int j = 0;
				while (j < sb.length()) {
					try {
						int z = Integer.parseInt(Character.toString(sb
								.charAt(j)));
						j++;
					} catch (NumberFormatException ex) {
						sb.deleteCharAt(j);
					}
				}

				setString(textField, "text", sb.toString());
			}

		} else {
			evtTreinamento.desativarPesosAleatorios();
		}
	}

	public void eventPorcentagemPadroesTreino(Object checkbox,
			Object textField, Object label) {
		String s = getString(textField, "text");
		habilitaCampo(checkbox, textField, label);
		int porcentagem = 0;
		if (getBoolean(checkbox, "selected")) {
			if (s != null && !s.equals("")) {
				try {
					porcentagem = Integer.parseInt(s);
					if (porcentagem > 100 || porcentagem < 1) {
						s = s.substring(0, s.length() - 1);
						setString(textField, "text", s);
					} else {
						if (porcentagem == 100) {
							evtTreinamento.desativarPorcentagemPadroesTreino();
						} else {
							evtTreinamento
									.ativarPorcentagemPadroesTreino(porcentagem);
						}
					}
				} catch (NumberFormatException e) {
					// MessageDialog message = new MessageDialog(this.frame,
					// "Dado em formato inadequado","O campo com o n�mero de
					// �pocas da op��o Embaralhar Padr�es deve conter
					// somente n�meros");
					// message.show();
					StringBuilder sb = new StringBuilder(s);
					int j = 0;
					while (j < sb.length()) {
						try {
							int z = Integer.parseInt(Character.toString(sb
									.charAt(j)));
							j++;
						} catch (NumberFormatException ex) {
							sb.deleteCharAt(j);
						}
					}

					setString(textField, "text", sb.toString());
				}
			}
		} else {
			evtTreinamento.desativarPorcentagemPadroesTreino();
		}
	}

	public void eventChanceRenormalizar(Object checkbox, Object textField,
			Object label) {
		String s = getString(textField, "text");
		habilitaCampo(checkbox, textField, label);
		int porcentagem = 0;
		if (getBoolean(checkbox, "selected")) {
			if (s != null && !s.equals("")) {
				try {
					porcentagem = Integer.parseInt(s);
					if (porcentagem > 100) {
						s = s.substring(0, s.length() - 1);
						setString(textField, "text", s);
					} else {
						evtTreinamento.ativarChanceRenormalizar(porcentagem);
					}
				} catch (NumberFormatException e) {
					// MessageDialog message = new MessageDialog(this.frame,
					// "Dado em formato inadequado","O campo com o n�mero de
					// �pocas da op��o Embaralhar Padr�es deve conter
					// somente n�meros");
					// message.show();
					StringBuilder sb = new StringBuilder(s);
					int j = 0;
					while (j < sb.length()) {
						try {
							int z = Integer.parseInt(Character.toString(sb
									.charAt(j)));
							j++;
						} catch (NumberFormatException ex) {
							sb.deleteCharAt(j);
						}
					}

					setString(textField, "text", sb.toString());
				}
			}
		} else {
			evtTreinamento.desativarChanceRenormalizar();
		}
	}

	// abrir tela para configuração da normalização
	public void parametrosNormalizacao() {
		new visao.gui.telas.classes.ConfigNormalizacao(frame,
				"Configurar Normaliza��o");
		EvtNormalizacao.arrumarParametrosNormalizacao();
	}

	// abrir tela para configuração da tempera
	public void abrirConfTempera() {
		confTempera.ConfigTempera(App.getTelaEasyFAN().getFrame(),
				"Configurar T�mpera", this.evtTreinamento);
		confTempera.show();
	}

	// abrir modo wizard
	public void abrirWizard() {
		abrirWizard.AbrirWizard(App.getTelaEasyFAN().getFrame(),
				"EasyFAN - Modo Wizard");
		frame.setVisible(false);
		abrirWizard.show();
		frame.setVisible(true);
	}

	// configurar habilitação conjunto treinamento wizard
	public void configurarHabilitacaoConjuntoTreinamento() {
		setBoolean(btDescarregarTr,"enabled",true);
		setBoolean(btSalvarTr, "enabled", true);
		setBoolean(btConfigurarTr, "enabled", true);
		setBoolean(btVisualizarDadosTr, "enabled", true);
		setBoolean(btTreinar, "enabled", true);
	}

	public void configurarHabilitacaoConjuntoTeste() {
		try {
			if (App.getGerenciadorPadroes().getConjuntoTeste() != null) {
				try {
					if (carregarTabelaTeste == null)
						carregarTabelaTeste = new CarregarTabela(this,
								tabelaTs, this.find("pagAtualTs"), this
										.find("pagMaxTs"));
					carregarTabelaTeste.carregaDados(App
							.getGerenciadorPadroes().getConjuntoTeste());
					this.repaint();
				} catch (Exception e) {
					e.printStackTrace();
				}
				setBoolean(chkVisualizarTs, "enabled", true);
				setBoolean(chkVisualizarTs, "selected", true);
				setBoolean(btDescarregarTs, "enabled", true);
				setBoolean(btSalvarTs, "enabled", true);
				setBoolean(btConfigurarTs, "enabled", true);
				setBoolean(antPagTs, "enabled", true);
				setBoolean(proxPagTs, "enabled", true);
				// setBoolean(btConfigurarTs, "enabled", true);

				this.repaint();
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	//visualizar conjuntos de teste, classificaçao e validacao
	public void visualizarConjuntos(Object tipoConjunto){
		String s = this.getProperty(tipoConjunto, "indice").toString();
		Boolean b = getBoolean(tipoConjunto,"selected");
		if (s.equalsIgnoreCase("chkVisualizarTs")){
			if (b == false){
				carregarTabelaTeste.clearTable();
				this.setString(this.find("pagAtualTs"), "text", "");
				this.setString(this.find("pagMaxTs"), "text", "");
				setBoolean(antPagTs, "enabled", false);
				setBoolean(proxPagTs, "enabled", false);
			}else{
				try {
					carregarTabelaTeste = new CarregarTabela(this, tabelaTs,
					this.find("pagAtualTs"), this.find("pagMaxTs"));
					setBoolean(antPagTs, "enabled", true);
					setBoolean(proxPagTs, "enabled", true);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				if (array == null){
					array = abrirWizard.getArrayTeste();
					if (array == null){
						array = abrirWizard.getArrayTreino();
					}
				}
			   carregarTabelaTeste.carregaDados(array);
			}
		}else if (s.equalsIgnoreCase("chkVisualizarVl")){
			if (b == false){
				carregarTabelaValidacao.clearTable();
				this.setString(this.find("pagAtualVl"), "text", "");
				this.setString(this.find("pagMaxVl"), "text", "");
				setBoolean(antPagVl, "enabled", false);
				setBoolean(proxPagVl, "enabled", false);
			}else{
				try {
					carregarTabelaValidacao = new CarregarTabela(this, tabelaVl,
					this.find("pagAtualVl"), this.find("pagMaxVl"));
					setBoolean(antPagVl, "enabled", true);
					setBoolean(proxPagVl, "enabled", true);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			   carregarTabelaValidacao.carregaDados(array);
			}
		}else if (s.equalsIgnoreCase("chkVisualizarCl")){
			if (b == false){
				carregarTabelaClassificacao.clearTable();
				this.setString(this.find("pagAtualCl"), "text", "");
				this.setString(this.find("pagMaxCl"), "text", "");
				setBoolean(antPagCl, "enabled", false);
				setBoolean(proxPagCl, "enabled", false);
			}else{
				try {
					carregarTabelaClassificacao= new CarregarTabela(this, tabelaCl,
					this.find("pagAtualCl"), this.find("pagMaxCl"));
					setBoolean(antPagCl, "enabled", true);
					setBoolean(proxPagCl, "enabled", true);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			   carregarTabelaClassificacao.carregaDados(array);
			}
			
			
			
		}
		this.repaint();
	}
	
	// visualizar help
	public void criaHelp() {
		vHelp = new viewHelp(frame);// procura o arquivo EasyHelp.sh
		vHelp.visualizarHelp();
	}

	// Salvar Rede
	public void salvarRede() {
		salvarRede.salvarRede(frame, "Salvar Rede");
		salvarRede.show();
	}

	// carregar rede
	public void carregarRede() {
		carregarRede.carregarRede(App.getTelaEasyFAN().getFrame(),
				"Carregar Rede");
	}

	public void eventTrocarEpocaStepTempera(Object txtStepTempera) {
		String s = getString(txtStepTempera, "text");
		if (s != null && !s.equals("")) {
			int step;
			try {
				step = Integer.parseInt(s);
				/*
				 * char ultimo = s.charAt(s.length()-1); if (ultimo == 'd' ||
				 * ultimo == 'f') { s = s.substring(0, s.length()-1);
				 * setString(txtStepTempera,"text", s); return; }
				 */
				evtTreinamento.trocarEpocaStepTempera(step);
			} catch (NumberFormatException e) {
				// MessageDialog message = new MessageDialog(this.frame, "Dado
				// em formato inadequado","O campo com o n�mero de �pocas da
				// op��o Embaralhar Padr�es deve conter somente
				// n�meros");
				// message.show();
				StringBuilder sb = new StringBuilder(s);
				int j = 0;
				while (j < sb.length()) {
					try {
						int z = Integer.parseInt(Character.toString(sb
								.charAt(j)));
						j++;
					} catch (NumberFormatException ex) {
						sb.deleteCharAt(j);
					}
				}
				setString(txtStepTempera, "text", sb.toString());
			}
		}
	}

	public void eventTrocarReinicializarTempera(Object txtReiniciarEpoca) {
		String s = getString(txtReiniciarEpoca, "text");
		if (s != null && !s.equals("")) {
			try {
				int i = Integer.parseInt(s);
				evtTreinamento.trocarEpocaReiniciarTempera(i);
			} catch (NumberFormatException e) {
				StringBuilder sb = new StringBuilder(s);
				int j = 0;
				while (j < sb.length()) {
					try {
						int z = Integer.parseInt(Character.toString(sb
								.charAt(j)));
						j++;
					} catch (NumberFormatException ex) {
						sb.deleteCharAt(j);
					}
				}

				setString(txtReiniciarEpoca, "text", sb.toString());
			}
		}
	}

	public void testarRede() {
		TesteRede testeRede = new TesteRede(frame, "Testar Rede");
		testeRede.show();
	}
	
	public void validarRede() {
		ValidaRede validaRede = new ValidaRede(frame, "Testar Rede");
		validaRede.show();
	}
	
	public void salvarConjuntoTreinamento(){
		EvtSalvarArquivo.salvarConjuntoTreinamento();
	}

	public void salvarConjuntoTeste() {
		EvtSalvarArquivo.salvarConjuntoTeste();
	}
	
	public void salvarConjuntoValidacao(){
		EvtSalvarArquivo.salvarConjuntoValidacao();
	}
	
	public void salvarConjuntoClassificacao(){
		EvtSalvarArquivo.salvarConjuntoClassificacao();
	}
	
	public EvtTeste getEvtTeste() {
		return evtTeste;
	}

	public EvtAbrirArquivo getEvtAbrirArquivo() {
		return evtAbrirArquivo;
	}

	public void setCertosTeste(int i) {
		try {
			this.setString(lblAcertosTs, "text", Integer.toString(i));
		} catch (NumberFormatException e) {
			this.setString(lblAcertosTs, "text", "");
		}

	}

	public void setErrosTeste(int i) {
		try {
			this.setString(lblErrosTs, "text", Integer.toString(i));
		} catch (NumberFormatException e) {
			this.setString(lblErrosTs, "text", "");
		}
	}
	
	public void nomearCaracteristicas(){
		NomeadorCaracteristica nc = new NomeadorCaracteristica(new Frame(),"Nomeie as caracter�sticas");
		nc.show();     
	}
	
	public void setHarmonicaValidacao(String s) {
		setString(lblHarmonicaVl, "text", s);
	}
	
	public void setMaxMinValidacao(String s) {
		setString(lblMaxMinVl, "text", s);
	}
	
	public void setAritmeticaValidacao(String s) {
		setString(lblAritmeticaVl, "text", s);
	}
	
	public void setAcertosValidacao(String s) {
		setString(lblAcertosVl, "text", s);
	}
	
	public void setErrosValidacao(String s) {
		setString(lblErrosVl, "text", s);
	}
	
	public void setEpocaValidada(String s) {
		setString(lblEpocaValidada, "text", s);
	}
	
	public void setTipoRedeValidacao(String s) {
		setString(lblTipoRedeValidacao, "text", s);
	}
	
	public EvtValidacao getEvtValidacao() {
		return evtValidacao;
	}
	
	public EvtClassificacao getEvtClassificacao() {
		return evtClassificacao;
	}
	
	public void atualizarTabelaClassificacao() {
		this.carregarTabelaClassificacao.draw();
	}
	
	public void classificar() {
		ClassificaRede cr = new ClassificaRede(frame,"Escolhe a rede que ser� usada");
		cr.show();
		cr = null;
	}
	
	public void configurarPesos() {
		 if(App.getMonitorFAN() == null) {
			MessageDialog md = new MessageDialog(frame,"Atenção","Não existem dados para configurar os pesos.");
			md.show();
			return;
		 }
		ConfigPesos cp = new ConfigPesos(frame,"Configurar o peso de cada classe");
		cp.show();
		cp = null;
	}
	
	public void salvarConfiguracoesDefault(){
		App.getProjetoConfig().saveAsDefaultConfiguration();
	}
}
