package visao.gui.telas.classes;

import java.awt.Color;
import java.awt.Dialog;
import java.awt.Frame;
import java.io.IOException;
import java.text.NumberFormat;
import java.util.Arrays;
import java.util.HashMap;

import jfan.fan.utilitarias.RecalculadorClasses;
import jfan.io.arquivos.GerenciadorPadroes;
import thinlet.Thinlet;
import thinletcommons.AntiAliasedThinlet;
import thinletcommons.MessageDialog;
import thinletcommons.ThinletDialog;

import controle.eventos.EvtTreinamento;
import controle.main.App;

public class MatrizConfusaoTela extends AntiAliasedThinlet{

	private Thinlet thinlet;
	private ThinletDialog dialog;

	/**
	 * Campos do thinlet.
	 */
	private Object pnlMatrizConfusao, lblAritmetica, lblHarmonica, lblMaxMin, rdgOpcao, rdQuantidade, rdPorcentagem,lblEpocaTitulo , lblEpoca;
	
	private int epoca;
	private float harmonica,aritmetica,maxmin;
	private int[][] matrizConfusao;
	private double[][] matrizConfusaoPorcentagem = null;
	private String[] classesReais;
	private NumberFormat numformat = NumberFormat.getInstance();
	private String tipoRede;
	
	//private HashMap<Integer,Integer> mapaIndicesInteirosMapeados = RecalculadorClasses.getClassesMapIndexReal();
	private HashMap<Integer,Integer> mapaMapeadosIndices = RecalculadorClasses.getClassesMapRealIndex();
	//private HashMap<Integer,String> mapaInteirosMapeadosReais = App.getGerenciadorPadroes().getMapaClasses();
	private HashMap<String,Integer> mapaReaisMapeados = App.getGerenciadorPadroes().getMapaClassesReaisMapeadas();
	

   public MatrizConfusaoTela(Frame ower, String title, int epoca, int[][] matrizConfusao, float harmonica,float aritmetica,float maxmin, String tipoRede) {
		this.dialog = new ThinletDialog(ower,title,true);
		this.epoca = epoca;
		this.matrizConfusao = matrizConfusao;
		this.harmonica = harmonica;
		this.aritmetica = aritmetica;
		this.maxmin = maxmin;
		this.tipoRede = tipoRede;
		this.init();
		if (epoca < 1) {
			thinlet.remove(lblEpocaTitulo);
			thinlet.remove(lblEpoca);
		}	
	}
   
   public void initParameters(Object pnlMatrizConfusao,Object lblAritmetica,Object lblHarmonica,Object lblMaxMin,Object rdgOpcao,Object rdQuantidade,Object rdPorcentagem, Object lblEpoca, Object lblEpocaTitulo) {
	   this.pnlMatrizConfusao = pnlMatrizConfusao;
	   this.lblAritmetica = lblAritmetica;
	   this.lblHarmonica = lblHarmonica; 
	   this.lblMaxMin = lblMaxMin;
	   this.rdgOpcao = rdgOpcao;
	   this.rdQuantidade = rdQuantidade;
	   this.rdPorcentagem = rdPorcentagem;
	   this.lblEpoca = lblEpoca;
	   this.lblEpocaTitulo = lblEpocaTitulo; 
   }
   
   private void init() {
	   if (tipoRede != null && tipoRede.equals("validacao")) {
		   classesReais = App.getGerenciadorPadroes().getClassesConjuntoValidacaoReais();  
	   }
	   else {
		   classesReais = App.getGerenciadorPadroes().getClassesConjuntoTesteReais();
	   }
	   
	   
	    numformat.setMinimumFractionDigits(4);
		numformat.setMaximumFractionDigits(4);
	   	this.thinlet = new AntiAliasedThinlet();
		Object panel = null;
		try {
			panel = thinlet.parse("/visao/gui/telas/MatrizConfusao.xml", this);
		} catch (IOException e) {
			new MessageDialog(dialog, "Erro ao abrir a janela", "Erro ao tentar abrir a Configura��o de T�mpera").show();
			e.printStackTrace();
			
		}
       thinlet.add(panel);
       dialog.setContent(thinlet);
       dialog.setModal(true);
       //Seta a label da epoca
       thinlet.setString(lblEpoca, "text", Integer.toString(epoca));
       thinlet.setString(lblHarmonica, "text", Double.toString(harmonica));
       thinlet.setString(lblAritmetica, "text", Double.toString(aritmetica));
       thinlet.setString(lblMaxMin, "text", Double.toString(maxmin));
       //Cria a matriz no painel
       criarMatriz();
       
	}
	
	public void criarMatriz() {
		thinlet.removeAll(pnlMatrizConfusao); //Remove tudo do painel
		Arrays.sort(classesReais); //Ordena o array
		//criar as labels de título
		Object[] label = new Object[matrizConfusao.length];
		Object[] label2 = new Object[matrizConfusao.length];
		int fim = label.length;
		for (int i = 0; i < fim;i++) {
			label[i] = thinlet.create("label");
			label2[i] = thinlet.create("label");
			thinlet.setString(label[i],"text",classesReais[i]);
			thinlet.setString(label2[i],"text",classesReais[i]);
		}
		Object blankLabel = thinlet.create("label");
				
		//Seta o número de colunas do painel
		int colunas = (fim*2)+3;
		Object sep1 = thinlet.create("separator");
		thinlet.setInteger(sep1, "colspan", colunas);
		thinlet.add(pnlMatrizConfusao, sep1);
		thinlet.setInteger(pnlMatrizConfusao,"columns",colunas);
		//Adiciona a primeira linha ao painel
		thinlet.add(pnlMatrizConfusao, thinlet.create("separator"));
		thinlet.add(pnlMatrizConfusao, blankLabel);
		thinlet.add(pnlMatrizConfusao, thinlet.create("separator"));
		for (Object o : label) {
			thinlet.add(pnlMatrizConfusao, o);
			thinlet.add(pnlMatrizConfusao, thinlet.create("separator"));
		}
		Object sep = thinlet.create("separator");
		thinlet.setInteger(sep, "colspan", colunas);
		thinlet.add(pnlMatrizConfusao, sep);
		
		//Adiciona as outras linhas com seus cabeçalhos e dados
		int mapeado,indexado, mapeadoSub, indexadoSub;
		Object lblData, sepLine;
		for (int i = 0; i < fim; i++) {
			thinlet.add(pnlMatrizConfusao, thinlet.create("separator"));
			thinlet.add(pnlMatrizConfusao, label2[i]); //cabeçalho
			if (mapaReaisMapeados.size() > 0) {
				mapeado = mapaReaisMapeados.get(classesReais[i]);
				indexado = mapaMapeadosIndices.get(mapeado);
			}
			else {
				indexado = mapaMapeadosIndices.get((int)Double.parseDouble(classesReais[i]));
			}
			for (int j = 0; j < fim;j++) {
				if (mapaReaisMapeados.size() > 0) {
					mapeadoSub = mapaReaisMapeados.get(classesReais[j]);
					indexadoSub = mapaMapeadosIndices.get(mapeadoSub);
				}
				else {
					indexadoSub = mapaMapeadosIndices.get((int)Double.parseDouble(classesReais[j]));
				}
				 thinlet.add(pnlMatrizConfusao, thinlet.create("separator"));
				 lblData = thinlet.create("label");
				 thinlet.setColor(lblData, "background", Color.WHITE);
				 thinlet.setChoice(lblData, "alignment", "center");
				 thinlet.setString(lblData, "text", Integer.toString(matrizConfusao[indexado][indexadoSub]));
				 thinlet.add(pnlMatrizConfusao, lblData);
			}
			thinlet.add(pnlMatrizConfusao, thinlet.create("separator"));
			sepLine = thinlet.create("separator");
			thinlet.setInteger(sepLine, "colspan", colunas);
			thinlet.add(pnlMatrizConfusao, sepLine);
		}
		
	}

	public void show() {
		dialog.pack();
		//dialog.setSize(210,222);
		dialog.setAlwaysOnTop(false);
        dialog.setLocationRelativeTo(dialog.getOwner());
        dialog.setVisible(true);
	}  
	
	public void cancelar() {
		dialog.setVisible(false);
		dialog.dispose();
	}
	
	public void criarMatrizPorcentagem() {
		thinlet.removeAll(pnlMatrizConfusao); //Remove tudo do painel
		//Cria a matriz de porcentagem
		int[] divisor = new int[matrizConfusao.length];
		for (int i = 0; i < divisor.length; i++) {
			divisor[i] = 0;
			for (int j = 0; j < matrizConfusao[i].length; j++) {
				divisor[i] += matrizConfusao[i][j];
			}
		}
			
		if (matrizConfusaoPorcentagem == null) {
			matrizConfusaoPorcentagem = new double[matrizConfusao.length][matrizConfusao[0].length];
			for (int i = 0; i < matrizConfusao.length; i++)
				for (int j = 0; j < matrizConfusao[i].length; j++)
					matrizConfusaoPorcentagem[i][j] = (((double)matrizConfusao[i][j])/divisor[i]) * 100.0;
		}
		Arrays.sort(classesReais); //Ordena o array
		//criar as labels de título
		Object[] label = new Object[matrizConfusao.length];
		Object[] label2 = new Object[matrizConfusao.length];
		int fim = label.length;
		for (int i = 0; i < fim;i++) {
			label[i] = thinlet.create("label");
			label2[i] = thinlet.create("label");
			thinlet.setString(label[i],"text",classesReais[i]);
			thinlet.setString(label2[i],"text",classesReais[i]);
		}
		Object blankLabel = thinlet.create("label");
				
		//Seta o número de colunas do painel
		int colunas = (fim*2)+3;
		Object sep1 = thinlet.create("separator");
		thinlet.setInteger(sep1, "colspan", colunas);
		thinlet.add(pnlMatrizConfusao, sep1);
		thinlet.setInteger(pnlMatrizConfusao,"columns",colunas);
		//Adiciona a primeira linha ao painel
		thinlet.add(pnlMatrizConfusao, thinlet.create("separator"));
		thinlet.add(pnlMatrizConfusao, blankLabel);
		thinlet.add(pnlMatrizConfusao, thinlet.create("separator"));
		for (Object o : label) {
			thinlet.add(pnlMatrizConfusao, o);
			thinlet.add(pnlMatrizConfusao, thinlet.create("separator"));
		}
		Object sep = thinlet.create("separator");
		thinlet.setInteger(sep, "colspan", colunas);
		thinlet.add(pnlMatrizConfusao, sep);
		
		//Adiciona as outras linhas com seus cabeçalhos e dados
		int mapeado,indexado, mapeadoSub, indexadoSub;
		Object lblData, sepLine;
		for (int i = 0; i < fim; i++) {
			thinlet.add(pnlMatrizConfusao, thinlet.create("separator"));
			thinlet.add(pnlMatrizConfusao, label2[i]); //cabeçalho
			if (mapaReaisMapeados.size() > 0) {
				mapeado = mapaReaisMapeados.get(classesReais[i]);
				indexado = mapaMapeadosIndices.get(mapeado);
			}
			else {
				indexado = mapaMapeadosIndices.get((int)Double.parseDouble(classesReais[i]));
			}
			for (int j = 0; j < fim;j++) {
				if (mapaReaisMapeados.size() > 0) {
					mapeadoSub = mapaReaisMapeados.get(classesReais[j]);
					indexadoSub = mapaMapeadosIndices.get(mapeadoSub);
				}
				else {
					indexadoSub = mapaMapeadosIndices.get((int)Double.parseDouble(classesReais[j]));
				}
				 thinlet.add(pnlMatrizConfusao, thinlet.create("separator"));
				 lblData = thinlet.create("label");
				 thinlet.setColor(lblData, "background", Color.WHITE);
				 thinlet.setChoice(lblData, "alignment", "center");
				 thinlet.setString(lblData, "text", numformat.format(matrizConfusaoPorcentagem[indexado][indexadoSub])+"%");
				 thinlet.add(pnlMatrizConfusao, lblData);
			}
			thinlet.add(pnlMatrizConfusao, thinlet.create("separator"));
			sepLine = thinlet.create("separator");
			thinlet.setInteger(sepLine, "colspan", colunas);
			thinlet.add(pnlMatrizConfusao, sepLine);
		}
	}
	
	public static void main(String[] args) {
		MatrizConfusaoTela mc = new MatrizConfusaoTela(new Frame(),
				"Matriz de Confus�o", 0, null,0,0,0,  null);
		mc.show();
		while (mc.dialog.isShowing()) {
		}
		mc.dialog.dispose();

		System.exit(0);

	}
}

