package visao.gui.telas.classes;

import java.awt.Dialog;
import java.awt.Frame;
import java.io.IOException;
import java.util.ArrayList;
import controle.eventos.EvtTeste;
import controle.main.App;
import jfan.fan.NeuronioFAN;
import jfan.fan.StoredNetworkType;
import jfan.fan.normalizadores.INormalizator;
import jfan.fan.normalizadores.NormalizatorConfiguration;
import jfan.fan.normalizadores.NormalizatorMax;
import jfan.fan.normalizadores.NormalizatorMaxMean;
import jfan.fan.normalizadores.NormalizatorMaxMin;
import jfan.fan.normalizadores.NormalizatorTypes;
import jfan.fan.padroes.IPadrao;
import jfan.fan.utilitarias.CalcularCaracteristicasFANBatch;
import jfan.fan.utilitarias.RecalculadorClasses;
import jfan.io.arquivos.CarregaNeuronioXML;
import thinlet.Thinlet;
import thinletcommons.AntiAliasedThinlet;
import thinletcommons.ThinletDialog;

	public class TesteRede {

		private Thinlet thinlet;

		private ThinletDialog dialog;
		
		private StoredNetworkType tipoRede = StoredNetworkType.BestHarmonicMean;
		
		private boolean carregar = false;
		
		private EvtTeste evtTeste = App.getTelaEasyFAN().getEvtTeste();

		public TesteRede(Dialog owner) {
			this.dialog = new ThinletDialog(owner, false);
			this.init();
		}

		public TesteRede(Dialog owner, String title) {
			this.dialog = new ThinletDialog(owner, title, false);
			this.init();
		}

		public TesteRede(Frame owner) {
			this.dialog = new ThinletDialog(owner, false);
			this.init();
		}

		public TesteRede(Frame owner, String title) {
			this.dialog = new ThinletDialog(owner, title, false);
			this.init();
		}

		private void init() {
			this.thinlet = new AntiAliasedThinlet();
			Object panel = null;
			try {
				panel = thinlet.parse(
						"/visao/gui/telas/TesteRede.xml", this);
			} catch (IOException e) {
				// TODO Criar mensagem de erro na constura��o
				e.printStackTrace();

			}
			thinlet.add(panel);
			dialog.setContent(thinlet);
		}

		public void show() {
			dialog.pack();
			//dialog.setSize(210, 175);
			//dialog.setAlwaysOnTop(true);
			dialog.setModal(true);
			dialog.setLocationRelativeTo(dialog.getOwner());
			dialog.setVisible(true);
		}
		
		private void allToFalse(boolean[] arr) {
			for (int i = 0; i < arr.length; i++) arr[i] = false;
		}

		public void confirmar() {
			if (carregar) {
				try {
					CarregaNeuronioXML carregada =  App.getTelaEasyFAN().getEvtAbrirArquivo().abrirRedeCarregaXML();
					//App.getProjetoConfig().getRedeConf().setMaximos(carregada.getMaximos());
					//App.getProjetoConfig().getRedeConf().setMinimos(carregada.getMinimos());
					//App.getProjetoConfig().getRedeConf().setMedias(carregada.getMedias());
					NormalizatorConfiguration config = new NormalizatorConfiguration();
					config.setMaximos(carregada.getMaximos());
					config.setMinimos(carregada.getMinimos());
					config.setMedias(carregada.getMedias());
					NormalizatorTypes tipoNorma = carregada.getTipoNormalizacao();
					
					ArrayList<NeuronioFAN> neurons =  carregada.getNeuroniosFAN();
					
					int fim = neurons.size();
					int[] classes = new int[fim];
					for(int i = 0; i < fim; i++) {
						classes[i] = neurons.get(i).getClasseAssociada();
					}
					RecalculadorClasses.indexarNeuronios(classes, neurons);
					//RecalculadorClasses.indexarClasses(classes, App.getGerenciadorPadroes().getConjuntoTesteRede());
					ArrayList<IPadrao> conjunto = App.getGerenciadorPadroes().getConjuntoTesteRede();
					ArrayList<IPadrao> conjuntoClonado = new ArrayList<IPadrao>(conjunto.size()); 
					for(IPadrao p : conjunto) {
						conjuntoClonado.add(p.clone());
					}
					
					normalizarConjunto(config, conjuntoClonado, tipoNorma);
					evtTeste.testarRede(neurons,conjuntoClonado);
				}
				catch (Exception e) {
					e.printStackTrace();
				}
			}
			else {
				evtTeste.testarRede(tipoRede);
			}
			dialog.setVisible(false);
		}

		public void cancelar() {
			dialog.setVisible(false);
		}
		
		public void radioHarmonica() {
			this.carregar = false;
			this.tipoRede = StoredNetworkType.BestHarmonicMean;
		}
		
		public void radioAritmetica() {
			this.carregar = false;
			this.tipoRede = StoredNetworkType.BestAritmethicMean;
		}
		
		public void radioMaxMin() {
			this.carregar = false;
			this.tipoRede = StoredNetworkType.BestMaxMin;
		}
		
		public void radioAtual() {
			this.carregar = false;
			this.tipoRede = StoredNetworkType.Actual;
		}
		
		public void radioCarregada() {
			this.carregar = true;
		}
		
		public void normalizarConjunto(NormalizatorConfiguration config,ArrayList<IPadrao> conjunto, NormalizatorTypes tipo) {
			INormalizator norm = null;
			if (tipo == NormalizatorTypes.NormalizatorMaxMin) {
				norm = new NormalizatorMaxMin(config);
			}
			else if (tipo == NormalizatorTypes.NormalizatorMaxMean) {
				norm = new NormalizatorMaxMean(config);
			}
			else if (tipo == NormalizatorTypes.NormalizatorArcSinMaxMin) {
				//TODO ArcSinMaxMin
			}
			else{
				norm = new NormalizatorMax(config);
			}
			
			norm.normalizarThreaded(conjunto);
						
			CalcularCaracteristicasFANBatch calc = new CalcularCaracteristicasFANBatch(App.getProjetoConfig().getRedeConf().getRaioDifuso(), App.getProjetoConfig().getRedeConf().getSuporteConjuntosDifusos());
			calc.calcularCaracteristicasFAN(conjunto);
		}

	}

