package visao.gui.telas.graficos.classes;

import java.awt.Dialog;
import java.awt.Frame;
import java.awt.Image;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import jfan.fan.padroes.IPadrao;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.category.CategoryDataset;
import org.jfree.data.category.DefaultCategoryDataset;
import thinlet.Thinlet;
import thinletcommons.AntiAliasedThinlet;
import thinletcommons.MessageDialog;
import thinletcommons.ThinletDialog;
import visao.gui.telas.classes.ConjuntoNulo;
import controle.main.App;

public class FeatureGraphic {

	private Thinlet thinlet;

	private ThinletDialog dialog;

	private Object lblGrafico;

	private JFreeChart freeChart;

	private CategoryDataset dataset = new DefaultCategoryDataset();

	private ArrayList<IPadrao> array;

	private double[][] arrayGrafico;

	private String[] caracteristica = null;

	private String serieCaracteristica = "Caracterstica";

	private Object cmbConjunto;

	private Object cmbCaracteristica;

	private int tamanhoArray;

	private int lastCaracteristica = -10;

	private int lastConjunto = -10;

	public FeatureGraphic(Dialog owner) {
		this.dialog = new ThinletDialog(owner, false);
		this.init();
	}

	public FeatureGraphic(Dialog owner, String title) {
		this.dialog = new ThinletDialog(owner, title, false);
		this.init();
	}

	public FeatureGraphic(Frame owner) {
		this.dialog = new ThinletDialog(owner, false);
		this.init();
	}

	public FeatureGraphic(Frame owner, String title) {
		this.dialog = new ThinletDialog(owner, title, false);
		this.init();
	}

	private void init() {
		this.thinlet = new AntiAliasedThinlet();
		Object panel = null;

		try {
			panel = thinlet.parse(
					"/visao/gui/telas/graficos/FeatureGraphic.xml", this);
		} catch (IOException e1) {
			e1.printStackTrace();
		}

		thinlet.add(panel);
		dialog.setContent(thinlet);
		createChart();
		int fim = 0;
		try {
			fim = App.getGerenciadorPadroes().getConjuntoTreinamentoRede().get(
					0).getQuantasCaracteristicas();
		} catch (Exception e) {
			e.printStackTrace();
		}
		Object choice;
		for (int i = 0; i < fim; i++) {
			choice = thinlet.create("choice");
			thinlet.setString(choice, "text", Integer.toString(i + 1));
			thinlet.add(cmbCaracteristica, choice, i);
		}
		//choice = thinlet.create("choice");
		//thinlet.setString(choice, "text", "Todas");
		//thinlet.add(cmbCaracteristica, choice, fim);
		thinlet.setInteger(cmbCaracteristica, "selected", 0);

		updateConjunto();
		dialog.addComponentListener(new ComponentAdapter() {
			public void componentResized(ComponentEvent e) {
				createImage();
			}
		});
	}

	private void createImage() {
		int height = dialog.getHeight() - 60;
		if (height <= 0)
			height = 1;
		thinlet.setIcon(lblGrafico, "icon", (Image) freeChart
				.createBufferedImage(thinlet.getWidth() - 10, height));
	}

	public void show() {
		dialog.pack();
		dialog.setSize(1010, 500);
		dialog.setAlwaysOnTop(true);
		dialog.setLocationRelativeTo(dialog.getOwner());
		dialog.setVisible(true);
		createImage();
	}

	public void initParameters(Object labelImagem, Object cmbConjunto,
			Object cmbCaracteristica) {
		this.cmbConjunto = cmbConjunto;
		this.cmbCaracteristica = cmbCaracteristica;
		this.lblGrafico = labelImagem;
	}

	public void updateConjunto() {
		int itemIndice = thinlet.getSelectedIndex(cmbConjunto);
		if (itemIndice == lastConjunto)
			return;

		if (itemIndice == 0) {

			try {
				if (App.getGerenciadorPadroes().getConjuntoTreinamentoRede()
						.size() == 0) {
					ConjuntoNulo conjuntoNulo = new ConjuntoNulo(new Frame(),
							"Conjunto de Treinamento Vazio");
					conjuntoNulo.show();
					thinlet.setBoolean(cmbCaracteristica, "enabled", false);
					thinlet.repaint();
				} else {
					thinlet.setBoolean(cmbCaracteristica, "enabled", true);
					thinlet.repaint();
					try {
						array = App.getGerenciadorPadroes()
								.getConjuntoTreinamentoRede();
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		if (itemIndice == 1) {
			try {
				if (App.getGerenciadorPadroes().getConjuntoTesteRede().size() == 0) {
					ConjuntoNulo conjuntoNulo = new ConjuntoNulo(new Frame(),
							"Conjunto de Teste Vazio");
					conjuntoNulo.show();
					thinlet.setBoolean(cmbCaracteristica, "enabled", false);
					thinlet.repaint();
				} else {
					thinlet.setBoolean(cmbCaracteristica, "enabled", true);
					thinlet.repaint();
					try {
						array = App.getGerenciadorPadroes()
								.getConjuntoTesteRede();
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		if (itemIndice == 2) {
			try {
				if (App.getGerenciadorPadroes().getConjuntoValidacaoRede()
						.size() == 0) {
					ConjuntoNulo conjuntoNulo = new ConjuntoNulo(new Frame(),
							"Conjunto de Validao Vazio");
					conjuntoNulo.show();
					thinlet.setBoolean(cmbCaracteristica, "enabled", false);
					thinlet.repaint();
				} else {
					thinlet.setBoolean(cmbCaracteristica, "enabled", true);
					thinlet.repaint();
					try {
						array = App.getGerenciadorPadroes()
								.getConjuntoValidacaoRede();
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		if (itemIndice == 3) {
			try {
				if (App.getGerenciadorPadroes().getConjuntoClassificacaoRede()
						.size() == 0) {
					ConjuntoNulo conjuntoNulo = new ConjuntoNulo(new Frame(),
							"Conjunto de Classificao Vazio");
					conjuntoNulo.show();
					thinlet.setBoolean(cmbCaracteristica, "enabled", false);
					thinlet.repaint();
				} else {
					thinlet.setBoolean(cmbCaracteristica, "enabled", true);
					thinlet.repaint();
					try {
						array = App.getGerenciadorPadroes()
								.getConjuntoClassificacaoRede();
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		updateCaracteristica();
		lastConjunto = itemIndice;
	}

	public void updateCaracteristica() {
		((DefaultCategoryDataset) dataset).clear();
		App.requisitarNormalizacao();
		Object item = thinlet.getSelectedItem(cmbCaracteristica);
		int caracSize = array.get(0).getQuantasCaracteristicas();
		double[][] arrayOrdenado = new double[array.get(0).getQuantasCaracteristicas()][array.size()];
		double[][] arrayTodas = new double[array.get(0).getQuantasCaracteristicas()][array.size()];
		int arraySize = array.size();
		caracteristica = new String[caracSize];
		for (int i = 0; i < caracSize; i++) {
			for (int ii = 0; ii < arraySize; ii++) {
				arrayOrdenado[i][ii] = array.get(ii)
						.getCaracteristicaNormalizada(i + 1);
				arrayTodas[i][ii] = array.get(ii).getCaracteristicaNormalizada(i + 1);
			}
		}

		for (int i = 0; i < arrayOrdenado.length; i++) {
			Arrays.sort(arrayOrdenado[i]);
		}
		if (arraySize > 50) {

			tamanhoArray = arraySize / 50;
			if (!(arraySize % 50 == 0)) {
				arrayGrafico = new double[caracSize][51];
			} else {
				arrayGrafico = new double[caracSize][50];
			}
			int cont = 0;
			int indiceArray = 0;
			double valor = 0.0;
			for (int j = 0; j < caracSize; j++) {
				for (int jj = 0; jj < arrayOrdenado[0].length; jj++) {
					valor = valor + arrayOrdenado[j][jj];
					cont = cont + 1;
					if (cont % tamanhoArray == 0) {
						arrayGrafico[j][indiceArray] = valor / cont;
						valor = 0;
						cont = 0;
						indiceArray = indiceArray + 1;
						if (indiceArray == 50) {
							indiceArray = 0;
						}
					}

				}
				if (!(valor == 0)) {
					arrayGrafico[j][50] = valor / cont;
				}
				valor = 0;
				cont = 0;
			}
		} else {
			arrayGrafico = new double[caracSize][array.size()];
			for (int i = 0; i < caracSize; i++) {
				for (int ii = 0; ii < arrayOrdenado[0].length; ii++) {
					arrayGrafico[i][ii] = arrayOrdenado[i][ii];
				}
			}

		}
		// *******Criao do Dataset*************
		if (item != null) {
			int itemIndice = thinlet.getSelectedIndex(cmbCaracteristica);
			String itemTexto = thinlet.getString(item, "text");
			if (itemIndice == lastCaracteristica)
				return;
			((DefaultCategoryDataset) dataset).clear();
			if (itemTexto.equals("Todas")) {
				if (arraySize > 50) {
					
					/*
					double valor1 = 0.0;
					int cont1 = 0;
					int indiceArray1 = 0;

					for (int j = 0; j < arrayTodas.length; j++) {
						for (int jj = 0; jj < arrayTodas[0].length; jj++) {
							valor1 = valor1 + arrayTodas[j][jj];
							cont1 = cont1 + 1;
							if (cont1 % tamanhoArray == 0) {
								arrayGrafico[j][indiceArray1] = valor1 / cont1;
								valor1 = 0;
								cont1 = 0;
								indiceArray1 = indiceArray1 + 1;
								if (indiceArray1 == 50) {
									indiceArray1 = 0;
								}
							}

						}
						if (!(valor1 == 0)) {
							arrayGrafico[j][50] = valor1 / cont1;
						}
						valor1 = 0;
						cont1 = 0;
					}
					int fim1 = arrayGrafico[0].length;
					for(int ii = 0; ii<arrayGrafico.length;ii++){
						caracteristica[ii] = "Caracterstica"+ Integer.toString(ii + 1);
							
						for (int i = 0; i < fim1; i++) {
						String columns = Integer.toString(i + 1);
						((DefaultCategoryDataset) dataset).addValue(
								arrayGrafico[ii][i],
								caracteristica[ii],columns);

					}
					}*/
					((DefaultCategoryDataset) dataset).clear();
				} else {
					for (int i = 0; i < caracSize; i++) {
						caracteristica[i] = "Caracterstica"
								+ Integer.toString(i + 1);
						for (int ii = 0; ii < array.size(); ii++) {
							String columns = Integer.toString(ii);
							((DefaultCategoryDataset) dataset).addValue(array
									.get(ii)
									.getCaracteristicaNormalizada(i + 1),
									caracteristica[i], columns);
						}
					}
				}
			} else {
				int fim = arrayGrafico[itemIndice].length;
				for (int i = 0; i < fim; i++) {
					String columns = Integer.toString(i + 1);
					((DefaultCategoryDataset) dataset)
							.addValue(arrayGrafico[itemIndice][i],
									serieCaracteristica
											+ Integer.toString(itemIndice + 1),
									columns);

				}
			}
			lastCaracteristica = itemIndice;
			createImage();

		}
	}

	private void createChart() {

		// create the chart...
		freeChart = ChartFactory.createLineChart(
				"Visualizao de Caracterstica", // chart
				// title
				"Padres", // domain axis label
				"Caracterstica Normalizada", // range axis label
				dataset, // data
				PlotOrientation.VERTICAL, // orientation
				true, // include legend
				true, // tooltips
				false // urls
				);

	}

	public static void main(String[] args) {
		final FeatureGraphic fg = new FeatureGraphic(new Frame(),
				"Grfico de Caracterstica");
		fg.show();
		fg.dialog.addWindowListener(new WindowListener() {

			public void windowActivated(WindowEvent e) {

			}

			public void windowClosed(WindowEvent e) {
				System.exit(0);

			}

			public void windowClosing(WindowEvent e) {
				// TODO Auto-generated method stub

			}

			public void windowDeactivated(WindowEvent e) {
				// TODO Auto-generated method stub

			}

			public void windowDeiconified(WindowEvent e) {
				// TODO Auto-generated method stub

			}

			public void windowIconified(WindowEvent e) {
				// TODO Auto-generated method stub

			}

			public void windowOpened(WindowEvent e) {
				// TODO Auto-generated method stub

			}

		});
	}
}