package visao.gui.telas.graficos.classes;

import java.awt.Frame;
import java.io.IOException;

import thinlet.Thinlet;
import thinletcommons.AntiAliasedThinlet;
import thinletcommons.ThinletDialog;

public class GraphicChooser extends AntiAliasedThinlet {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private Thinlet thinlet;

	private ThinletDialog dialog;

	public GraphicChooser(Frame owner, String title) {
		this.dialog = new ThinletDialog(owner, title, false);
		this.init();
	}

	private void init() {
		this.thinlet = new AntiAliasedThinlet();
		Object panel = null;
		try {
			panel = thinlet.parse("/visao/gui/telas/graficos/GraphicChooser.xml", this);
		} catch (IOException e) {
			// TODO Criar mensagem de erro 
			e.printStackTrace();

		}
		thinlet.add(panel);
		dialog.setContent(thinlet);
	}

	public void show() {
		dialog.pack();
		dialog.setSize(205, 170);
		dialog.setAlwaysOnTop(false);
		dialog.setLocationRelativeTo(dialog.getOwner());
		dialog.setVisible(true);
	}

	public void statisticGraphic() {
		StatisticGraphic sg = new StatisticGraphic(new Frame(), "Evoluo de Erros");
		sg.show();
		this.repaint();
	}

	public void featureGraphic() {
 		FeatureGraphic fg = new FeatureGraphic(new Frame(), "Visualizao de Caractersticas");
		fg.show();
		this.repaint();
	}
	
	public void neuronGraphic() {
		NeuronGraphic ng = new NeuronGraphic(new Frame(),"Grfico de Neurnio");
		ng.show();
		this.repaint();
		}
    public void comparateFeatureGraphic(){
    	ComparateFeatureGraphic cfg = new ComparateFeatureGraphic(new Frame(), "Comparao de Caractersticas");
    	cfg.show();
    	this.repaint();
    }
	
	public void cancelar(){
		dialog.setVisible(false);
	}
	public static void main(String[] args) {
		GraphicChooser gc = new GraphicChooser(new Frame(), "Escolha o Grafico");
		gc.show();
	}
}
