package visao.gui.telas.utils;

import java.io.IOException;
import java.lang.reflect.Array;
import java.util.Arrays;

import thinlet.Thinlet;
import thinletcommons.AntiAliasedThinlet;


public class CarregarTabela extends AntiAliasedThinlet {

	private static final long serialVersionUID = 1L;

	private int pageSize = 200;

	private int page = 1;

	private String[][] matrix;

	private int maxPages;

	private Object table, labelNowPage, labelMaxPage;

	private Thinlet thinlet;

	public CarregarTabela(Thinlet thinlet, Object tabela,
		Object labelPaginaAtual, Object labelPaginaMax) throws IOException {
		this.labelMaxPage = labelPaginaMax;
		this.labelNowPage = labelPaginaAtual;
		this.table = tabela;
		this.thinlet = thinlet;
	}

	public void carregaDados(String[][] vetor) {
		addRows(vetor);
	}

	/*
	 * M�todo para criar Linhas e Colunas na tabela e preenche-las @parametro
	 * Table = Tabela que se deseja preencher, vetor = Vetor cujos dados se
	 * deseja adicionar a tabela
	 */
	/**
	 * Add a row in the table
	 * 
	 * @param strings
	 *            the row, is a vararg
	 * @return 
	 */

	public void addRow(final String... strings) {
		// Runnable rodar = new Runnable() {
		// public void run() {
		Object header = Thinlet.create("header");

		// *************Colocando cabe�alho nas
		// colunas*******************************************
		int qtdCaracteristicas = 0;
		for (int coluna = 0; coluna < strings.length - 1; coluna++) {
			qtdCaracteristicas ++;
			Object column = Thinlet.create("column");
			String carac = "Caracteristica ";
			carac += coluna + 1;
			thinlet.setString(column, "text", carac);
			thinlet.setInteger(column, "width", 150);
			thinlet.add(header, column);
		}
		thinlet.setString(thinlet.find("caracTsN"),"text",Integer.toString(qtdCaracteristicas)) ;
		Object column = Thinlet.create("column");
		thinlet.setString(column, "text", "Classe");
		thinlet.add(header, column);
		thinlet.add(table, header);
		 //***************************************
		
		String[] lin = strings;
		int col = lin.length;

		System.out.println(col);
		// ***************************************************************************************
		Object row = Thinlet.create("row");
		Object cell;
		
				
		for (String s : strings) {
			cell = Thinlet.create("cell");
			thinlet.setString(cell, "text", s);
			thinlet.add(row, cell);
		thinlet.add(table, row);
		
	    }
	   }

	

	/**
	 * Add all the rows from a table(double dimension array).
	 * 
	 * @param table
	 *            the double dimensioned array.
	 */
	public void addRows(final String[][] table) {
		if (matrix ==  null) {
			this.matrix = table;
		}		
		else {
			int tamanho = matrix.length + table.length;
			String[][] novaMatrix = new String[tamanho][matrix[0].length];
			int fim1 = matrix.length;
			int fim2 = matrix[0].length;
			int k = 0;
			for (int i = 0; i < fim1; i++ ) {
				for (int j = 0; j < fim2; j++ ) {
					novaMatrix[k][j] = matrix[i][j];
				}
				k++;
			}
			fim1 = table.length;
			fim2 = table[0].length;
			for (int i = 0; i < fim1; i++ ) {
				for (int j = 0; j < fim2; j++ ) {
					novaMatrix[k][j] = table[i][j];
				}
				k++;
			}
			this.matrix = novaMatrix;
		}
		this.page = 1;
		calculateMaxPages();
		draw();
	}

	/*
	 * Metodo para apagar o conteudo da tabela @parametro Table = Tabela que se
	 * deseja apagar o conteudo
	 */
	public void clearTable() {
		removeAll(table);
		matrix = null;
	}

	private void calculateMaxPages() {
		this.maxPages = (this.matrix.length / this.pageSize);
		if ((this.matrix.length % this.pageSize) > 0)
			this.maxPages++;
	}

	public void draw() {
		thinlet
				.setString(labelMaxPage, "text", Integer
						.toString(this.maxPages));
		thinlet.setString(labelNowPage, "text", Integer.toString(this.page));
		int i = (this.page - 1) * this.pageSize;
		int fim1 = (this.page) * this.pageSize;
		int fim2 = this.matrix.length; 
		removeAll(table);
		int qtdPadroes = 0;
		for (; i < fim1 && i < fim2; i++) {
			addRow(this.matrix[i]);
			qtdPadroes++;
		}
		thinlet.setString(thinlet.find("padroesTsN"),"text",Integer.toString(qtdPadroes)) ;
	}
	
	public int getPage() {
		return this.page;
	}

	public void setPage(int page) {
		this.page = page;
		draw();
	}

	public int getPageSize() {
		return this.pageSize;
	}

	public void setPageSize(int pageSize) {
		this.pageSize = pageSize;
		calculateMaxPages();
		draw();
	}
	
	public void nextPage() {
		if (page < maxPages)
			setPage(++this.page);
	}
	
	public void beforePage(){
		if (page > 1)
			setPage(--this.page);
	}
}
