package fan.utilitarias;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Random;




public class fastFAN
{
	// dados crus
	public double [][] test;
	public double [][] trainning;
	
	//dados normalizados
	public double [][] testNorm;
	public double [][] trainningNorm;
	
	//conjuntos difusos
	public double [][][] testConjDifuso;
	public double [][][] trainningConjDifuso;
	
	//soma conjuntos difusos
	public double [] testSomaConjDifuso;
	public double [] trainningSomaConjDifuso;
	
	private String messageStatus;

	//variaveis da rede
	public static int MAX_CLA =  7;//20;											//mximo de classes permitidas
	public static int MAX_RAN = 110;											//mximo de range permitido
	public static int MAX_CAR =  3;//4;//50;											//mximo de caracteristicas permitidas
	public static int MAX_PAD = 10000;											//mximo de padroes permitidos
	private int n_entr;											//caracteristicas para os padroes de treino e teste
	private int n_neur;											//neuronios da sada
	private int n_pad;											//numero de padroes
	private int max_range;										//max_range informado para treinamento
	private int [] d;											//variavel para treinamento e teste
	private double [] nx;										//normais dos padroes
	private double [] peso_neu;									//peso do neuronio sobre o treinamento
	private double [][][] c1;										//rede neural
	private int [] classe_real;									//classe com as respostas corretas
	private int [] classe_fan;									//classe com as respostas da rede
	private int [] classe_certo;								//classe de respostas corretas
	private int [] classe_erro;									//classe de respostas erradas
	private double max_sem;										//variavel auxiliar (nao identificada)
	public double minval_max;
	public double minval_old;
	public double s_harm;
	public double max_tot;
	private Random rand;
	private String fileTreino;
	private String fileTeste;
	private int m_aprendizagem;

	public double [][] m_vMatconf;
	public double [][] m_pMatconf;
	private boolean [] usar_car;									//caracteristicas utilizadas no treinamento
	private int [] pesos;
	public double m_certos;
	public double m_total;
	public double m_errados;
	public double m_taxaerrados;
	private boolean normalized;

	protected fastFAN()
	{
		normalized = false;

		try
		{
			test = new double [MAX_PAD][MAX_CAR+1];
			trainning = new double [MAX_PAD][MAX_CAR+1];
			
			testNorm = new double [MAX_PAD][MAX_CAR];
			trainningNorm = new double [MAX_PAD][MAX_CAR];
			
			testSomaConjDifuso = new double [MAX_PAD];
			trainningSomaConjDifuso = new double [MAX_PAD];
			
			c1 = new double [MAX_CLA] [MAX_CAR] [MAX_RAN];
			d = new int [MAX_CAR];
			nx = new double [MAX_CAR + 1];								//ultima posicao contem o total da normal
			usar_car = new boolean [MAX_CAR];
			peso_neu = new double [MAX_CLA];//[MAX_CAR];
			classe_real = new int [MAX_CLA];
			classe_fan = new int [MAX_CLA];
			classe_certo = new int [MAX_CLA];
			classe_erro = new int [MAX_CLA];
			rand = new Random();
			pesos = new int [MAX_CLA];
			m_vMatconf = new double [MAX_CLA] [MAX_CLA];
			m_pMatconf = new double [MAX_CLA] [MAX_CLA];
		}
		catch (Exception ex)
		{
			messageStatus += ex.getMessage();
		}

		m_aprendizagem = 45;
		n_entr = 3;//35;!!!
		n_pad = 4096;
		n_neur = 7;
		max_range = 101;
		max_sem = 0.10;
		minval_max = 0;
		minval_old = 0;
		s_harm = 0;
		max_tot = 0;
		m_certos = 0;
		m_total = 0;
		for (int i = 0; i < MAX_CAR; i++)
			d[i] = 6;

		for (int i = 0; i < MAX_CLA; i++)
			pesos[i] = 500;

		double maiorRaio = 0;
		for (double dd : d) {
			if (dd > maiorRaio) {
				maiorRaio = dd;
			}
		}
			
		
		testConjDifuso = new double [MAX_PAD][n_entr][(int)(maiorRaio*2)+1];
		trainningConjDifuso = new double [MAX_PAD][n_entr][(int)(maiorRaio*2)+1];

	}
	////////////////////////////////////////////////////////////
	// Funcao: random
	// Objetivo: gerar um numero pseudo-randomico entre 0 e maximo
	// Entradas: maximo valor do numero randomico (maximo)
	// Saidas: numero gerado
	////////////////////////////////////////////////////////////
	public int random(int maximo)
	{
		int intRet = rand.nextInt(maximo+1);// Next(0,1000);
		return intRet;
	}
	////////////////////////////////////////////////////////////
	// Funcao: quadro
	// Objetivo: calcular o quadrado de um numero
	// Entradas: numero (arg)
	// Saidas: quadrado do numero
	////////////////////////////////////////////////////////////
	/*private double quadro (double arg) 
	{
		return (arg*arg);
	}*/

	////////////////////////////////////////////////////////////
	// Funcao: num_car
	// Objetivo: obter o numero de caracteristicas contidas
	//	em um arquivo de treino/teste
	// Entradas: nome do arquivo a ser lido
	// Saidas: numero de caracteristicas
	////////////////////////////////////////////////////////////
	private boolean num_car(int num_cars)
	{
		try {
		File fso = new File(fileTreino);

		if (!fso.exists())
		{
			messageStatus += "Err000 - Arquivo de treinamento no encontrado";
			return false;
		}
		BufferedReader sr;
		String line;
		
			sr = new BufferedReader(new FileReader(fileTreino));
			line = sr.readLine();
		
		String [] values = line.split("\t");
		sr.close();
		

		num_cars = 0;
		for (int i = 0; i < values.length; i++)
		{
			if (values[i].toString() != "" || values[i].toString() != null)
				num_cars = i - 1;
			else
				break;
		}

		//porque a ultima coluna  a resposta e logo apos vem um tab que 
		// calculado como uma coluna
		return true;
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return false;
		}
	}

	////////////////////////////////////////////////////////////
	// Funcao: f_area
	// Objetivo: area de Triangulo delimitada por um ponto R3 normalizada
	//	para vetor maximo (1,1,1); utilizada para calcular a caracteristica extra
	// Entradas:
	// Saidas:
	////////////////////////////////////////////////////////////
	/*private double f_area (double a, double b, double c) 
	{
		double m_ret;
		
		m_ret = (double)Math.sqrt(3)*Math.sqrt(a*a*b*b + a*a*c*c + b*b*c*c)/3.0;
		return (Math.pow(m_ret,1/7.0));
	}*/

	////////////////////////////////////////////////////////////
	// Funcao: triang
	// Objetivo: funcao triangular para pertinencia
	// Entradas: valor (x), centro, raio difuso (d)
	// Saidas: pertinencia para o valor x
	////////////////////////////////////////////////////////////
	private double triang ( double x, double centro, double d) 
	{
		double y, d1;
		d1 = d + 1;
		if (x<centro)
			y = (double) (1.0f/d1)*(x+d1-centro);
		else
			y = (double) (1.0f/d1)*(-x+d1+centro);

		return (y);
	}
	////////////////////////////////////////////////////////////
	// Funcao: normal
	// Objetivo: calcula os parametros de normalizacao a partir
	//	do arquivo de treino
	// Entradas: nome do arquivo de treino (arq3)
	// Saidas: parametros de normalizacao (nx)
	////////////////////////////////////////////////////////////
	
	private boolean normal (String file)
	{
		try {
		//double [] e = new double [MAX_CAR];
		int j;

		//verifica se o arquivo existe
		File fso = new File(file);
		if (!fso.exists())
		{
			return false;
		}

		BufferedReader sr = new BufferedReader(new FileReader(file));

		//limpa todas as normais
		for(j=0; j<n_entr; j++)
			nx[j] = 0;

		
			//inicia o calculo da normal
			String line = sr.readLine();
			String [] values = line.split("  ");//Object [] values = line.split("\t");
			for(j=0; j<n_entr; j++)
				nx [j] = Double.parseDouble(values[1+j]);
			int count = 2;
			//verifica se existe alguma maior que a atual maior
			line = sr.readLine();
			while (line != null && line != "")
			{
				values = line.split("  ");
				for(j=0; j<n_entr; j++)
					if (nx[j] < Double.parseDouble(values[j+1])) {
						nx[j] = Double.parseDouble(values[j+1]);
						if(nx[j] > 2.0f) {
							@SuppressWarnings("unused")
							int as = 0;
						}
					}
				line = sr.readLine();
				count++;
				
			}
		
		

		nx[n_entr] = 0;
		for(j=0; j<n_entr; j++)
			nx [n_entr] += nx[j];

		sr.close();
		return true;
	}catch(Exception ex)
		{
			messageStatus += ex.getMessage();
			return false;
		}
	}

	////////////////////////////////////////////////////////////
	// Funcao: store
	// Objetivo: treina um padrao
	// Entradas: rede (c), valor correto da saida (neu), valores
	//	das entradas (arg)
	// Saidas: -x-
	////////////////////////////////////////////////////////////
	private void store (double [][][] c, int neu, double [] arg, double[][] idx, double[] x) 
	{
		int i, j, count;
		//double idx;
		int iip;
		double u, s;
		//double [] x = new double [MAX_CAR];
		double mais;

		/*for (i=0; i<n_entr; i++)
		{
			x [i] = (max_range-1)*arg [i];
		}*/
		
		for (j=0; j<n_entr; j++)
		{
			count = 0;
			for (i=-d[j]; i<=d[j]; i++)
			{
				iip = (int) x [j] + i;
				if (iip<0)
					iip = 0;
				if (iip>max_range-1) iip = max_range-1;
				//idx = triang(iip,x[j],d[j]);
				u = c [neu][j][iip];
				s = c [neu][j][max_range];
				
				mais = idx[j][count];
				u += mais;
				s += mais;
				if (random(100)<100*idx[j][count]) 
				{
					c [neu][j][iip] = u;
					c [neu][j][max_range] = s;
				}
				count++;
			}
		}
	}
	////////////////////////////////////////////////////////////
	// Funcao: unstore
	// Objetivo: nega um padrao
	// Entradas: rede (c), valor correto da saida (neu), valores
	//	das entradas (arg)
	// Saidas: -x-
	////////////////////////////////////////////////////////////
	private void unstore (double [][][] c, int neu, double [] arg, double[][] idx, double[] x) 
	{
		int i, j, count;
		//double idx;
		int iip;
		double u;//, v, s;
		//double [] x = new double [MAX_CAR];
		/*for (i=0; i<n_entr; i++)
			x [i] = (max_range-1)*arg [i];*/

		for (j=0; j<n_entr; j++) {
			count = 0;
			if (random(10000)>peso_neu[neu]*10) {
				for (i=-d[j]; i<=d[j]; i++) 
				{
					iip = (int) x[j] + i;
					if (iip<0) iip = 0;
					if (iip>max_range-1) iip = max_range-1;
					u = c [neu][j][iip];
					//idx = triang(iip,x[j],d[j]);
					if (random(100)>1)
						u *= Math.pow(1-idx[j][count],0.001)*0.999;
					else
						u -= idx[j][count];
					if (u<0) u = 0;
					if (random(100)<100*idx[j][count])
						c [neu][j][iip] = u;
					
				}
				count++;
			}
		}
	}

	////////////////////////////////////////////////////////////
	// Funcao: tests
	// Objetivo: testa um padrao
	// Entradas: rede (c), valor correto da saida (neu), valores
	//	das entradas (arg)
	// Saidas: -x-
	////////////////////////////////////////////////////////////
	private double tests (double [][][]c, int neu, double [] arg, double somaCD, double[][] idx, double[] x) 
	{
		double pi;
		int i,j;
		int iip;
		double u, s;
		pi = 1;

		for (j=0; j<n_entr; j++) 
		{
			int count = 0;
			for (i=-d[j]; i<=d[j]; i++) 
			{
				iip = (int) x[j] + i;
				if (iip<0) iip = 0;
				if (iip>max_range-1) iip = max_range-1;
				u   = c [neu][j][iip];
				s   = c [neu][j][max_range];
				if (s > 0) 
				{
					if (usar_car[j])
						pi *= (1-Math.sqrt(idx[j][count]*u/(s*somaCD))); // Xi se Relaciona com Xj com intensidade idx
				}
				count++;
			}
		}
		return (1-Math.pow(pi, 1/(double)n_entr));
	}

	////////////////////////////////////////////////////////////
	// Funcao: inicializa
	// Objetivo: inicializar RNA randomicamente
	// Entradas: rede (c)
	// Saidas: rede inicializada
	////////////////////////////////////////////////////////////
	/*private void inicializa(double [][][] c) 
	{
		double r;
		int i, j, k;
		for (k=0; k<n_neur; k++)
			for (i=0; i<n_entr; i++)
				for (j=0; j<max_range; j++)  
				{
					r = random(1000)/1000.0;
					//r = 0;
					c [k][i][j] = r;
					c [k][i][max_range] += r;
				}
	}*/

	////////////////////////////////////////////////////////////
	// Funcao: inicializa
	// Objetivo: inicializar RNA randomicamente
	// Entradas: 
	// Saidas: rede inicializada
	////////////////////////////////////////////////////////////
	protected void inicializa()
	{
		double r;
		int i, j, k;
		for (k=0; k<n_neur; k++)
			for (i=0; i<n_entr; i++)
				for (j=0; j<max_range; j++)  
				{
					//r = random(1000)/1000.0;
					r = 0;
					c1 [k][i][j] = r;
					c1 [k][i][max_range] += r;
				}
	}

	////////////////////////////////////////////////////////////
	// Funcao: renormaliza
	// Objetivo: renormalizar RNA
	// Entradas: rede (c)
	// Saidas: rede renormalizada
	////////////////////////////////////////////////////////////
	public void renormaliza() 
	{
		int i, j, k;

		for (k=0; k<n_neur; k++)
			for (i=0; i<n_entr; i++)  
			{
				for (j=0; j<max_range; j++)  
				{
					c1 [k][i][j] /= c1 [k][i][max_range];
				}
				c1 [k][i][max_range] = 1;
			}
	}
	

	////////////////////////////////////////////////////////////
	// Funcao: cromo
	// Objetivo: realiza o treinamento da RNA para 1 epoca
	// Entradas: nome do arquivo de treino, rotulos para apresentar
	//	valores instantaneos (interface windows)
	// Saidas: -x-
	////////////////////////////////////////////////////////////
	// Treinamento cromossoma
	protected boolean cromo()
	{
		double [] e = new double [MAX_CAR];
		double [] xin = new double [MAX_CAR];
		double [] bxin = new double [MAX_CAR];
		double [] a  = new double [MAX_CLA];
		double [] q = new double [MAX_CLA];
		double ma;
		double prop;
		double certost = 0;  double certosm = 0;
		double errosm  = 0;  double errost  = 0;
		int maior, maior2;
		int ce = 0;
		int i,k, padrao;

		padrao = 0;
		m_total = 0;
		m_certos = 0;

		//inicializacao dos contadores de classe, acertos e erros
		for (i=0; i<n_neur; i++) 
		{
			classe_real [i] = 0;
			classe_fan  [i] = 0;
			classe_certo[i] = 0;
			classe_erro [i] = 0;
		}

		while (padrao < n_pad)
		{
			//lock(trainning)
			//{
				//leitura de todas as caracteristicas deste padrao
				for(k=0; k<n_entr; k++)
				{
					e[k] = trainning[padrao][k];
				}
				//leitura da saida correspondente
				ce = (int)trainning[padrao] [n_entr] - 1;
			//}

			//normalizacao do padrao
			for(k=0; k<n_entr; k++)
				if (nx[k] != 0)
					xin[k] = (/*0.9**/e[k]/nx[k]);
				else
					xin[k] = 0;

			//eliminacao do sinal (calculo do modulo) dos dados
			for (i=0; i<n_entr; i++)
				bxin [i] = Math.abs(xin[i]);

			ma = maior = maior2 = 0;

			//consulta da pertinencia em relacao a cada classe para
			//o padrao sendo testado
			for (i=0; i<n_neur; i++)         
			{
				a[i] = tests(c1,i,bxin, trainningSomaConjDifuso[padrao], trainningConjDifuso[padrao], trainningNorm[padrao]);
				ma += a [i];
			}

			//verificacao da classe com maior pertinencia
			for (i=0; i<n_neur; i++) 
			{
				q[i] = a[i];
				if (q[i]>q[maior])   
				{
					maior2 = maior;
					maior  = i;
				} 
			}
			if (q[maior] > 0)
				prop = (q[maior]-q[maior2])/q[maior];
			else
				prop = 1;

			m_total +=1;

			/// Armazenamento ***
			classe_real [ce] += 1;
			classe_fan  [maior] += 1;

			//aprendizagem
			if (random(100) > m_aprendizagem)
			{
				store(c1,ce,bxin, trainningConjDifuso[padrao], trainningNorm[padrao]);
				//se a opiniao da FAN estiver errada, 
				//realizar penalizacao
				if (maior != ce && q[maior] > q[ce]) 
				{ 
					unstore(c1,maior,bxin, trainningConjDifuso[padrao], trainningNorm[padrao]);

					for (int j = 0; j < n_neur; j++)
					{
						peso_neu[j] = pesos[j] + random(1000-pesos[j]);
					}

				}
			}
			/// Fim Armazenamento

			//contagem do numero de acertos/erros
			if (maior == ce) 
			{
				classe_certo [ce] += 1;
				if (prop > max_sem)
					certost += 1;
				else
					certosm += 1;
			}
			else 
			{
				classe_erro [maior] += 1;
				if (prop > max_sem)
					errost +=1;
				else
					errosm +=1;
			}

			padrao++;
		}
		m_certos = certost + certosm;
		m_errados = errost + errosm;
		return true;
	}

	////////////////////////////////////////////////////////////
	// Funcao: cromot
	// Objetivo: realiza o teste da RNA para 1 epoca
	// Entradas: nome do arquivo de teste (arq3) e nome do arquivo 
	//	da tabela de confusao (arqc), rotulos para apresentar
	//	valores instantaneos (interface windows)
	// Saidas: -x-
	////////////////////////////////////////////////////////////
	protected boolean cromot(boolean saida, int rede)
	{
		double [][] conf = new double [MAX_CLA] [MAX_CLA];
		double [] e = new double [MAX_CAR];
		double [] xin = new double [MAX_CAR];
		double [] bxin = new double [MAX_CAR];
		double [] a = new double [MAX_CLA];
		//double [] b = new double [MAX_CLA];
		double [] q = new double [MAX_CLA];
		double ma;
		double prop;
		double certost = 0;  double certosm = 0;
		double errosm  = 0;  double errost  = 0;
		double maior, maior2;
		int ce,i,j,k, padrao;
		BufferedWriter swFC = null;

		double [][][] c = new double[1][1][1];
		
		if (rede == 1)
		{
			c = new double [MAX_CLA] [MAX_CAR] [MAX_RAN];
			if (!load_net("amax.fan", c))
			{
				return false;
			}
		}
		else
			if (rede == 2)
		{
			c = new double [MAX_CLA] [MAX_CAR] [MAX_RAN];
			if (!load_net("amaxg.fan", c))
			{
				return false;
			}
		}

		padrao = 0;
		m_certos = 0;
		m_total = 0;

		if (saida)
		{
			try
			{
				//abre arquivo de saida
				swFC = new BufferedWriter(new FileWriter("fc.fsy"));
			
			}
			catch (Exception ex)
			{
				messageStatus += "Err000 - No foi possivel criar arquivo de sada";
				return false;
			}
		}

		//inicializacao dos contadores de classe, acertos e erros
		for (i=0; i<n_neur; i++) 
		{
			classe_real [i] = 0;
			classe_fan  [i] = 0;
			classe_certo[i] = 0;
			classe_erro [i] = 0;
			for (j=0; j<n_neur; j++)
				conf [i][j] = 0;
		}
		
		while (padrao < n_pad)
		{
			//lock(test)
			//{
				//leitura de todas as caracteristicas deste padrao
				for(k=0; k<n_entr; k++)
				{
					e[k] = test[padrao][k];
				}
				//leitura da saida correspondente
				ce = (int)test[padrao][n_entr] - 1;
			//}

			//normalizacao dos dados a serem testados
			for(k=0; k<n_entr; k++)
			{
				if (nx[k] != 0)
					xin[k] = (/*0.9**/e[k]/nx[k]);
				else
					xin[k] = 0;
			}
			for (i=1; i<n_entr; i++)
			{
				if (xin[i] > 1)
					xin[i] = 1;
			}

			//eliminacao do sinal
			for (i=0; i<n_entr; i++)
			{
				bxin [i] = Math.abs(xin[i]);
			}

			ma = maior = maior2 = 0;

			//consulta da pertinencia em relacao a cada classe para
			//o padrao sendo testado
			for (i=0; i<n_neur; i++)         
			{
				if (rede == 1 || rede == 2)
				{
					a[i] = tests(c,i,bxin, testSomaConjDifuso[padrao], testConjDifuso[padrao], testNorm[padrao]);
				}
				else
				{
					a[i] = tests(c1,i,bxin, testSomaConjDifuso[padrao], testConjDifuso[padrao], testNorm[padrao]);
				}
				ma += a [i];
			}

			//verificacao da classe com maior pertinencia
			for (i=0; i<n_neur; i++) 
			{
				q[i] = a[i];
				if (q[i] > q[(int)maior])
				{
					maior2 = maior;
					maior  = i;
				} 
			}
			if (q[(int)maior] > 0)
				prop = (q[(int)maior]-q[(int)maior2])/q[(int)maior];
			else 
				prop = 1;

			m_total +=1;

			classe_real [ce] += 1;
			classe_fan [(int)maior] += 1;
			conf [ce][(int)maior] +=1;

			//atualizacao da quantidade de acertos e erros
			if (maior == ce)
			{
				classe_certo [ce] += 1;
				if (prop > max_sem)
					certost+=1;
				else
					certosm+=1;
			}
			else 
			{
				classe_erro [(int)maior] += 1;
				if (prop > max_sem)
					errost +=1;
				else
					errosm +=1;
			}
			try{
			//salva as pertinencias de cada classe para cada padrao testado
			if(saida)
			{
				for(i=0; i<n_neur; i++)
				{
					double dvalue = q[i]; //Math.Round(q[i],6);
					swFC.write("\t" + Double.toString(dvalue));
				}
				int iValue = ce + 1;
				swFC.write("\t" + Integer.toString(iValue)+ "\n");//swFC.writeLine("\t" + Integer.toString(iValue));
			}
			}
			catch(Exception ex) {
				ex.printStackTrace();
				return false;
			}
			padrao++;
			
		}

		m_certos = certost + certosm;
		m_errados = errost + errosm;
		try {
		if (saida)
            swFC.close();
		}
		catch(Exception ex) {
			ex.printStackTrace();
		}

		//calculo da media harmonica
		if (rede == 0)
		{
			s_harm = 0;
			for (i=0; i<n_neur; i++) 
			{
				if (conf[i] [i] > 0) 
				{
					s_harm += classe_real[i]/conf[i][i]; // tentar 0 no final
				}
				else 
				{
					s_harm = 100;
					break;
				}
			}
			s_harm = n_neur/s_harm;

			minval_old=0;
			if (classe_real[0] > 0 && classe_real[1] > 0)
				minval_old = Math.min(conf[0][0]/classe_real[0],conf[1][1]/classe_real[1]);

			//salva o maior valor minimo da taxa de acertos
			if (minval_old > minval_max) 
			{   
				minval_max = minval_old;	
				save_net("amaxg.fan");
			}

			//salvar a melhor media absoluta
			if (max_tot < s_harm) 
			{
				max_tot = s_harm;
				save_net("amax.fan");
			}

		}
		//calcula e salva matriz de confusao
		m_taxaerrados = 100-(double)(100*m_certos/m_total);

		for (i=0; i<n_neur; i++)
			for(j=0; j<n_neur; j++)
				m_vMatconf[i][j] = conf [i][j];

		for (i=0; i<n_neur; i++)
			for(j=0; j<n_neur; j++)
				m_pMatconf[i][j] = conf [i][j]/classe_real[i];
		return true;
	}

	////////////////////////////////////////////////////////////
	// Funcao: load_net
	// Objetivo: carregar a rede
	// Entradas: nome do arquivo de rede
	// Saidas: rede carregada
	////////////////////////////////////////////////////////////
	private boolean load_net(String file, double [][][] c) 
	{
		int i,j,l;
		String [] values;

		File fso = new File(file);
		if(!fso.exists())
		{
			messageStatus += "Err000 - Arquivo no pode ser localizado";
		}
		else
		{
			try {
			BufferedReader sr = new BufferedReader(new FileReader(file));
			for (i=0; i<n_neur; i++)
				for (l=0; l<=max_range; l++)    
				{
					String line = sr.readLine();
					values = line.split(" ");
					for (j=0; j<n_entr; j++) 
					{
						c [i][j][l] = Double.parseDouble(values[j]);
					}
				}
			sr.close();
			}
			catch (Exception ex) {
				ex.printStackTrace();
			}
		}
		return true;
	}

	////////////////////////////////////////////////////////////
	// Funcao: load_data
	// Objetivo: carregar a info
	// Entradas: nome do arquivo de data
	// Saidas: data carregada
	////////////////////////////////////////////////////////////
	private boolean load_data(String file,double[][] dat) 
	{
		int j, padroes;
		String [] values;

		File fso = new File(file);
		if(!fso.exists())
		{
			messageStatus += "Err000 - Arquivo no pode ser localizado";
		}
		else
		{
			try {
			padroes = 0;
			BufferedReader sr = new BufferedReader(new FileReader(file));
			String line = sr.readLine();
			while (line != null && line != "")
			{
				values = line.split("  ");
				for (j=0; j<= values.length - 2; j++)    //!!!! Era menor ou igual antes
				{
					dat[ padroes] [j] = Double.parseDouble(values[j+1]);
				}
				padroes++;
				line = sr.readLine();
			}
			sr.close();
			n_pad = padroes;
			}
			catch(Exception ex) {
				ex.printStackTrace();
				return false;
			}
		}
		return true;
	}

	////////////////////////////////////////////////////////////
	// Funcao: load_net
	// Objetivo: carregar a rede
	// Entradas: nome do arquivo de rede
	// Saidas: rede carregada
	////////////////////////////////////////////////////////////
	protected boolean load_net(String file) 
	{
		int i,j,l;
		String [] values;

		File fso = new File(file);
		if(!fso.exists())
		{
			messageStatus += "Err000 - Arquivo no pode ser localizado";
		}
		else
		{
			try{
			BufferedReader sr = new BufferedReader(new FileReader(file));
			for (i=0; i<n_neur; i++)
				for (l=0; l<=max_range; l++)    
				{
					String line = sr.readLine();
					values = line.split(" ");
					for (j=0; j<n_entr; j++) 
					{
						c1 [i][j][l] = Double.parseDouble(values[j]);
					}
				}
			sr.close();
			}
			catch(Exception ex) {
				ex.printStackTrace();
				return false;
			}
		}
		return true;
	}
	
	////////////////////////////////////////////////////////////
	// Funcao: save_net
	// Objetivo: salvar uma rede
	// Entradas: nome do arquivo
	// Saidas: arquivo de rede
	////////////////////////////////////////////////////////////
	protected boolean save_net(String file) 
	{
		int i,j,l;
		double cell;
		BufferedWriter sw = null;
		try
		{
			sw = new BufferedWriter(new FileWriter(file));
		}
		catch(Exception err)
		{
			messageStatus += "Err000 - " + err.getMessage();
		}
		for (i=0; i<n_neur; i++)
			for (l=0; l<=max_range; l++)   
			{
				String line = "";
				for (j=0; j<n_entr; j++) 
				{
					cell = c1 [i][j][l];
					line += Double.toString(cell) + " ";
				}
				try {
					sw.write(line+"\n");
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}//sw.writeLine(line);
			}
		try {
			sw.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return true;
	}	

	protected boolean fanInit()
	{
		//verifica a existencia dos arquivos de treino, teste e configuraao
		if(fileTreino == null || fileTeste == null || fileTreino == "" || fileTeste == "")
		{
			messageStatus += "Err000 - Nome de arquivo invlido";
			return false;
		}

		File fso = new File(fileTreino);
		if(!fso.exists())
		{
			messageStatus += "Err000 - Erro ao localizar arquivo de treino";
			return false;
		}
		fso = new File(fileTeste);

		if(!fso.exists())
		{
			messageStatus += "Err000 - Erro ao localizar arquivo de teste";
			return false;
		}

		if (!num_car(n_entr))
		{
			return false;
		}
		//inicializa a rede randomicamente
		inicializa();

		if (!load_data(fileTreino, trainning))
		{
			return false;
		}
		if (!load_data(fileTeste, test))
		{
			return false;
		}
		
		//Calcula nx[]
		if (!normalized)
		{
			if (!normal(fileTreino))
			{
				return false;
			}
			normalized = true;
		}
		
		//preenche os arrays com  os padroes normalizados
		normalizarPadroes(test, testNorm);
		normalizarPadroes(trainning, trainningNorm);
		
		calcularConjuntosDifusos(testNorm, testConjDifuso, testSomaConjDifuso);
		calcularConjuntosDifusos(trainningNorm, trainningConjDifuso, trainningSomaConjDifuso);
		
		for (int i = 0; i < MAX_CAR; i++)
		{
			usar_car [i] = true;
		}
		for (int i = 0; i < MAX_CLA; i++)
		{
			peso_neu [i] = 500.0;
		}
		return true;
	}

	private void calcularConjuntosDifusos(double[][] padroesNorm, double[][][] padroesConjDifuso, double[] padroesSomaConjDifuso) {
		int padrao = 0;
		int iip;
		while (padrao < n_pad){
			for (int j=0; j<n_entr; j++) 
			{
				int k = 0;
				double sidx = 0;
				for (int i=-d[j]; i<=d[j]; i++) 
				{
					iip = (int) padroesNorm[padrao][j] + i;
					if (iip<0) iip = 0;
					if (iip>max_range-1) iip = max_range-1;
					padroesConjDifuso[padrao][j][k] = triang(iip,padroesNorm[padrao][j],d[j]);
					sidx += padroesConjDifuso[padrao][j][k];
					k++;
				}
				padroesSomaConjDifuso[padrao] = sidx;
			}
			padrao++;
		}
		
	}
	private void normalizarPadroes(double[][] padroes, double[][] padroesNorm) {
		int padrao = 0;
		while (padrao < n_pad)
		{
			for(int k=0; k<n_entr; k++)	{
					if (nx[k] != 0)
						padroesNorm[padrao][k] =  (Math.abs(/*0.9**/padroes[padrao][k]/nx[k]))*(max_range-1);
					else
						padroesNorm[padrao][k] = 0;
			}			
			padrao++;
		}
	}

	//--------------------------------------------------
	public static void main(String[] args) {
		fastFAN rede = new fastFAN();
		rede.fileTeste = ".//src//data//cromo_ts.dat";
		rede.fileTreino = ".//src//data//cromo_tr.dat";
		rede.fanInit();
		int epoca = 1;
		//long li = System.currentTimeMillis();
		while(/*epoca <= 100*/true) {
			rede.cromot(false,0);
			rede.cromo();
			System.out.println(epoca + "\t" + rede.s_harm*100+ "\t"+rede.max_tot *100+"\t"+rede.m_certos+ "\t"+ rede.m_errados);
			epoca++;
		}
		//long lf = System.currentTimeMillis();
		//System.out.println("Tempo:" + ((lf-li)));
		
	}
	//--------------------------------------------------
}
