package jfan.fan;

public interface IMonitor {

	/**
	 * Deve iniciar a execuo da rede, em geral esse
	 * mtodo deve iniciar uma thread para manter a 
	 * execuo em paralelo.
	 */
	public void execute();
	
	/**
	 * Deve indicar que o monitor deve parar a execuo chamada
	 * pelo mtodo execute.
	 */
	public void stop();
	
	/**
	 * Deve retornar se o monitor est em execuo (true) ou no
	 * (false).
	 * @return True se o monitor est em execuo, false se no
	 * estiver executando.
	 */
	public boolean isExecuting();
}
