package jfan.fan.utilitarias;

import java.util.ArrayList;

import jfan.fan.padroes.IPadrao;

public abstract class DetectorMaxMinMean {
	
	public static double[] procurarMaximos (ArrayList<IPadrao>... padroes) {
		double[][] maxs = null;
		double[] max = null;
		for (int i = 0; i < padroes.length; i++) {
			if (padroes[i].size() == 0) {
				continue;
			}
			else {
				maxs = new double[padroes.length][padroes[i].get(0).getQuantasCaracteristicas()];
				max = new double[padroes[i].get(0).getQuantasCaracteristicas()];
			}
			
		}
		for (int i = 0; i < padroes.length; i++) {
			maxs[i] = procurarMaximos(padroes[i]);
		}
		
		for(int i = 0; i < max.length; i++) {
			int index = 0;
			for (int j = 0; j < maxs.length; j++) {
				if (maxs[j] == null) {
					continue;
				}
				else {
					index = j;
					break;
				}
			}
			
						
			max[i] = maxs[index][i];
			for (int j = 1; j < padroes.length; j++) {
				if (maxs[j] == null) continue; 
				if (max[i]<maxs[j][i]) max[i] = maxs[j][i]; 
			}
		}
		return max;
	}
	
	public static double[] procurarMedias (ArrayList<IPadrao>... padroes) {
		double[] mean = null;
		
		for (int i = 0; i < padroes.length; i++) {
			if (padroes[i].size() == 0) {
				continue;
			}
			else {
				mean = new double[padroes[i].get(0).getQuantasCaracteristicas()];
			}
			
		}
		int count;
		for (int i = 0; i < mean.length; i++)
			mean[i] = 0.0;
		for (int i = 0; i < mean.length; i++) {
			count = 0;
			for(ArrayList<IPadrao> arrayListPadroes : padroes){
				for(IPadrao p : arrayListPadroes) {
					mean[i] += p.getCaracteristica(i+1);
					count++;
				}
			}
			mean[i] /= count;
		}
		return mean;
	}

	public static double[] procurarMaximos(ArrayList<IPadrao> padroes) {
		if (padroes.size() == 0) return null;
		double[] max = new double[padroes.get(0).getQuantasCaracteristicas()];
		for (int i = 0; i < max.length; i++)
			max[i] = Double.MIN_VALUE;
		for (int i = 0; i < max.length; i++) {
			for(IPadrao p : padroes) {
				if (max[i] < p.getCaracteristica(i+1)) {
					max[i] = p.getCaracteristica(i+1);
				}
			}
		}
		return max;
	}
	
	public static double[] procurarMedias(ArrayList<IPadrao> padroes) {
		if (padroes.size() == 0) return null;
		double[] means = new double[padroes.get(0).getQuantasCaracteristicas()];
		int count;
		for (int i = 0; i < means.length; i++)
			means[i] = 0.0;
		for (int i = 0; i < means.length; i++) {
			count = 0;		
			for(IPadrao p : padroes) {
				means[i] += p.getCaracteristica(i+1);
				count++;
			}
			means[i] /= count;
		}
		return means;
	}
	
	
	public static double procurarMaximo(ArrayList<IPadrao> padroes, int caracteristica) {
		double max = Double.MIN_VALUE; 
		for(IPadrao p : padroes) {
				if (max < p.getCaracteristica(caracteristica)) {
					max = p.getCaracteristica(caracteristica);
				}
			}
		return max;
	}
	
	public static double procurarMedia(ArrayList<IPadrao> padroes, int caracteristica) {
		double media = 0.0;
		double count = 0;
		for(IPadrao p : padroes) {
				 media += p.getCaracteristica(caracteristica);
				 count++;
		}
		media /= count;
		return media;
	}
		
	public static double[] procurarMinimos (ArrayList<IPadrao>... padroes) {
		
		double[][] mins = null;
		double[] min = null;
		for (int i = 0; i < padroes.length; i++) {
			if (padroes[i].size() == 0) {
				continue;
			}
			else {
				mins = new double[padroes.length][padroes[i].get(0).getQuantasCaracteristicas()];
				min = new double[padroes[i].get(0).getQuantasCaracteristicas()];
			}
			
		}
		
		for (int i = 0; i < padroes.length; i++) {
			mins[i] = procurarMinimos(padroes[i]);
		}
		for(int i = 0; i < min.length; i++) {
			int index = 0;
			for (int j = 0; j < mins.length; j++) {
				if (mins[j] == null) {
					continue;
				}
				else {
					index = j;
					break;
				}
			}
			min[i] = mins[index][i];
			for (int j = 1; j < padroes.length; j++) {
				if (mins[j] == null) continue;
				if (min[i]>mins[j][i]) min[i] = mins[j][i]; 
			}
		}
		return min;
	}
	
	public static double procurarMinimo(ArrayList<IPadrao> padroes, int caracteristica) {
		double max = Double.MAX_VALUE; 
		for(IPadrao p : padroes) {
				if (max > p.getCaracteristica(caracteristica)) {
					max = p.getCaracteristica(caracteristica);
				}
			}
		return max;
	}
	
	public static double[] procurarMinimos(ArrayList<IPadrao> padroes) {
		if (padroes.size() == 0) return null;
		double[] max = new double[padroes.get(0).getQuantasCaracteristicas()];
		for (int i = 0; i < max.length; i++)
			max[i] = Double.MIN_VALUE;
		for (int i = 0; i < max.length; i++){
			max[i] =procurarMinimo(padroes, i+1);
		}
		return max;
	}
	
}
