package jfan.fan.utilitarias;

import java.util.ArrayList;
import java.util.HashMap;

import jfan.fan.NeuronioFAN;
import jfan.fan.padroes.IPadrao;

public class RecalculadorClasses {
	
	private static HashMap<Integer, Integer> classesMapRealIndex;
	//private static  HashMap<Integer, Integer> neuroniosMapRealIndex;
	private static HashMap<Integer, Integer> classesMapIndexReal;
	//private static  HashMap<Integer, Integer> neuroniosMapIndexReal;
	
	
	public static void indexarClasses(int[] classes, ArrayList<IPadrao> padroes) {
		try {
		//Mapeamento usando hash para agilizar o processo
		if (classesMapIndexReal == null || classesMapRealIndex == null) {
			classesMapRealIndex = new HashMap<Integer, Integer>(classes.length);
			classesMapIndexReal = new HashMap<Integer, Integer>(classes.length);
		}
		
		for (int i = 0; i < classes.length; i++) {
			if (!classesMapRealIndex.containsKey(classes[i])) {
				classesMapRealIndex.put(classes[i], i);
			}
			if (!classesMapIndexReal.containsKey(i)) {
				classesMapIndexReal.put(i,classes[i]);
			}	
		}
		//Substitui as classes originais pelos indices delas.
		Integer novaClasse = null;
		for (IPadrao p : padroes) {
			novaClasse = classesMapRealIndex.get(p.getClasse());
			if (novaClasse == null) {
				int i = p.getClasse();
				System.out.println(i);
			}
			p.setClasse(novaClasse);
			
		}
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void indexarNeuronios (int[] classes, ArrayList<NeuronioFAN> neuronios) {
		try {
			/*if (neuroniosMapIndexReal == null || neuroniosMapRealIndex == null) {
				neuroniosMapRealIndex = new HashMap<Integer, Integer>(classes.length);
				neuroniosMapIndexReal = new HashMap<Integer, Integer>(classes.length);
			}*/
			if (classesMapIndexReal == null || classesMapRealIndex == null) {
				classesMapRealIndex = new HashMap<Integer, Integer>(classes.length);
				classesMapIndexReal = new HashMap<Integer, Integer>(classes.length);
			}
			
			for (int i = 0; i < classes.length; i++) {
				if (!classesMapRealIndex.containsKey(classes[i])) {
					classesMapRealIndex.put(classes[i], i);
				}
				
				if (!classesMapIndexReal.containsKey(i)) {
					classesMapIndexReal.put(i,classes[i]);
				}
			}
			Integer novaClasse = null;
			for (NeuronioFAN n : neuronios) {
				novaClasse = classesMapRealIndex.get(n.getClasseAssociada());
				/*for(Integer i = 0; i < classes.length; i++) {
					if (n.getClasseAssociada() == classes[i]) {
						novaClasse = i;
						break;
					}
				}
				if (novaClasse == 7) {
					String a = "aaaa";
					System.out.println(a);
				}*/
				n.setClasseAssociada(novaClasse);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void reverterIndexacaoPadroes(ArrayList<IPadrao> padroes) {
		if (padroes != null && classesMapIndexReal != null) {
			for (IPadrao p : padroes) {
				int i = classesMapIndexReal.get(p.getClasse());
				p.setClasse(i);
			}
		}
	}

	public static HashMap<Integer, Integer> getClassesMapIndexReal() {
		return classesMapIndexReal;
	}

	public static HashMap<Integer, Integer> getNeuroniosMapIndexReal() {
		return classesMapIndexReal;
	}
	
	public static HashMap<Integer, Integer> getClassesMapRealIndex() {
		return classesMapRealIndex;
	}

	public static HashMap<Integer, Integer> getNeuroniosMapRealIndex() {
		return classesMapRealIndex;
	}

}
