/**
 * 
 */
package jfan.io.arquivos;


import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.Vector;

import jfan.fan.padroes.IPadrao;
import jfan.fan.padroes.Padrao;
import jfan.io.ILeitura;


/**
 * @author Fabiano
 *
 */
public class CarregaTxt implements ILeitura {
	/**
	 * Contm os padres desnormalizados  
	 */
	public ArrayList<IPadrao> padroes = null;

	/**
	 * Define o tipo de separador de colunas no arquivo de padres 
	 */
	private String separadorColuna = "  ";

	/**
	 * Define o nome de arquivo de padres 
	 */
	private String nomeArquivo = "";
	
	/**
	 * Define uma coluna inicial inclusive
	 */
	private int colunaInicial = 0;
	
	/**
	 * Define uma coluna final inclusive
	 */
	private int colunaFinal = 1;

	/**
	 * Define uma linha inicial inclusive 
	 */
	private int linhaInicial = 1;

	/**
	 * Define uma linha final inclusive 
	 */
	private int linhaFinal = 0;

	/**
	 * Define a coluna que contm a classe 
	 */
	private int colunaClasse = 0;

	/**
	 * Construtor da classe CarregaTxt
	 * @param umNomeDeArquivo
	 *	Um arquivo com padres
	 *
	 * @param umSeparadorColuna
	 *	Um separador de coluna
	 *
	 * @param aColunaDaClasse
	 *	A Coluna que contm a classe
	 *
	 * @param aColunaInicial
	 *	Define a coluna inicial inclusive
	 *
	 * @param aColunaFinal
	 *	Define a coluna final inclusive
	 *
	 * @param aLinhaInicial
	 *	Define a linha inicial inclusive
	 *
	 * @param aLinhaFinal
	 *	Define a linha final inclusive
	 */

	public CarregaTxt(String umNomeDeArquivo, String umSeparadorDeColuna, int aColunaDaClasse, int aColunaInicial, int aColunaFinal, int aLinhaInicial, int aLinhaFinal){
		this.nomeArquivo = umNomeDeArquivo;
		this.separadorColuna = umSeparadorDeColuna;
		this.colunaClasse = aColunaDaClasse;
		this.colunaInicial = aColunaInicial;
		this.colunaFinal = aColunaFinal;
		this.linhaInicial = aLinhaInicial;
		this.linhaFinal = aLinhaFinal;
	}

	public int[] getClasses() throws Exception {
        BufferedReader arqDados = new BufferedReader(new FileReader(nomeArquivo));
        ArrayList<Double> asClasses = new ArrayList<Double>();
        String linha = "";
        int contadorLinhas = 0;
        while ((linha = arqDados.readLine())!=null){
        	contadorLinhas+=1;
        	if(getLinhaInicial()<=contadorLinhas && contadorLinhas<=getLinhaFinal()){
        		StringTokenizer t = new StringTokenizer(linha,separadorColuna);
        		int contadorTokens = 0;
        		while (t.hasMoreTokens()){
        			if (contadorTokens==getColunaClasse())
        				asClasses.add(Double.parseDouble(t.nextToken()));
        			else
        				t.nextToken();
        			contadorTokens+=1;
        		}
        	}
        }
        ArrayList<Double> achados = new ArrayList<Double>();	
        for (int i=0;i<asClasses.size();i++)
        	if (!achados.contains(asClasses.get(i)))
        		achados.add(asClasses.get(i));

        int[] classes = new int[achados.size()];
        for (int i=0;i<achados.size();i++)
        	classes[i]=achados.get(i).intValue();
        arqDados.close();
        return classes;
	}

	public int getNumClasses() throws Exception {
        BufferedReader arqDados = new BufferedReader(new FileReader(nomeArquivo));
        ArrayList<Double> asClasses = new ArrayList<Double>();
        String linha = "";
        int contadorLinhas = 0;
        while ((linha = arqDados.readLine())!=null){
        	contadorLinhas+=1;
        	if(getLinhaInicial()<=contadorLinhas && contadorLinhas<=getLinhaFinal()){
        		StringTokenizer t = new StringTokenizer(linha,separadorColuna);
        		int contadorTokens = 0;
        		while (t.hasMoreTokens()){
        			if (contadorTokens==getColunaClasse())
        				asClasses.add(Double.parseDouble(t.nextToken()));
        			else
        				t.nextToken();
        			contadorTokens+=1;
        		}
        	}
        }
        ArrayList<Double> achados = new ArrayList<Double>();	
        for (int i=0;i<asClasses.size();i++)
        	if (!achados.contains(asClasses.get(i)))
        		achados.add(asClasses.get(i));
        arqDados.close();
        return achados.size();
	}

	public int getNumCaracteristicas() throws Exception {
        BufferedReader arqDados = new BufferedReader(new FileReader(nomeArquivo));
		String linha = "";
        linha = arqDados.readLine();
        StringTokenizer t = new StringTokenizer(linha,separadorColuna);
		if (t.countTokens() < getColunaFinal())
			setColunaFinal(t.countTokens());
        arqDados.close();
        return getColunaFinal()-getColunaInicial()+1;
	}

	public int getNumPadroes() throws Exception {
		BufferedReader arqDados = new BufferedReader(new FileReader(nomeArquivo));
		int contadorLinhas = getLinhaInicial();
        while ((arqDados.readLine())!=null)
        	if (getLinhaInicial()<=contadorLinhas && contadorLinhas<=getLinhaFinal())
        		contadorLinhas+=1;
        arqDados.close();
        return (contadorLinhas-getLinhaInicial());
	}
	
	public int getNumLinhasArquivo() throws Exception {
		BufferedReader arqDados = new BufferedReader(new FileReader(nomeArquivo));
		int contadorLinhas = 0;
        while ((arqDados.readLine())!=null)
        		contadorLinhas+=1;
        arqDados.close();
        return contadorLinhas;
	}


	public ArrayList<IPadrao> getPadroes() throws Exception{
			BufferedReader arqDados = new BufferedReader(new FileReader(nomeArquivo));
			String linha = "";
			Vector<Double> asCaracteristicas = new Vector<Double>();
			int classe = 0;
			padroes = new ArrayList<IPadrao>();
			padroes.clear();
			int contadorLinhas = 0;
			while ((linha = arqDados.readLine())!=null){
				contadorLinhas+=1;
				if (getLinhaInicial()<=contadorLinhas && contadorLinhas<=getLinhaFinal()){
					StringTokenizer t = new StringTokenizer(linha,separadorColuna);
					if (t.countTokens() < getColunaFinal())
						setColunaFinal(t.countTokens()-1);
					while (t.hasMoreTokens())
						asCaracteristicas.add(Double.parseDouble(t.nextToken()));
				
					double[] copiaDasCaracteristicas = new double[getColunaFinal()-getColunaInicial()+1];
					for (int j=0;j<getColunaFinal()-getColunaInicial()+1;j++)
						copiaDasCaracteristicas[j]=asCaracteristicas.elementAt(getColunaInicial()+j);

					classe = asCaracteristicas.elementAt(getColunaClasse()).intValue();
				
					asCaracteristicas.removeElementAt(getColunaClasse());
					asCaracteristicas.trimToSize();
			
					//teste
					for (int i=0;i<copiaDasCaracteristicas.length;i++)
						System.out.print(copiaDasCaracteristicas[i]+" ");
					System.out.println("Caracterticas ");
					System.out.println("Classe "+classe);
					//
				
					padroes.add(new Padrao(copiaDasCaracteristicas,classe));
   		   			asCaracteristicas.removeAllElements();
   		   			padroes.trimToSize();
				}
			}
			arqDados.close();
			return padroes;
	}

	public String[][] getPadroesOriginais() throws Exception{
		BufferedReader arqDados = new BufferedReader(new FileReader(nomeArquivo));
		String linha = "";
		Vector<String> umPadrao = new Vector<String>();
		String[][] arrayPadroes = new String[getLinhaFinal()][getColunaFinal()-getColunaInicial()+2];
		int contadorLinhas = 0;
		int contadorColunas = 0;
		while ((linha = arqDados.readLine())!=null){
			contadorLinhas+=1;
			if (getLinhaInicial()<=contadorLinhas && contadorLinhas<=getLinhaFinal()){
				StringTokenizer t = new StringTokenizer(linha,separadorColuna);
				if (t.countTokens() < getColunaFinal())
					setColunaFinal(t.countTokens()-1);
				contadorColunas = 0;
				while (t.hasMoreTokens()){
					if (contadorColunas>=getColunaInicial() && contadorColunas<=getColunaFinal())
						umPadrao.add(t.nextToken());
					else if (contadorColunas==getColunaClasse())
						umPadrao.add(t.nextToken());
					else
						t.nextToken();
					contadorColunas+=1;
				}
				for (int i=0;i<umPadrao.size();i++){
					arrayPadroes[contadorLinhas-1][i]=umPadrao.elementAt(i);
				}
				umPadrao.removeAllElements();
			}
		}
		arqDados.close();
		return arrayPadroes;
	}

	public void setArquivo(String umArquivo) throws Exception {
		this.nomeArquivo = umArquivo;
	}
	
	public void setSeparadorColuna(String umSeparadorColuna) throws Exception {
		this.separadorColuna = umSeparadorColuna;
	}
	
	public void setColunaInicial(int umaColunaInicial) throws Exception {
		if (umaColunaInicial>0)
			this.colunaInicial = umaColunaInicial-1;
		else
			this.colunaInicial = 0;
	}
	
	public int getColunaInicial() throws Exception {
		return this.colunaInicial;
	}

	public void setColunaFinal(int umaColunaFinal) throws Exception {
		this.colunaFinal = umaColunaFinal-1;
	}

	public int getColunaFinal() throws Exception {
		return this.colunaFinal;
	}

	public void setLinhaInicial(int umaLinhaInicial) throws Exception {
		if (umaLinhaInicial>0)
			this.linhaInicial = umaLinhaInicial;
		else
			this.linhaInicial = 0;
	}

	public int getLinhaInicial() throws Exception {
		return this.linhaInicial;
	}

	public int getLinhaFinal() throws Exception {
		return this.linhaFinal;
	}
	
	public void setLinhaFinal(int umaLinhaFinal) throws Exception {
		if (umaLinhaFinal<1)
			this.linhaFinal=getNumLinhasArquivo();
		else
			this.linhaFinal = umaLinhaFinal;
	}

	public void setColunaClasse(int umaColunaClasse) throws Exception {
		if (umaColunaClasse>0)
			this.colunaClasse = umaColunaClasse-1;
		else
			this.colunaClasse = 0;
	}

	public int getColunaClasse() throws Exception {
		return this.colunaClasse;
	}
	
}
