/* Essa e a classe principal, ela possui a maioria do metodos
 * usados pelo genetico, ela tambem possui 2 ArrayList que
 * guardam as populaes
 *  
 *  Verso 2.0 24/06/07 12:32 Hrs
 * 
     * By: Oslei Taborda Ribas
 */


package jorfinder.business;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import jorfinder.information.GabaritoVO;
import jorfinder.information.NotaVO;
import jorfinder.information.ORFCodonVO;
import jorfinder.information.ORFVO;
import jorfinder.log2java.Logger;
import jorfinder.persistence.GabaritoDAO;
import jorfinder.persistence.GabaritoORFDAO;
import jorfinder.persistence.NotaDAO;
import jorfinder.persistence.ORFCodonDAO;
import jorfinder.persistence.ORFDAO;
import jorfinder.util.UniqueException;
import jorfinder.view.GraficoFORM;
import org.apache.commons.math.stat.descriptive.DescriptiveStatistics;

// Clase implemente Runnable para poder trabalhar com Thread
public class AlgoritmoGeneticoBO implements Runnable{

        public static Logger log = new Logger(AlgoritmoGeneticoBO.class.getName());
	private int qtdeMutacao;
	private int qtdeCrossover;
	private int qtdeElitismo ;
	private int qtdeGeracoes ;
	private int tamPopulacao ;
        private int geracaoAtual;
        private int percenElitismo;
        private int percenMutacao;
	private boolean diferenciarProteina;
	private boolean pararProcessamento = false;
        private boolean killThread = false;
        private double notaDoMelhorIndividuo;
	private ArrayList<CromossomoBO> populacao1;
        private ORFVO orf1;
        private ORFVO orf2;
	private ArrayList<CromossomoBO> populacao2;
	private byte[] arrayCodonOrf1;
	private byte[] arrayCodonOrf2;
	private byte[] traducaoOrf1ComGabarito;
	private byte[] traducaoOrf2ComGabarito;
        private byte[] melhorIndividuo;
	private Calendar dataInicioProcessamento;
	private Calendar dataFimProcessamento;
        //expoente utilizado no sorteio pseudo aleatrio de um nmero entre 0 e o total da populao
        private static final double expoenteSorteio = 1.4;
	
       
        /*
         * Contrutor 
         */        
        public AlgoritmoGeneticoBO(){}

        
        public void setValueObjects(GabaritoVO gab, ORFVO orf){
                
                log.info("Passando valores para o algoritmo genetico, passando apenas uma orf");
                diferenciarProteina = false;
                
            	tamPopulacao = gab.getPopulacao();
                qtdeGeracoes = gab.getGeracoes();
                percenElitismo = gab.getElitismo();
                percenMutacao = gab.getMutacao();
		qtdeElitismo = ((tamPopulacao * gab.getElitismo()) / 100);		
		qtdeMutacao = ((tamPopulacao * gab.getMutacao()) / 100);
		qtdeCrossover = tamPopulacao - (qtdeMutacao + qtdeElitismo);
		populacao1 = new ArrayList<CromossomoBO>(tamPopulacao);
		populacao2 = new ArrayList<CromossomoBO>(tamPopulacao);
                
                this.orf1 = ORFDAO.getObjetoByUnique(orf);
                arrayCodonOrf1 = this.getArrayCodon(orf1);
		traducaoOrf1ComGabarito = new byte[arrayCodonOrf1.length];
		
        }
        
        public void setValueObjects(GabaritoVO gab, ORFVO orfNum1, ORFVO orfNum2){
                
                log.info("Passando valores para o algoritmo genetico, passando duas orf's");
                diferenciarProteina = true;
                
                tamPopulacao = gab.getPopulacao();
                qtdeGeracoes = gab.getGeracoes();
                percenElitismo = gab.getElitismo();
                percenMutacao = gab.getMutacao();
		qtdeElitismo = ((tamPopulacao * gab.getElitismo()) / 100);
		qtdeMutacao = ((tamPopulacao * gab.getMutacao()) / 100);
		qtdeCrossover = tamPopulacao - (qtdeMutacao + qtdeElitismo);
                
		populacao1 = new ArrayList<CromossomoBO>(tamPopulacao);
		populacao2 = new ArrayList<CromossomoBO>(tamPopulacao);
                
                this.orf1 = ORFDAO.getObjetoByUnique(orfNum1);
                this.orf2 = ORFDAO.getObjetoByUnique(orfNum2);
                arrayCodonOrf1 = this.getArrayCodon(orf1);
		arrayCodonOrf2 = this.getArrayCodon(orf2);
		traducaoOrf1ComGabarito = new byte[arrayCodonOrf1.length];
		traducaoOrf2ComGabarito = new byte[arrayCodonOrf2.length];
            
        }   
        
        public void salvarProcessamento(String nomeGabarito, String descricaoGabarito) throws UniqueException{
            
            log.info("Salvando o processamento ");
            
            GabaritoVO gab = new GabaritoVO();
            gab.setNome(nomeGabarito);
            gab.setDescricao(descricaoGabarito);
            gab.setPopulacao(tamPopulacao);
            gab.setGeracoes(qtdeGeracoes);
            gab.setFitness(notaDoMelhorIndividuo);
            gab.setElitismo(percenElitismo);
            gab.setMutacao(percenMutacao);
            gab.setTempoProcessamento(getTempoProcessamento());
            
            GabaritoDAO.adiciona(gab);
            GabaritoVO gabComId = GabaritoDAO.getObjetoByUnique(gab);
            GabaritoORFDAO.adiciona(gabComId, orf1);
            if (diferenciarProteina)
                GabaritoORFDAO.adiciona(gabComId, orf2);
            
            NotaVO nota = new NotaVO();
            nota.setCodGabarito(gabComId.getCod());
            int codCodon = 0;
            for (byte i: melhorIndividuo){
                nota.setNota(i);
                nota.setCodCodon(codCodon);
                NotaDAO.adiciona(nota);
                codCodon++;
            }
                
            
        }
        
        public byte[] getArrayCodon(ORFVO orf){
            ArrayList<ORFCodonVO> array = ORFCodonDAO.getListaObjetoByUnique(orf);
            byte[] retorno = new byte[array.size()];
            int i = 0;
            for (ORFCodonVO oRFCodonVO: array){
                retorno[i] = (byte) oRFCodonVO.getCodCodon(); 
                i++;        
            }            
            return retorno;
        }
        

	
        // Metodos get para pegar os valores do genetico!
	

	public int getQtdeGeracoes (){
                return this.qtdeGeracoes;
	}
        
        public void killThread(){
            killThread = true;
        }
	
        public boolean isThreadWait(){
            if (!pararProcessamento) return false;
            return true;
        }
	
	// pega o gabarito do melhor individuo durante o processamento
	public byte[] getMelhorIndividuo(){            
		return melhorIndividuo;
	}
        
        public boolean isProcessamentoComDuasOrf(){
            if (diferenciarProteina) return true;
            return false;
        }
        
        public byte[] getTraducaoOrf1(){
               byte[] dadosGrafico = setTraducao(this.arrayCodonOrf1, melhorIndividuo);
               Arrays.sort(dadosGrafico);
               return  dadosGrafico;
        }
        
        public byte[] getTraducaoOrf2(){
                byte[] dadosGrafico = setTraducao(this.arrayCodonOrf2, melhorIndividuo);
               Arrays.sort(dadosGrafico);
               return  dadosGrafico;
        }
        
        public Date getTempoProcessamento(){
            
            long ini = dataInicioProcessamento.getTimeInMillis();
	    long fim = dataFimProcessamento.getTimeInMillis();
                                                
            int segundos =  (int) (fim-ini) / 1000 ;
            int minutos = (int) (fim-ini) / 1000 / 60;
            int horas = (int) (fim-ini) / 1000 / 3600;
            int dias = (int) horas / 24;            
            
            GregorianCalendar calendar3 = new GregorianCalendar();
            calendar3.set(0,0,dias,horas,minutos,segundos);
            Date retorno = calendar3.getTime();
            
            return retorno;
        }
	
	// pega a Nota do melhor individuo durante o processamento
	public double getNotaDoMelhorIndividuo(){
               return notaDoMelhorIndividuo;
		
	}
        
        public void pararProcessamento(){
            pararProcessamento = true;
        }
	
        public void continuarProcessamento(){
            pararProcessamento = false;
        }

        public int getGeracaoAtual(){
            return geracaoAtual;
        }
        
	/* Esse metodo sortea um cromossomo para mutao ou crossover!
	 * como pode-se ver no est implementado est fazendo de maneira aleatorio!
	 * Fica como ToDo ento!
	 *  necessrio fazer aquele calcula q tente a retornar os melhores cromossomos
	 * os que esto com as melhores notas 
	 *
	 */
	private int getSortearCromo(){
	        return (int) (this.tamPopulacao * Math.pow(Math.random(), expoenteSorteio));
	}
	
	/* Esse metodo sortea o um bit dentro do cromossomo que vai receber mutao
	 * Esse metodo est pronto! o sorteio  de maneira aleatoria mesmo!
	 * 
	 */
	private byte getBitParaMutar(){
		return (byte) (Math.random()*64);
	}
	
	// metodo usado para mutar : )
	// metodo usado para mutao recebe um cromossomo 
	private byte[] mutar(CromossomoBO cromossomo){
		
		byte[] resultado = cromossomo.getArrayNotas();
                
                // recebe o bit para ser mutado, que  um valor de 0 a 64
                byte bitParaMutar = getBitParaMutar();
                byte valorNovo = getBitParaMutar();
                byte valorAntigo = resultado[bitParaMutar];
                // seta o novo valor
                resultado[bitParaMutar] = valorNovo;
                boolean substituido = false;
                for (int i = 0; i < bitParaMutar; i++) {
                     if((resultado[i]) == (valorNovo)){
                        resultado[i] = valorAntigo;
                        substituido = true;
                    }                    
                }
                
                if(!substituido){
                    for (int i = (bitParaMutar + 1); i < 64; i++) {
                         if((resultado[i]) == (valorNovo)){
                            resultado[i] = valorAntigo;
                        }                    
                    }
                }
                
		return resultado;
	}
	
	// metodo usado para cruzar
	private byte[] cruzar(CromossomoBO cromoPai, CromossomoBO cromoMae){
		
		// ja recebe todos os genes do Pai
		byte[] resultado = cromoPai.getArrayNotas();
                
		// guarda os genes da mae
		byte[] genesMae = cromoMae.getArrayNotas();
                    
		// recebe o local (bit) aonde vai ser o cruzamento
		byte pontoDoCruzamento = getBitParaMutar();
		
		
		// agora recebe todos os genes da Mae;
                boolean adicionar;
                int contadorDePosicao = pontoDoCruzamento;
                for (int i = 0 ; i < 64; i ++){
                        adicionar = true;
                        for(int j = 0; j < pontoDoCruzamento;j++ ){
                            if(genesMae[i] == resultado[j]){
                                adicionar = false;
                                break;
                            } 
                        }
                        if(adicionar){
                            resultado[contadorDePosicao] = genesMae[i];
                            contadorDePosicao++;
                        }
                    
		}
		    
		return resultado;
	}
	
	/* aqui ele recebe uma populao com individuos chamada de populacaoAtual
	* e outra sem nenhum individuo chamada de populacaoNova
	* ento ele pega populacaoAtual e comea a fazer crossover, mutao e elitismo
	* os novos individos so colocados na populao nova
	*/
	private void gerarNovaPopulacao(ArrayList<CromossomoBO> populacaoAtual, ArrayList<CromossomoBO> populacaoNova){
                
		// realiza o Elitismo
		for (int cromossomo = 0; cromossomo < qtdeElitismo; cromossomo++){
			populacaoNova.add(new CromossomoBO(populacaoAtual.get(cromossomo).getArrayNotas()));
                        
		}
                
                // realiza a mutao
		for (int cromossomo = 0; cromossomo < qtdeMutacao; cromossomo++){
                 	byte[] arrayDeIndividuo = mutar(populacaoAtual.get(getSortearCromo()));
                	populacaoNova.add(new CromossomoBO(arrayDeIndividuo));
		} 
                
		// realiza o Crossover
		for (int cromossomo = 0; cromossomo < qtdeCrossover; cromossomo++){
                        byte[] arrayDeIndividuo = cruzar(populacaoAtual.get(getSortearCromo()), populacaoAtual.get(getSortearCromo()));
			populacaoNova.add(new CromossomoBO(arrayDeIndividuo));
			
		}
		
		darNotaPopulacao(populacaoNova);
                
		ordenarPopulacao(populacaoNova);
		
		populacaoAtual.clear();
                
	}

	private void darNotaPopulacao(ArrayList<CromossomoBO> populacao){
            
                
		// guarda o gabarito
		byte[] gabarito;		
			
		// se tiver duas orf para calcular!
		if (diferenciarProteina){			
				// 	faz um for avaliando cada cromossomo da populao
				for (int i = 0; i < populacao.size(); i++){
					// recebe o gabarito gerado pelo cromossomo
					gabarito = populacao.get(i).getArrayNotas();
					
					// comea as tradues:
					traducaoOrf1ComGabarito = setTraducao(this.arrayCodonOrf1, gabarito);                                        
                                        traducaoOrf2ComGabarito = setTraducao(this.arrayCodonOrf2, gabarito);
                                        // fim de tradues!
					
					// agora da Nota ao cromossomo!
					populacao.get(i).setNotaIndividuo(getFitnessComDuasOrf(traducaoOrf1ComGabarito, traducaoOrf2ComGabarito));
				} 
		// faz o calcula se tiver somente uma orf!	
		} else {
			
			// 	faz um for avaliando cada cromossomo da populao
			for (int i = 0; i < populacao.size(); i++){
				// recebe o gabarito gerado pelo cromossomo
                		gabarito = populacao.get(i).getArrayNotas();
				traducaoOrf1ComGabarito = setTraducao(this.arrayCodonOrf1, gabarito);
				
				// agora da Nota ao cromossomo!
                		populacao.get(i).setNotaIndividuo(getFitnessComUmaOrf(traducaoOrf1ComGabarito));		
                	} 		
		}	
                
	}
        
        /**
         * metodo criado para facilitar a traduo q  utilizada para dar nota a populao e gerar grficos
         */ 
        public static byte[] setTraducao(byte[] arrayCodonOrf, byte[] gabarito){
            byte[] traducao = new byte[arrayCodonOrf.length];
            for (int codon = 0; codon < arrayCodonOrf.length; codon++){
                traducao[codon] = gabarito[arrayCodonOrf[codon]];
            }
            return traducao;
        }



	private void ordenarPopulacao(ArrayList<CromossomoBO> populacao){
		Collections.sort(populacao);
               
        }
	/* metodo usado para calcular o fitNess  um dos metodos principais do AG
	*/
	 public static Double getFitnessComUmaOrf(byte[] traducaoDaOrf1){   
                // classe para calculos estatisticos
                DescriptiveStatistics stats = DescriptiveStatistics.newInstance();
                double somaDiferenca = 0.0;
                double difMedia;
                // adiciona os dados do array  e soma a diferena
                for( int i = 1; i < traducaoDaOrf1.length; i++) {
                        stats.addValue(traducaoDaOrf1[i]);
                        somaDiferenca += Math.abs(traducaoDaOrf1[i] - traducaoDaOrf1[i-1]);
                }
                
                difMedia  = somaDiferenca/traducaoDaOrf1.length;
                double media = stats.getMean();   
                
                float d_alta = triang((float) difMedia, (float)64);
                float d_baixa = triang((float) difMedia,(float)1);
                double fitness = (double) d_baixa/d_alta;  //Minimiza
               
                return fitness  ;                
	}
        
        public static float triang ( float x, float centro ) {
                float y, d1, d;
                d = 64;
                d1 = d + 5;
                if (x<centro)
                        y = (float) (1./d1)*(x+d1-centro);
                else
                        y = (float) (1./d1)*(-x+d1+centro);
                
                return (y);
        }
        
	/* metodo usado para calcular o fitNess  um dos metodos principais do AG
	*/
	public static Double getFitnessComDuasOrf(byte[] traducaoDaOrf1, byte[] traducaoDaOrf2){
               
                // pega a nota da 1 orf que  a que deve ser maximixada
                Double notaOrfMax = getFitnessComUmaOrf(traducaoDaOrf1);
                
                // pega a nota da 2 orf que  a que deve ser maximizada
                Double notaOrfMin = getFitnessComUmaOrf(traducaoDaOrf1);
                
                // agora maximiza e minimiza a outra
                return (notaOrfMax / (1 + notaOrfMin));		
	}
       

	private void criaPopInicial(){
		
                // limpa os array para um novo processamento
                populacao1.clear();
                populacao2.clear();

                // popula o array de populao com cromossomos                
                for (int i = 0; i < tamPopulacao; i++){
                        populacao1.add(new CromossomoBO());
                        
                }	
                
	}
	

              

	// metodo que inicia o processamento
	//  quase o metodo main : )
	public void processar(){
                
                log.info("Iniciando processamento do genetico");
		// marca a hora que inicio o processamento
		dataInicioProcessamento = new GregorianCalendar();
		// cria nova populao em baixo da nota, ordenada nova populao pela nota
		// e incrementa o contador de populao
		criaPopInicial();
		darNotaPopulacao(populacao1);
		ordenarPopulacao(populacao1);
                geracaoAtual = 1;                
                notaDoMelhorIndividuo = populacao1.get(0).getNotaIndividuo();
                melhorIndividuo = populacao1.get(0).getArrayNotas();
		
		/**
                 * Abaixo ocorre o processamento do algoritmo gentico prpriamente dito
                 * Enquanto no exceder o nmero de geraoes estipulado o loop continua.
                 * No meio do loop, alm de gerar populaes dois atributos so atualizados 
                 * simultaneamente: notaAtual do melhor indivduo e geraao atual que utilizada pela
                 * classe BarraProgresso para atualizar a barra atrvs de threads.
                 */
                
		while ((geracaoAtual < qtdeGeracoes) && (!killThread))    {
                        
                        gerarNovaPopulacao(populacao1, populacao2);
                        geracaoAtual++;
                        
                        // alimenta a nota atual e tambem o melhor individuo;
                        if ((geracaoAtual % 30) == 0){
                                int i = (int) populacao2.get(0).getNotaIndividuo();                                
                                notaDoMelhorIndividuo = populacao2.get(0).getNotaIndividuo();
                                melhorIndividuo = populacao2.get(0).getArrayNotas();
                        }
                        
                        // usado para dar um wait na Thread
                        synchronized (this) {
                            while (pararProcessamento) {
                                try {
                                    notaDoMelhorIndividuo = populacao2.get(0).getNotaIndividuo();
                                    melhorIndividuo = populacao2.get(0).getArrayNotas();
                                    dataFimProcessamento = new GregorianCalendar();		
                                    wait();
                                } catch (Exception ex) {
                                    log.exception("erro ao dar um wait na Thread", ex);
                                }
                            }
                        }
                        
                        
                        if (geracaoAtual < qtdeGeracoes){	
                        
                                gerarNovaPopulacao(populacao2, populacao1);
				geracaoAtual++;                                                     
			}  
                        
		}
                
                killThread = false;
		
                if (populacao1.isEmpty()){
                        notaDoMelhorIndividuo = populacao2.get(0).getNotaIndividuo();
                        melhorIndividuo = populacao2.get(0).getArrayNotas();
                }else {
                        notaDoMelhorIndividuo = populacao1.get(0).getNotaIndividuo();
                        melhorIndividuo = populacao1.get(0).getArrayNotas();
                }
                                
                // marca a hora que terminou o processamento	
		dataFimProcessamento = new GregorianCalendar();		
                
                log.info("Fim do processamento do genetico");
                log.info("Finalizando Thread");
	}
        
          // esse metodo  chamado quando vc d um start na thread
        public void run(){
            processar();
        }
        
                
}
