
package jorfinder.business;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedList;
import java.io.File;
import javax.swing.JOptionPane;
import jorfinder.information.ClasseVO;
import jorfinder.log2java.Logger;
import jorfinder.persistence.ClasseDAO;
import jorfinder.util.Mensagem;
import jorfinder.util.UniqueException;
import jorfinder.util.VioletionFKException;


public class ClasseBO {	
    
        public static Logger log = new Logger(ClasseBO.class.getName());
        private Mensagem msg = new Mensagem();
        
        public Mensagem getMensagem(){
            return this.msg;
        }
	public void adiciona(ClasseVO objeto) {		
                try {
                    if(ClasseDAO.getObjetoByUnique(objeto).getCod() > 0){
                        this.msg.setMsg("Erro! J existe uma Classe com este nome no banco!");
                        this.msg.setSucesso(false);                     
                    } else {
                        ClasseDAO.adiciona(objeto);
                        this.msg.setMsg("Cadastro realizado com sucesso!");
                        this.msg.setSucesso(true);
                    }                       
                } catch (jorfinder.util.UniqueException ex) {
                    this.msg.setMsg("Houve falha ao inserir o registro!");
                    this.msg.setSucesso(false);
                }   		
	}
	
	
	public void exclui(ClasseVO objeto) {		
            try {
                    ClasseDAO.exclui(objeto);      
                    this.msg.setMsg("Classe Base Excluda com sucesso!");
                    this.msg.setSucesso(true);
            } catch (VioletionFKException e) {
                    this.msg.setMsg("No foi possvel deletar esse registro porque existem outros registros que dependem dele!");
                    this.msg.setSucesso(false);
            }
        }
        public void atualiza(ClasseVO objeto) {	
            try {

                ClasseDAO.atualiza(objeto);
                this.msg.setMsg("Classe Alterada com sucesso!");
                this.msg.setSucesso(true);
            } catch (UniqueException e) {
                this.msg.setMsg("No foi possvel atualizar esta classe!");
                this.msg.setSucesso(false);
            }
        }
          
	public ArrayList <ClasseVO> getListaObjeto(){
		return ClasseDAO.getListaObjeto();
	}
        
        public String[] getStringArrayNome(){		
                ArrayList<ClasseVO> lista = ClasseDAO.getListaObjeto();
                String[] nomes = new  String[lista.size()] ;
                for(int cont = 0; cont < lista.size(); cont++){
                    nomes[cont] = lista.get(cont).getNome();
                }                
                return nomes;
	}        
        public ClasseVO getUltimoCadastrado(){
            ArrayList <ClasseVO> lista = getListaObjeto();
            return lista.get(lista.size() - 1);
        }

}
