/* O CromossomoBO (Individuo),  uma soluo para o problema
 * ele  composto de 64 genes que juntos propoem um conjunto
 * de valores para a soluo do genetico(Gabarito). Essa classe est guardando
 * os genes em dois Array's, um ordenado e outro no cada um  utilizado
 * em determinadas operaes, embora seja possvel fazer tudo isso 
 * com um nico array, foi colocado dois para obter uma performance melhor
 * e no precisar ficar ordenando e desordenando dependendo da operao
 * que fosse realizada, no existe nenhuma perda de desempenho 
 * ou aumento significativo no uso da memoria, nesse modelo
 * de 2 arrays 
 * 
 * Verso 1.0 - 24/06/07 - 02:02 hrs
 * By: Oslei Taborda Ribas
 *
 */

package jorfinder.business;

/* Essa classe implementa a interface Comparable para que possamos usar a
 * Collections.Sort() para ordenar os cromossomos na classe algoritmo genetico
 * 
 */
public class CromossomoBO implements Comparable <CromossomoBO>{
	
		private double notaDoIndividuo;
		private byte[] gabarito;
		
		/* Esse  construtor principal! Ele  usado somente uma vez em todo o codigo
		 * que  quando criamos a populao inicial, nesse momento criamos um cromossomo
		 * usando esse construtor, o que ele  faz  criar um cromossomo, popula-lo com
		 * em seguida ordenado os valor aleatorios dentro do array valorAleatorioOrdenado;
		 * ou seja o cromossomo j fica pronto para pegar os valores do codon e receber
		 * a nota individuo
		 * 
		 */
		public CromossomoBO(){
			
			gabarito = new byte[64];
			
			// gerar os valores iniciais dos codons onde aaa=0... ttt=63
			// so 64 valores
			for (byte i = 0; i < gabarito.length; i++){
				gabarito[i] = i;
			}
			
			
			
		}
		
		/* Esse  construtor secundrio! Ele  usado em operaes de crossover e mutao
		 * o que ele faz  receber como parametro um valorAleatorioPopulado j populado, ou seja,
		 * o resultado de um cromossomo que acabou de receber uma mutao ou um cromossomo que nasceu
		 * de um crossover! Ele recebe ento o valorAleatorioPopulado, e ordena ele! O valor ordenado
		 * fica em  valorAleatorioOrdenado, 
		 * 
		 */
		public CromossomoBO(byte[] gabarito){
			
			this.gabarito = gabarito;
					
		}
                
                
		public void setNotaIndividuo(double notaDoIndividuo){
			this.notaDoIndividuo = notaDoIndividuo;
		}
		
		public double getNotaIndividuo(){
			return notaDoIndividuo;
		}
		
		public byte[] getArrayNotas(){
			return gabarito.clone(); 
		}
		
		
              /* Esse metodo  da interface comparable O criterio para ordenao  valor
		* da NotaDoIndividuo, o individuo com maior nota fica por 1 o com pior fica
		* por ultimo! dentro do ArrayList na classe AlgoritmoGenetico. 
		*/
		public int compareTo(CromossomoBO cromossomo1){
			if (this.notaDoIndividuo < cromossomo1.getNotaIndividuo()){
				return 1;
			}
			if (this.notaDoIndividuo > cromossomo1.getNotaIndividuo()){
				return -1;
			}
			return 0;
			
		}
                

	
}
