

/*
 * ORFBaseTableModel.java
 *
 * Created on 31 de Julho de 2007, 17:25
 *
 * By: Oslei Taborda Ribas
 */

package jorfinder.swingModel;

import java.util.ArrayList;
import jorfinder.business.ORFBO;
import jorfinder.information.ClasseVO;
import jorfinder.information.ORFVO;
import jorfinder.log2java.Logger;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author oeslei
 */
public class AlgGeneticoTableModel extends AbstractTableModel{
    
    public static Logger log = new Logger(ORFBaseTableModel.class.getName());
    private ORFBO orfbo;
    private String[] titulo;
    private ArrayList <String[]> arrayRegistros;
    /** Creates a new instance of ORFBaseTableModel */
    public AlgGeneticoTableModel(ArrayList<ORFVO> array, ORFBO orfbo) {

        this.orfbo = orfbo;
        arrayRegistros = new ArrayList <String[]>();
        titulo = new String[] {"Nome", "Tamanho", "Observacao", "Classe"};
        
        for (ORFVO orf: array){
            arrayRegistros.add(new String[] {orf.getNome(), String.valueOf(ORFBO.getTotalCodonORF(orf)), orf.getDescricao(), orf.getClasse().getNome(), orf.getTipo()});            
        }
    }
    
    
    public AlgGeneticoTableModel(ORFBO orfbo) {
        this.orfbo = orfbo;
        arrayRegistros = new ArrayList <String[]>();
        titulo = new String[] {"Nome", "Tamanho", "Observacao", "Classe"};
    }
    
     public void adicionarORFBase(ORFVO orfvo){         
         ORFVO orf = orfbo.getORFVO(orfvo);
         arrayRegistros.add(new String[] {orf.getNome(), String.valueOf(orfbo.getTotalCodonORF(orf)), orf.getDescricao(), orf.getClasse().getNome(), orf.getTipo()});
         this.fireTableRowsInserted(arrayRegistros.size() -1, arrayRegistros.size() - 1 );
        
    }
    

    public int getRowCount() {
        
        return arrayRegistros.size();
    }

    public int getColumnCount() {
        return titulo.length;
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
         // Obtem a linha!
        String retorno = null;
        retorno = arrayRegistros.get(rowIndex)[columnIndex];
        return retorno;
    }
    
    public String getColumnName(int col){
          return titulo[col];
    }
    
    public void excluir(int linha){  
        arrayRegistros.remove(linha);
        fireTableRowsDeleted(linha,linha);
        
    } 
    
    public ORFVO getORFVOselecionada(int linha){
            ORFVO orf = new ORFVO();
            orf.setNome(arrayRegistros.get(linha)[0]);
            orf.setTipo(arrayRegistros.get(linha)[4]);
            return orf;
    }
    
}
