/*
 * ClasseTableModel.java
 *
 * By: Matheus Rosendo
 */

package jorfinder.swingModel;

import java.util.ArrayList;
import javax.swing.JOptionPane;
import jorfinder.business.ClasseBO;
import jorfinder.information.ClasseVO;
import jorfinder.information.ClasseVO;
import jorfinder.log2java.Logger;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author matheus
 */
public class ClasseTableModel extends AbstractTableModel{
    
    public static Logger log = new Logger(ClasseTableModel.class.getName());
    private ClasseBO classebo;
    private String[] titulo;
    private ArrayList<ClasseVO> arrayRegistros;

    /** Creates a new instance of ClasseTableModel */
    public ClasseTableModel(ClasseBO classebo) {
        this.classebo = classebo;
        this.setArrayRegistros(this.classebo.getListaObjeto());
        titulo = new String[] {"Classe"};
    }
        
     public void adicionarClasse(ClasseVO classevo){         
         this.classebo.adiciona(classevo);   
         JOptionPane.showMessageDialog(null, this.classebo.getMensagem().getMsg(), this.classebo.getMensagem().getTitulo(), this.classebo.getMensagem().getTipoMensagem());
         if(this.classebo.getMensagem().isSucesso()){
             this.arrayRegistros.add(this.classebo.getUltimoCadastrado());
             this.fireTableRowsInserted(this.arrayRegistros.size(), this.arrayRegistros.size());
         } 
     }
    

    public int getRowCount() {
        return getArrayRegistros().size();
    }

    public int getColumnCount() {
        return titulo.length;
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
         // Obtem a linha!
        String retorno = null;
        ClasseVO ClasseVO = getArrayRegistros().get(rowIndex);
        switch (columnIndex) {
            case 0:            
                retorno = ClasseVO.getNome();
                break;
        }
        return retorno;
    }
    
    public String getColumnName(int col){
          return titulo[col];
    }
    
    public void excluir(int linha){  

        this.classebo.exclui(arrayRegistros.get(linha));
        JOptionPane.showMessageDialog(null, this.classebo.getMensagem().getMsg(), this.classebo.getMensagem().getTitulo(), this.classebo.getMensagem().getTipoMensagem());
        if(this.classebo.getMensagem().isSucesso()){
             this.arrayRegistros.remove(linha);
             fireTableRowsDeleted(linha, this.arrayRegistros.size());  
        } 
    } 

    public ArrayList<ClasseVO> getArrayRegistros() {
        return arrayRegistros;
    }

    public void setArrayRegistros(ArrayList<ClasseVO> arrayRegistros) {
        this.arrayRegistros = arrayRegistros;
    }

    public ClasseVO getClasseVOselecionada(int linha) {
       return arrayRegistros.get(linha);
    }

    public void alterar(ClasseVO ClasseVO, int linha) {

        this.classebo.atualiza(ClasseVO);
        JOptionPane.showMessageDialog(null, this.classebo.getMensagem().getMsg(), this.classebo.getMensagem().getTitulo(), this.classebo.getMensagem().getTipoMensagem());
        if(this.classebo.getMensagem().isSucesso()){
            this.arrayRegistros.set(linha, this.classebo.getUltimoCadastrado());
            fireTableRowsUpdated(linha, linha);
        }        
    }
}
