/*
 * NovoClass.java
 *
 * Criado em 22 de Julho de 2007, 14:15
 *
 */

package jorfinder.swingModel;


import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;
import jorfinder.log2java.Logger;

/**
 *
 * @author Marcelo Moreira Mendes
 */
public class GabaritoTableModel extends AbstractTableModel {
   
    public static Logger log = new Logger(GabaritoTableModel.class.getName());
    private ArrayList<String[]> listaElementos=null;
    private String[] nomeColunas=null;
    
    
    public GabaritoTableModel(ArrayList<String[]> listaElementos, String[] nomeColunas){        
        setListaElementos(listaElementos);
        setNomeColunas(nomeColunas);
        
    }
    
    public void setListaElementos (ArrayList<String[]> listaElementos){        
         this.listaElementos=listaElementos;
    }
    
    public void setNomeColunas(String[] nomeColunas){        
        this.nomeColunas=nomeColunas;
    }
    
    public ArrayList<String[]> getListaElementos(){       
       return listaElementos;
    }
    
    public String[] getNomeColunas(){
         return nomeColunas;
    }
    
    public int getRowCount(){    
       return getListaElementos().size(); 
    }
    
    public int getColumnCount(){        
        return getNomeColunas().length;
    }
    
    
    /*
     * Preenche os campos da tabela com o conteudo dos objetos 
     */
    public Object getValueAt(int rowIndex, int columnIndex) {
         String[] elemento =null;
         if(listaElementos.size()>0)
         {    
            elemento=listaElementos.get(rowIndex);
            return elemento[columnIndex];
         
         }
         return elemento;
    }
    
    /*
     * Seta os nomes da colunas  na tabela
     */
    
     public String getColumnName(int col) {
          return getNomeColunas()[col];
    }
      
    public boolean excluir(int linha, int coluna) {
        String codigo;
        String[] elemento;
        codigo=Integer.toString(linha);
        
        for(int i=0; i<listaElementos.size();i++)
        {
           elemento = (String[])listaElementos.get(i); 
           if(elemento[coluna].equals(codigo))
           {
               listaElementos.remove(i);
               fireTableRowsDeleted(linha,linha);
               return true;
        
           }  
            
        }    
       
        return false;
    }  
     
  
}
