/*
 * ORFBaseTableModel.java
 *
 * Created on 31 de Julho de 2007, 17:25
 *
 * By: Oslei Taborda Ribas
 */

package jorfinder.swingModel;

import java.util.ArrayList;
import javax.swing.JOptionPane;
import jorfinder.business.ORFBO;
import jorfinder.information.ClasseVO;
import jorfinder.information.ORFVO;
import jorfinder.log2java.Logger;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author matheus
 */
public class ORFBaseTableModel extends AbstractTableModel{
    
    public static Logger log = new Logger(ORFBaseTableModel.class.getName());
    private ORFBO orfbo;
    private String[] titulo;
    private ArrayList<ORFVO> arrayRegistros;
    /** Creates a new instance of ORFBaseTableModel */
    public ORFBaseTableModel(ORFBO orfbo) {

        this.orfbo = orfbo;
        this.setArrayRegistros(this.orfbo.getListaObjetoORFBase());
        titulo = new String[] {"Classe", "Nome", "Descrio"};
    }
        
    public ORFBaseTableModel(ArrayList<ORFVO> arrayOrf, ORFBO orfbo) {
        this.orfbo = orfbo;
        this.setArrayRegistros(arrayOrf);
        titulo = new String[] {"Classe", "Nome", "Descrio"};
    }
    
    
     public void adicionarORFBase(ORFVO orfvo){
         orfbo.adiciona(orfvo);   
         JOptionPane.showMessageDialog(null, this.orfbo.getMensagem().getMsg(), this.orfbo.getMensagem().getTitulo(), this.orfbo.getMensagem().getTipoMensagem());
         if(this.orfbo.getMensagem().isSucesso()){
             arrayRegistros.add(this.orfbo.getUltimoCadastrado());
             fireTableRowsInserted(this.arrayRegistros.size(), this.arrayRegistros.size());
         } 
     }
    

    public int getRowCount() {
        return getArrayRegistros().size();
    }

    public int getColumnCount() {
        return titulo.length;
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
         // Obtem a linha!
        String retorno = null;
        ORFVO orfVO = getArrayRegistros().get(rowIndex);
        switch (columnIndex) {
            case 0:            
                retorno = orfVO.getClasse().getNome();
                break;
            case 1:            
                retorno = orfVO.getNome();
                break;
            case 2:            
                retorno = orfVO.getDescricao();
                break;
        }
        return retorno;
    }
    
    public String getColumnName(int col){
          return titulo[col];
    }
    
    public void excluir(int linha){  
        
        orfbo.exclui(arrayRegistros.get(linha));
        JOptionPane.showMessageDialog(null, this.orfbo.getMensagem().getMsg(), this.orfbo.getMensagem().getTitulo(), this.orfbo.getMensagem().getTipoMensagem());
        if(this.orfbo.getMensagem().isSucesso()){
             arrayRegistros.remove(linha);
             fireTableRowsDeleted(linha, this.arrayRegistros.size());  
        } 
    } 

    public ArrayList<ORFVO> getArrayRegistros() {
        return arrayRegistros;
    }

    public void setArrayRegistros(ArrayList<ORFVO> arrayRegistros) {
        this.arrayRegistros = arrayRegistros;
    }

    public ORFVO getORFVOselecionada(int linha) {
       return arrayRegistros.get(linha);
    }

    public void alterar(ORFVO orfvo, int linha) {
        
        orfbo.atualiza(orfvo);
        JOptionPane.showMessageDialog(null, this.orfbo.getMensagem().getMsg(), this.orfbo.getMensagem().getTitulo(), this.orfbo.getMensagem().getTipoMensagem());
        if(this.orfbo.getMensagem().isSucesso()){
        
            arrayRegistros.set(linha, this.orfbo.getUltimoCadastrado());
            fireTableRowsUpdated(linha, linha);
        }        
    }
}
