/*
 * ORFBaseTableModel.java
 *
 */

package jorfinder.swingModel;

import java.util.ArrayList;
import javax.swing.JOptionPane;
import jorfinder.util.Mensagem;
import jorfinder.business.ORFBO;
import jorfinder.information.ClasseVO;
import jorfinder.information.ORFVO;
import jorfinder.log2java.Logger;

import javax.swing.table.AbstractTableModel;


public class ORFTreinoTableModel extends AbstractTableModel{
    
    public static Logger log = new Logger(ORFTreinoTableModel.class.getName());
    private ORFBO orfbo;
    private String[] titulo;
    private ArrayList<ORFVO> arrayRegistros;
    /** Creates a new instance of ORFTreinoTableModel */
    public ORFTreinoTableModel(ORFBO orfbo) {
        this.orfbo = orfbo;
        this.setArrayRegistros(this.orfbo.getListaObjetoORFTreino());
        titulo = new String[] {"Classe", "Nome", "Tamanho"};
    }
    
    public Mensagem getMensagem(){
        return this.orfbo.getMensagem();
    }
    
    public void adicionarORFTreino(ORFVO orfvo){         
         this.orfbo.adiciona(orfvo);         
         if(this.orfbo.getMensagem().isSucesso()){
             this.arrayRegistros.add(this.orfbo.getUltimoCadastrado());
             this.fireTableRowsInserted(this.arrayRegistros.size(), this.arrayRegistros.size());
         }         
    }
    

    public int getRowCount() {
        return getArrayRegistros().size();
    }

    public int getColumnCount() {
        return titulo.length;
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
         // Obtem a linha!
        String retorno = null;
        ORFVO orfVO = getArrayRegistros().get(rowIndex);
        switch (columnIndex) {
            case 0:            
                retorno = orfVO.getClasse().getNome();
                break;
            case 1:            
                retorno = orfVO.getNome();
                break;
            case 2:            
                retorno = String.valueOf(ORFBO.getTotalCodonORF(orfVO));
                break;
        }
        return retorno;
    }
    
    public String getColumnName(int col){
          return this.titulo[col];
    }
    
    public void excluir(int linha){  
        
        this.orfbo.exclui(arrayRegistros.get(linha));
        if(this.orfbo.getMensagem().isSucesso()){
             this.arrayRegistros.remove(linha);
             fireTableRowsDeleted(linha, this.arrayRegistros.size());  
        }  else{
            JOptionPane.showMessageDialog(null, this.orfbo.getMensagem().getMsg(), this.orfbo.getMensagem().getTitulo(), this.orfbo.getMensagem().getTipoMensagem());
        }              
    } 

    public ArrayList<ORFVO> getArrayRegistros() {
        return arrayRegistros;
    }

    public void setArrayRegistros(ArrayList<ORFVO> arrayRegistros) {
        this.arrayRegistros = arrayRegistros;
    }

    public ORFVO getORFVOselecionada(int linha) {
       return arrayRegistros.get(linha);
    }

    public void alterar(ORFVO orfvo, int linha) {        
        
        this.orfbo.atualiza(orfvo);
        JOptionPane.showMessageDialog(null, this.orfbo.getMensagem().getMsg(), this.orfbo.getMensagem().getTitulo(), this.orfbo.getMensagem().getTipoMensagem());
        if(this.orfbo.getMensagem().isSucesso()){
            this.arrayRegistros.set(linha, this.orfbo.getUltimoCadastrado());
            fireTableRowsUpdated(linha, linha);
        }       
    }
}
