/*
 * ORFBaseTableModel.java
 *
 */

package jorfinder.swingModel;

import java.util.ArrayList;
import javax.swing.JOptionPane;
import jorfinder.util.Mensagem;
import jorfinder.business.ORFBO;
import jorfinder.information.ClasseVO;
import jorfinder.information.ORFVO;
import jorfinder.log2java.Logger;

import javax.swing.table.AbstractTableModel;


public class TabelaTreinoORFTableModel extends AbstractTableModel{
    
    public static Logger log = new Logger(ORFTreinoTableModel.class.getName());
    private ORFBO orfbo;
    private String[] titulo;
    private ArrayList<ORFVO> arrayRegistros;
    /** Creates a new instance of ORFTreinoTableModel */
    public TabelaTreinoORFTableModel(ORFBO orfbo) {
        this.orfbo = orfbo;
        this.setArrayRegistros(this.orfbo.getListaObjetoORFTreino());
        titulo = new String[] {"ndice", "Classe", "Nome", "Tamanho"};
    }
    
    public Mensagem getMensagem(){
        return this.orfbo.getMensagem();
    }

    public int getRowCount() {
        return getArrayRegistros().size();
    }

    public int getColumnCount() {
        return titulo.length;
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
         // Obtem a linha!
        String retorno = null;
        ORFVO orfVO = getArrayRegistros().get(rowIndex);
        switch (columnIndex) {
            case 0:            
                retorno = String.valueOf((rowIndex+1));
                break;
            case 1:            
                retorno = orfVO.getClasse().getNome();
                break;
            case 2:            
                retorno = orfVO.getNome();
                break;
            case 3:            
                retorno = String.valueOf(ORFBO.getTotalCodonORF(orfVO));
                break;
        }
        return retorno;
    }
    
    public String getColumnName(int col){
          return this.titulo[col];
    }
    
    public void retirar(int linha){  
             this.arrayRegistros.remove(linha);
             fireTableRowsDeleted(linha, this.arrayRegistros.size());                  
    } 

    public ArrayList<ORFVO> getArrayRegistros() {
        return arrayRegistros;
    }

    public void setArrayRegistros(ArrayList<ORFVO> arrayRegistros) {
        this.arrayRegistros = arrayRegistros;
    }

    public ORFVO getORFVOselecionada(int linha) {
       return arrayRegistros.get(linha);
    }

    public void atualizar() {        
        //primeiro limpa tudo
        for(int cont = this.arrayRegistros.size()-1; cont >=0 ; cont--){
            this.arrayRegistros.remove(cont);
            fireTableRowsDeleted(cont, this.arrayRegistros.size()); 
        }
        //depois chama todos os caboclinho de novo      
        this.setArrayRegistros(this.orfbo.getListaObjetoORFTreino());
        fireTableRowsInserted(0, this.arrayRegistros.size());
    }
}
