/*
 * ORFBaseTableModel.java
 *
 */

package jorfinder.swingModel;

import java.util.ArrayList;
import javax.swing.JOptionPane;
import jorfinder.util.Mensagem;
import jorfinder.business.TreinoBO;
import jorfinder.information.TreinoVO;
import jorfinder.log2java.Logger;
import javax.swing.table.AbstractTableModel;


public class TabelaTreinoVisualizarTableModel extends AbstractTableModel{
    
    public static Logger log = new Logger(TabelaTreinoVisualizarTableModel.class.getName());
    private TreinoBO treinoBO;
    private String[] titulo;
    private ArrayList<TreinoVO> arrayRegistros;
    
    /** Creates a new instance of ORFTreinoTableModel */
    public TabelaTreinoVisualizarTableModel(TreinoBO treinoBO){
        
        this.treinoBO = treinoBO;
        this.setArrayRegistros(this.treinoBO.getListaObjeto());
        titulo = new String[] {"Codigo","Nome","Descrio"};
    }
    

    public int getRowCount() {
        return getArrayRegistros().size();
    }

    public int getColumnCount() {
        return titulo.length;
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
         // Obtem a linha!
        String retorno = null;
        TreinoVO treinoVO = getArrayRegistros().get(rowIndex);
        switch (columnIndex) {
             case 0:            
                retorno = String.valueOf(treinoVO.getCod());
                break;
            case 1:            
                retorno = treinoVO.getNome();
                break;
            case 2:            
                retorno =treinoVO.getDescricao();
                break;
     
        }
        return retorno;
    }
    
    public String getColumnName(int col){
          return this.titulo[col];
    }
    
    public void retirar(int linha){  
             this.arrayRegistros.remove(linha);
             fireTableRowsDeleted(linha, this.arrayRegistros.size());                  
    } 

    public ArrayList<TreinoVO> getArrayRegistros() {
        return arrayRegistros;
    }

    public void setArrayRegistros(ArrayList<TreinoVO> arrayRegistros) {
        this.arrayRegistros = arrayRegistros;
    }

    public TreinoVO getORFVOselecionada(int linha) {
       return arrayRegistros.get(linha);
    }

    public void atualizar() {        
        //primeiro limpa tudo
        for(int cont = this.arrayRegistros.size()-1; cont >=0 ; cont--){
            this.arrayRegistros.remove(cont);
            fireTableRowsDeleted(cont, this.arrayRegistros.size()); 
        }
        //depois chama todos os caboclinho de novo      
        this.setArrayRegistros(this.treinoBO.getListaObjeto());
        fireTableRowsInserted(0, this.arrayRegistros.size());
        
        
    }
}
