/*
 * ORFBaseTableModel.java
 *
 */

package jorfinder.swingModel;

import java.util.ArrayList;
import javax.swing.JOptionPane;
import jorfinder.business.GabaritoBO;
import jorfinder.util.Mensagem;
import jorfinder.business.TreinoBO;
import jorfinder.business.TreinoORFGabaritoBO;
import jorfinder.information.GabaritoVO;
import jorfinder.information.TreinoORFGabaritoVO;
import jorfinder.information.TreinoVO;
import jorfinder.log2java.Logger;

import javax.swing.table.AbstractTableModel;


public class TreinoDetalhadaGabaritoTableModel extends AbstractTableModel{
    
    public static Logger log = new Logger(TreinoDetalhadaGabaritoTableModel.class.getName());
    private TreinoORFGabaritoBO treinoORFGabaritoBO =new TreinoORFGabaritoBO();
    private String[] nomeColunas;
    private GabaritoVO gabaritoVO = new GabaritoVO();
    private GabaritoBO gabaritoBO =new GabaritoBO();
    private ArrayList<GabaritoVO> arrayRegistros = new ArrayList();
    private ArrayList<GabaritoVO> arrayGabaritoVO = new ArrayList();
    private TreinoORFGabaritoVO treinoORFGabaritoVO = new TreinoORFGabaritoVO();
    private ArrayList<TreinoORFGabaritoVO> arrayTreinoORFGabarito;
    private boolean achou;
    
    /** Creates a new instance of ORFTreinoTableModel */
    
    public TreinoDetalhadaGabaritoTableModel(TreinoVO treinoVO) 
    {
        
        arrayTreinoORFGabarito = treinoORFGabaritoBO.getTreinoUsaCodTreino(treinoVO);
        for(int i=0;i< arrayTreinoORFGabarito.size();i++ ){
                 
                   treinoORFGabaritoVO=arrayTreinoORFGabarito.get(i);
                   gabaritoVO.setCod(treinoORFGabaritoVO.getCodGabarito());                  
                   gabaritoVO = gabaritoBO.getObjetoByUnique(gabaritoVO);              
                   arrayGabaritoVO.add(this.gabaritoVO);
                 
        }   
        
        
        this.setArrayRegistros(this.arrayGabaritoVO);
        nomeColunas = new String[] {"Codigo","Nome","Descrio","Geraes","Mutaes(%)","Processamento","Populao","Elitismo","Fitness"};    
    }   
    

    public int getRowCount() {
        return getArrayRegistros().size();
    }

    public int getColumnCount() {
        return nomeColunas.length;
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
         // Obtem a linha!
        String retorno = null;
        GabaritoVO gabaritoVO = getArrayRegistros().get(rowIndex);
        switch (columnIndex) 
        {
             case 0:            
                retorno = String.valueOf(gabaritoVO.getCod());
                break;
            case 1:            
                retorno =gabaritoVO.getNome();
                break;
            case 2:            
                retorno =gabaritoVO.getDescricao();
                break;
            case 3:            
                retorno =String.valueOf(gabaritoVO.getGeracoes());
                break;
            case 4:            
                retorno =String.valueOf(gabaritoVO.getMutacao());
                break;
               
             case 5:            
                retorno =String.valueOf(gabaritoVO.getTempoProcessamento());
                break;
             case 6:            
                retorno =String.valueOf(gabaritoVO.getPopulacao());
                break;
                
             case 7:            
                retorno =String.valueOf(gabaritoVO.getElitismo());
                break;    
              case 8:            
                retorno =String.valueOf(gabaritoVO.getFitness());
                break;     
                
        }
        return retorno;
    }
    
    public String getColumnName(int col){
          return this.nomeColunas[col];
    }
    
    public void retirar(int linha){  
             
             this.arrayRegistros.remove(linha);
             fireTableRowsDeleted(linha, this.arrayRegistros.size());                  
    } 

    public ArrayList<GabaritoVO> getArrayRegistros() {
        return arrayRegistros;
    }

    public void setArrayRegistros(ArrayList<GabaritoVO> arrayRegistros) {
        this.arrayRegistros = arrayRegistros;
    }

    public GabaritoVO getORFVOselecionada(int linha) {
       return arrayRegistros.get(linha);
    }

    public void atualizar(){        
        
        //primeiro limpa tudo
        for(int cont = this.arrayRegistros.size()-1; cont >=0 ; cont--){
            this.arrayRegistros.remove(cont);
            fireTableRowsDeleted(cont, this.arrayRegistros.size()); 
        }
        //depois chama todos os caboclinho de novo      
        this.setArrayRegistros(this.arrayGabaritoVO);
        fireTableRowsInserted(0, this.arrayRegistros.size());
   
  
        
        
    }
}
