/*
 * TreinoDetalhadaORFTableModel.java
 *
 * Criado em 12 de Outubro de 2007, 18:02
 *
 * Para mudar este modelo, escolha Ferramentas | Gerenciador de Modelos
 * e abra o modelo no editor.
 */

package jorfinder.swingModel;

import java.util.ArrayList;
import javax.swing.JOptionPane;
import jorfinder.business.GabaritoBO;
import jorfinder.util.Mensagem;
import jorfinder.business.ORFBO;
import jorfinder.business.TreinoBO;
import jorfinder.business.TreinoORFGabaritoBO;
import jorfinder.information.GabaritoVO;
import jorfinder.information.ORFVO;
import jorfinder.information.TreinoORFGabaritoVO;
import jorfinder.information.TreinoVO;
import jorfinder.log2java.Logger;

import javax.swing.table.AbstractTableModel;


public class TreinoDetalhadaORFTableModel extends AbstractTableModel{
    
    public static Logger log = new Logger(TreinoDetalhadaORFTableModel.class.getName());
    private TreinoORFGabaritoBO treinoORFGabaritoBO =new TreinoORFGabaritoBO();
    private String[] nomeColunas;
    private ORFVO orfVO = new ORFVO();
    private ORFBO orfBO =new ORFBO();
    private ArrayList<ORFVO> arrayRegistros = new ArrayList();
    private ArrayList<ORFVO> arrayORFVO = new ArrayList();
    private TreinoORFGabaritoVO treinoORFGabaritoVO = new TreinoORFGabaritoVO();
    private ArrayList<TreinoORFGabaritoVO> arrayTreinoORFGabarito;
   
    
    /** Creates a new instance of ORFTreinoTableModel */
    
    public TreinoDetalhadaORFTableModel(TreinoVO treinoVO){     
        
        this.arrayTreinoORFGabarito=treinoORFGabaritoBO.getTreinoUsaCodTreino1(treinoVO);
        for(int i=0;i< arrayTreinoORFGabarito.size();i++ ){
                 
                   this.treinoORFGabaritoVO=arrayTreinoORFGabarito.get(i);
                   this.orfVO.setCod(treinoORFGabaritoVO.getCodORF());
                   this.orfVO=this.orfBO.getORFVO(orfVO);
              
                   this.arrayORFVO.add(this.orfVO);
              
        }   
        
        
        this.setArrayRegistros(this.arrayORFVO);
        nomeColunas = new String[] {"Classe", "Nome", "Tamanho"};    
    }   
    

    public int getRowCount() {
        return getArrayRegistros().size();
    }

    public int getColumnCount() {
        return nomeColunas.length;
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
         // Obtem a linha!
        String retorno = null;
        ORFVO orfVO = getArrayRegistros().get(rowIndex);
        switch (columnIndex) 
        {
             case 0:            
                retorno = orfVO.getClasse().getNome();
                break;
            case 1:            
                retorno = orfVO.getNome();
                break;
            case 2:            
                retorno = String.valueOf(ORFBO.getTotalCodonORF(orfVO));
                break;
                
        }
        return retorno;
    }
    
    public String getColumnName(int col){
          return this.nomeColunas[col];
    }
    
    public void retirar(int linha){               
             this.arrayRegistros.remove(linha);
             fireTableRowsDeleted(linha, this.arrayRegistros.size());                  
    } 

    public ArrayList<ORFVO> getArrayRegistros() {
        return arrayRegistros;
    }

    public void setArrayRegistros(ArrayList<ORFVO> arrayRegistros) {
        this.arrayRegistros = arrayRegistros;
    }

    public ORFVO getORFVOselecionada(int linha) {
       return arrayRegistros.get(linha);
    }

    public void atualizar(){        
        
        //primeiro limpa tudo
        for(int cont = this.arrayRegistros.size()-1; cont >=0 ; cont--){
            this.arrayRegistros.remove(cont);
            fireTableRowsDeleted(cont, this.arrayRegistros.size()); 
        }
        //depois chama todos os caboclinho de novo      
        this.setArrayRegistros(this.arrayORFVO);
        fireTableRowsInserted(0, this.arrayRegistros.size());
   
  
        
        
    }
}

