/*
 * ValidadorJTextFieldModel.java
 *
 * Created on 27 de Julho de 2007, 00:26
 *
 * By: Oslei Taborda Ribas
 */
package jorfinder.swingModel;

import javax.swing.text.*;
/**
 *
 * @author oeslei
 */
public class ValidadorJTextFieldModel extends PlainDocument {

	private static final long serialVersionUID = 1L;
	private int iMaxLength;
        private boolean isOnlyNumber;
  
     public ValidadorJTextFieldModel(int limiteCaracteres, boolean somenteNumero){
             super();
             iMaxLength = limiteCaracteres;
             isOnlyNumber = somenteNumero;
         }

     public void insertString(int offset, String str, AttributeSet attr)throws BadLocationException    {
         // verifica se a entrada no  nula
         if ((str == null) || (!(IsInputOK(str)))) return;
          
         if (iMaxLength <= 0 )        
         {
             
             super.insertString(offset, str, attr);
             return;
         }
 
         int ilen = (getLength() + str.length());
         if (ilen <= iMaxLength )    // se o comprimento final for menor...
             super.insertString(offset, str, attr);  
            
            // necessario para ficar bacana o ctrl+c ctrl+v
         else{
        	 if (getLength() == iMaxLength) return;  // nada a fazer
                                                    
        	          String newStr = str.substring(0, (iMaxLength - getLength())); 
                          super.insertString(offset, newStr, attr);
                          }
         	
         }
 
     private boolean IsInputOK(String str){
         if (!(isOnlyNumber))
             return true;
         int number;
         try{
             number = Integer.parseInt(str);
             
         } catch(NumberFormatException ex){
             
             return false;
         }
         return true;
     }    
}    