package jorfinder.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import jorfinder.util.TipoFileFilter;
import jorfinder.view.PrincipalFORM;

/**Usada para gravar, ler e manipular arquivos */
public class Arquivo {
	private File arquivo; 
	private BufferedReader conteudoArq = null ;
        private int totlinhas = 0;
	/**
	 * @param tipoArquivo
	 * @see TipoFileFilter
	 */
	public Arquivo(TipoFileFilter tipoArquivo) {
            
	     int result;
	      // Mostra dialogo box onde o usuario pode escolher o arquivo para ser aberto
              JFileChooser fileChooser = new JFileChooser();
              // Permite apenas a seleco de arquivos
	      fileChooser.setFileSelectionMode( JFileChooser.FILES_ONLY);
	      fileChooser.setFileFilter(tipoArquivo);
	      fileChooser.setCurrentDirectory(new File("."));
	      result = fileChooser.showOpenDialog( null );
	     
	      //Verifica se o usuario clicou no boto  cancelar da caixa de dialogo
	      if ( result == JFileChooser.CANCEL_OPTION || result == JFileChooser.ABORT){
	    	  setArquivo(null);	    	  
	      }
	      else{ 
		      // Obtem o arquivo selecionado
		      File fileName = fileChooser.getSelectedFile();
		     
		      // Mostra erro se o nome do arquivo for invalido
		      if ( fileName == null || fileName.getName().equals( "" ) ){ 
		         JOptionPane.showMessageDialog( null,"Nome do arquivo invalido", "Erro",JOptionPane.ERROR_MESSAGE );
			     setArquivo(null);
			  } 
		      setArquivo(fileName); 
		      
		      //coloca o contedo do arquivo na memria
		      try{   		    
		 		   conteudoArq = new BufferedReader(new FileReader(getArquivo()));	      
		 	  }
		 	   		
		 	  // Se hover erro na abertura do arquivo, faz o tratamento
		 	  catch (IOException e){
		 		   JOptionPane.showMessageDialog( null,"Arquivo no pode ser aberto","Erro", JOptionPane.ERROR_MESSAGE );
		 	  }
	      }
	}
	
    public void  setArquivo(File arq){
	   arquivo=arq;	  	  
    }
    
    public  File getArquivo(){
	   return arquivo;	   
    }
    
    /**
     * Conta o quantas linhas tem o arquivo
     * @return Total de linhas do arquivo
     */
    public int getTotLinhas(){
        if(this.totlinhas == 0){
            int x = 0; // guarda a quantidade de linhas da matriz
            try {   			   	
                // Faz a leitura do buffer linha por linha		        		   		    		       	           
                // calcula a quantidade de linhas e guarda em x
                   BufferedReader contarq = new BufferedReader(new FileReader(getArquivo()));
                while ((contarq.readLine()) != null) 		        {
                        x++;		        		        		        	
                }
                // Fecha o arquivo
                contarq.close();			  

            // Se hover erro na abertura do arquivo, faz o tratamento
            }catch (IOException e) {
                   JOptionPane.showMessageDialog( null,"Arquivo no pode ser aberto","Erro", JOptionPane.ERROR_MESSAGE );
            }  
            this.totlinhas = x;
            return x;
        } else {
            return this.totlinhas;
        }
    }	

    public BufferedReader getConteudoArquivo(){
    	return conteudoArq;
    }
}
