/*
 * ORFBase.java
 *
 * Created on 6 de Junho de 2007, 11:28
 *
 * By: Oslei Taborda Ribas
 */

package jorfinder.view;

import java.util.ArrayList;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.table.TableModel;
import jorfinder.util.CellRenderer;
import jorfinder.business.ORFBO;
import jorfinder.information.ORFVO;
import jorfinder.log2java.Logger;
import jorfinder.swingModel.AlgGeneticoTableModel;


public class AlgGeneticoCarregaORFBaseFORM extends JDialog {
    
    public static Logger log = new Logger(AlgGeneticoCarregaORFBaseFORM.class.getName());
    private AlgGeneticoFORM algGeneticoFORM;
    private AlgGeneticoTableModel selecionarORFTableModel;
    /** Creates new form ORFBase */
    public AlgGeneticoCarregaORFBaseFORM(AlgGeneticoFORM owner) {
        
        super(owner, "Carregar ORF Base", true);

        algGeneticoFORM = owner;        
        ArrayList<ORFVO> arrayOrf = algGeneticoFORM.getOrfBO().getListaObjetoORFBase();
        selecionarORFTableModel = new AlgGeneticoTableModel(arrayOrf, algGeneticoFORM.getOrfBO());
        initComponents();  
        ORFBase.setDefaultRenderer(Object.class, new CellRenderer());
        this.setVisible(true);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    
    // <editor-fold defaultstate="collapsed" desc=" Cdigo Gerado ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jScrollPane1 = new javax.swing.JScrollPane();
        ORFBase = new javax.swing.JTable();
        buttonSelecionar = new javax.swing.JButton();
        buttonCancelar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setResizable(false);
        ORFBase.setModel(selecionarORFTableModel);
        jScrollPane1.setViewportView(ORFBase);

        buttonSelecionar.setText("Selecionar");
        buttonSelecionar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonSelecionarMouseClicked(evt);
            }
        });

        buttonCancelar.setText("Cancelar");
        buttonCancelar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonCancelarMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 630, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 16, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(buttonCancelar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(buttonSelecionar, javax.swing.GroupLayout.DEFAULT_SIZE, 93, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(29, 29, 29)
                        .addComponent(buttonSelecionar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(buttonCancelar))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 411, Short.MAX_VALUE)))
                .addContainerGap())
        );
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-767)/2, (screenSize.height-467)/2, 767, 467);
    }// </editor-fold>//GEN-END:initComponents

    private void buttonCancelarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonCancelarMouseClicked
        this.dispose();
    }//GEN-LAST:event_buttonCancelarMouseClicked

    private void buttonSelecionarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonSelecionarMouseClicked
        int linha = ORFBase.getSelectedRow();
        if (linha < 0) {
            String msg = "Selecione uma das ORF's Base da lista";
            JOptionPane.showMessageDialog(null,msg, "Informao", JOptionPane.INFORMATION_MESSAGE);
        } else {

            algGeneticoFORM.inserirOrfSelecionada(selecionarORFTableModel.getORFVOselecionada(linha));
            algGeneticoFORM.atualizarStatusBotoes();
            this.dispose();
        }
        
        
    }//GEN-LAST:event_buttonSelecionarMouseClicked

    

    // Declarao de variveis - no modifique//GEN-BEGIN:variables
    private javax.swing.JTable ORFBase;
    private javax.swing.JButton buttonCancelar;
    private javax.swing.JButton buttonSelecionar;
    private javax.swing.JScrollPane jScrollPane1;
    // Fim da declarao de variveis//GEN-END:variables
    

}
