/*
 * AlgGeneticoOpcoes.java
 *
 * Created on 9 de Junho de 2007, 18:15
 *
 * By: Oslei Taborda Ribas
 */

package jorfinder.view;

import javax.swing.JOptionPane;
import javax.swing.table.TableModel;
import jorfinder.business.AlgoritmoGeneticoBO;
import jorfinder.util.CellRenderer;
import jorfinder.business.ORFBO;
import jorfinder.business.GabaritoBO;
import jorfinder.information.GabaritoVO;
import jorfinder.information.ORFVO;
import jorfinder.log2java.Logger;
import jorfinder.swingModel.AlgGeneticoTableModel;
import jorfinder.swingModel.ValidadorJTextFieldModel;

/**
 *
 * @author  MaTHeuS
 */
public class AlgGeneticoFORM extends javax.swing.JDialog{
    
    public static Logger log = new Logger(AlgGeneticoFORM.class.getName());
    private AlgoritmoGeneticoBO ag;
    private ORFBO orfBO;
    private GabaritoBO gabaritoBO;
    private AlgGeneticoTableModel orfSelecionadasTableModel;
    private boolean adicionar = true;
    private boolean excluir = false;
    private boolean processar = false;
    
    /**
     * Creates new form AlgGeneticoOpcoes
     */
    public AlgGeneticoFORM(PrincipalFORM owner) {
         
        super(owner, "Algortmo Gentico", true);
        log.info("criando a janela principal do algoritmo genetico");
        ag = new AlgoritmoGeneticoBO();
        orfBO = new ORFBO();
        gabaritoBO = new GabaritoBO();
        orfSelecionadasTableModel = new AlgGeneticoTableModel(orfBO);
        initComponents();   
        ORFBase.setDefaultRenderer(Object.class, new CellRenderer());
        this.setVisible(true);        
    }

    public ORFBO getOrfBO() {
        return orfBO;
    }
    
    public AlgoritmoGeneticoBO getAlgoritmoGenetico(){
        return ag;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Cdigo Gerado ">//GEN-BEGIN:initComponents
    private void initComponents() {
        fieldElitismo = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        fieldTamPopulacao = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        fieldMutacao = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        fieldGeracoes = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        buttonAdicionar = new javax.swing.JButton();
        buttonProcessar = new javax.swing.JButton();
        buttonCancelar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        ORFBase = new javax.swing.JTable();
        buttonExcluir = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setResizable(false);
        fieldElitismo.setDocument(new ValidadorJTextFieldModel(3,true));
        fieldElitismo.setText("1");

        jLabel2.setText("Gera\u00e7\u00f5es:");

        fieldTamPopulacao.setDocument(new ValidadorJTextFieldModel(9,true));
        fieldTamPopulacao.setText("100");

        jLabel3.setText("Muta\u00e7\u00e3o(%):");

        fieldMutacao.setDocument(new ValidadorJTextFieldModel(3, true));
        fieldMutacao.setText("10");

        jLabel4.setText("Elitismo(%):");

        fieldGeracoes.setDocument(new ValidadorJTextFieldModel(9,true));

        jLabel5.setText("Tamanho da Popula\u00e7\u00e3o:");

        buttonAdicionar.setText("Adicionar");
        buttonAdicionar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonAdicionarMouseClicked(evt);
            }
        });

        buttonProcessar.setText("Processar");
        buttonProcessar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonProcessarMouseClicked(evt);
            }
        });

        buttonCancelar.setText("Cancelar");
        buttonCancelar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonCancelarMouseClicked(evt);
            }
        });

        ORFBase.setModel(orfSelecionadasTableModel);
        jScrollPane1.setViewportView(ORFBase);

        buttonExcluir.setText("Excluir");
        buttonExcluir.setEnabled(false);
        buttonExcluir.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonExcluirMouseClicked(evt);
            }
        });

        jLabel1.setText("ORFs Base");
        atualizarStatusBotoes();
        atualizarValoresFields();

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(259, 259, 259)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel3)
                                    .addComponent(jLabel5)
                                    .addComponent(jLabel4)
                                    .addComponent(jLabel2))
                                .addGap(10, 10, 10)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                        .addComponent(fieldGeracoes, javax.swing.GroupLayout.DEFAULT_SIZE, 70, Short.MAX_VALUE)
                                        .addComponent(fieldTamPopulacao)
                                        .addComponent(fieldMutacao, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addComponent(fieldElitismo, javax.swing.GroupLayout.PREFERRED_SIZE, 38, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(16, 16, 16)
                                .addComponent(buttonProcessar)
                                .addGap(19, 19, 19)
                                .addComponent(buttonCancelar))))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 602, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(32, 32, 32)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(buttonExcluir, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(buttonAdicionar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addGap(47, 47, 47))))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(6, 6, 6)
                        .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 736, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addComponent(jLabel1)
                .addGap(19, 19, 19)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(buttonAdicionar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(buttonExcluir))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(31, 31, 31)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 11, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 44, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(fieldMutacao, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(fieldElitismo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(fieldTamPopulacao, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(fieldGeracoes, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(27, 27, 27)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonProcessar)
                    .addComponent(buttonCancelar))
                .addGap(48, 48, 48))
        );
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-784)/2, (screenSize.height-434)/2, 784, 434);
    }// </editor-fold>//GEN-END:initComponents

    private void buttonExcluirMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonExcluirMouseClicked
        int linha = ORFBase.getSelectedRow();
        if (excluir) {
            if (linha < 0) {
                String msg = "Selecione uma das ORF's Base da lista para excluso";
                JOptionPane.showMessageDialog(null,msg, "Informao", JOptionPane.INFORMATION_MESSAGE);
            } else {
                    log.info("Excluindo a Orf selecionada pelo usurio do TableModel");
                    orfSelecionadasTableModel.excluir(this.ORFBase.getSelectedRow());
                    this.atualizarStatusBotoes();
            }
        }  
    }//GEN-LAST:event_buttonExcluirMouseClicked

    private void buttonProcessarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonProcessarMouseClicked
        if (excluir){
            if (this.isDadadosOK()){
                GabaritoVO gab = new GabaritoVO();

                gab.setMutacao(Integer.parseInt(fieldMutacao.getText()));
                gab.setElitismo(Integer.parseInt(fieldElitismo.getText()));
                gab.setPopulacao(Integer.parseInt(fieldTamPopulacao.getText()));
                gab.setGeracoes(Integer.parseInt(fieldGeracoes.getText()));

                if (this.ORFBase.getRowCount() == 1){
                    ORFVO orf = orfSelecionadasTableModel.getORFVOselecionada(0);
                    ag.setValueObjects(gab,orf);

                }else {
                    ORFVO orf1 = orfSelecionadasTableModel.getORFVOselecionada(0);
                    ORFVO orf2 = orfSelecionadasTableModel.getORFVOselecionada(1);
                    ag.setValueObjects(gab,orf1, orf2);

                }
                new AlgGeneticoProcessandoFORM(this);

            }
        }        
     
    }//GEN-LAST:event_buttonProcessarMouseClicked

    private void buttonCancelarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonCancelarMouseClicked
        this.dispose();
    }//GEN-LAST:event_buttonCancelarMouseClicked

    private void buttonAdicionarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonAdicionarMouseClicked
        if (adicionar) new AlgGeneticoCarregaORFBaseFORM(this);
    }//GEN-LAST:event_buttonAdicionarMouseClicked
   
    
    // Declarao de variveis - no modifique//GEN-BEGIN:variables
    private javax.swing.JTable ORFBase;
    private javax.swing.JButton buttonAdicionar;
    private javax.swing.JButton buttonCancelar;
    private javax.swing.JButton buttonExcluir;
    private javax.swing.JButton buttonProcessar;
    private javax.swing.JTextField fieldElitismo;
    private javax.swing.JTextField fieldGeracoes;
    private javax.swing.JTextField fieldMutacao;
    private javax.swing.JTextField fieldTamPopulacao;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    // Fim da declarao de variveis//GEN-END:variables
    public void atualizarStatusBotoes(){
        
        if (ORFBase.getRowCount()== 0){
            buttonExcluir.setEnabled(false);
            buttonProcessar.setEnabled(false);
            buttonAdicionar.setEnabled(true);
            excluir = false;
            processar = true;
            adicionar = true;            
                
        } else if (ORFBase.getRowCount() > 1){
            buttonExcluir.setEnabled(true);
            buttonProcessar.setEnabled(true);
            buttonAdicionar.setEnabled(false);
            excluir = true;
            processar = true;
            adicionar = false;            
        
        } else {
            buttonExcluir.setEnabled(true);
            buttonProcessar.setEnabled(true);
            buttonAdicionar.setEnabled(true);
            excluir = true;
            processar = true;
            adicionar = true;                      
        
        }
        
    }
    
    public void inserirOrfSelecionada(ORFVO orf){
        orfSelecionadasTableModel.adicionarORFBase(orf);        
    }
    
    private void atualizarValoresFields(){
        GabaritoVO gab = gabaritoBO.getUltimoGabaritoInserido();
        if (gab == null){
            
            this.fieldMutacao.setText("10");
            this.fieldElitismo.setText("1");
            this.fieldTamPopulacao.setText("100");
            this.fieldGeracoes.setText("4500");
        } else {
        
            this.fieldMutacao.setText(String.valueOf(gab.getMutacao()));
            this.fieldElitismo.setText(String.valueOf(gab.getElitismo()));
            this.fieldTamPopulacao.setText(String.valueOf(gab.getPopulacao()));
            this.fieldGeracoes.setText(String.valueOf(gab.getGeracoes()));
            
        }
                        
    }
    
    private boolean isDadadosOK(){
        if(this.ORFBase.getRowCount() < 1){
            String msg = "Voc deve adicionar no minimo uma ORF para realizar o processamento";
            JOptionPane.showMessageDialog(null,msg, "Erro", JOptionPane.ERROR_MESSAGE);            
            return false;
        }
        if (this.fieldMutacao.getText().equals("")){
            String msg = "Voc deve preencher o campo Mutao para realizar o processamento";
            JOptionPane.showMessageDialog(null,msg, "Erro", JOptionPane.ERROR_MESSAGE);      
            return false;
        }
        if (this.fieldElitismo.getText().equals("")){
            String msg = "Voc deve preencher o campo Elitismo para realizar o processamento";
            JOptionPane.showMessageDialog(null,msg, "Erro", JOptionPane.ERROR_MESSAGE);      
            return false;
        }        
        if (this.fieldTamPopulacao.getText().equals("")){
            String msg = "Voc deve preencher o campo Tamanho da Populao para realizar o processamento";
            JOptionPane.showMessageDialog(null,msg, "Erro", JOptionPane.ERROR_MESSAGE);      
            return false;
        }
        if (this.fieldGeracoes.getText().equals("")){
            String msg = "Voc deve preencher o campo Geraes para realizar o processamento";
            JOptionPane.showMessageDialog(null,msg, "Erro", JOptionPane.ERROR_MESSAGE);      
            return false;
        }
        
        int mutacao = Integer.parseInt(fieldMutacao.getText());
        int elitismo = Integer.parseInt(fieldElitismo.getText());
        int tamPopulacao = Integer.parseInt(fieldTamPopulacao.getText());
        int geracoes = Integer.parseInt(fieldGeracoes.getText());
        
        if ((mutacao + elitismo) > 100){
            String msg = "A soma dos percentuais de mutao com Elitismo no pode ser superior a 100 %";
            JOptionPane.showMessageDialog(null,msg, "Erro", JOptionPane.ERROR_MESSAGE);      
            return false;
        }
        if (tamPopulacao < 2){
            String msg = "O tamanho da populacao no pode ser menor que 2";
            JOptionPane.showMessageDialog(null,msg, "Erro", JOptionPane.ERROR_MESSAGE);      
            return false;
            
        }
        if (geracoes < 2){
            String msg = "A quantidade de geraes no deve ser menor que 2";
            JOptionPane.showMessageDialog(null,msg, "Erro", JOptionPane.ERROR_MESSAGE);      
            return false;
        }
        
        return true;
    }
}
