/*
 * ORFBaseAdicionar.java
 *
 * Created on 9 de Junho de 2007, 13:10
 *
 * By: Oslei Taborda Ribas
 */

package jorfinder.view;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;
import javax.swing.JOptionPane;
import javax.swing.JProgressBar;
import jorfinder.business.AlgoritmoGeneticoBO;
import jorfinder.view.BarraProgresso;
import jorfinder.log2java.Logger;


public class AlgGeneticoProcessandoFORM extends javax.swing.JDialog{
    
    public static Logger log = new Logger(AlgGeneticoProcessandoFORM.class.getName());
    private int statusBarra = 0;
    private Thread threadAlgoritmoGenetico;
    private Thread threadBarraDeProgresso;
    private AlgoritmoGeneticoBO ag;
    private BarraProgresso barraProgresso;
    private int percenMutacao;
    private int qtdeElitismo;
    private int qtdeGeracoes;
    private int tamPopulacao;    
    private boolean visualizarGrafico;
    private boolean salvarProcessamento;
    private boolean sair ;
    
    
    public AlgGeneticoProcessandoFORM(AlgGeneticoFORM owner) {
        super(owner, "Processando...", true);
        
        sair = false;
        ag = owner.getAlgoritmoGenetico();
        barraProgresso = new BarraProgresso(this);
        log.info("Instanciando a tela do processamento do genetico");
                    
        initComponents();    
        jProgressBar1.setMaximum(ag.getQtdeGeracoes());   
        atualizarStatusBotoes();
        this.setVisible(true);      
    }
    
    public void atualizarStatusProcessamento(){
        
        jProgressBar1.setValue(ag.getGeracaoAtual());
        labelValorNota.setText(String.valueOf(ag.getNotaDoMelhorIndividuo()));
        if(ag.getGeracaoAtual()>1){
            mostarMelhorIndividuo();
        }
        if (!threadAlgoritmoGenetico.isAlive()){            
            barraProgresso.killThread();
            jProgressBar1.setValue(ag.getQtdeGeracoes());
            log.info("A execuo do genetico chegou ao Fim!");
            buttonPlayer.setText("Processar Novamente");
            this.atualizarStatusBotoes();
            mostarMelhorIndividuo();
            
            if (!sair){
                    String msg = "O processamento do Algoritmo Genetico chegou ao fim.";
                    JOptionPane.showMessageDialog(null,msg, "Fim do processamento", JOptionPane.INFORMATION_MESSAGE);                
            }           
            
            jProgressBar1.setValue(0);
        }
        
    }
    
    public AlgoritmoGeneticoBO getAlgoritmoGenetico(){
            return ag;
    }
    

    
    // <editor-fold defaultstate="collapsed" desc=" Cdigo Gerado ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jProgressBar1 = new javax.swing.JProgressBar();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        jLabel2 = new javax.swing.JLabel();
        labelNota = new javax.swing.JLabel();
        buttonSair = new javax.swing.JButton();
        buttonPlayer = new javax.swing.JButton();
        labelValorNota = new javax.swing.JLabel();
        buttonSalvarProcessamento = new javax.swing.JButton();
        buttonVisualizarGrafico = new javax.swing.JButton();

        this.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e){
                fecharJanela();

            }
        });
        /*
        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        */
        setResizable(false);
        jProgressBar1.setMaximum(500);

        jLabel1.setText("Melhor Indiv\u00edduo");

        jTextPane1.setFont(new java.awt.Font("Courier New", 0, 11));
        jTextPane1.setEnabled(false);
        jScrollPane1.setViewportView(jTextPane1);

        jLabel2.setText("Status do Processamento");

        labelNota.setText("Nota");

        buttonSair.setText("Sair");
        buttonSair.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonSairMouseClicked(evt);
            }
        });

        buttonPlayer.setText("Iniciar processamento");
        buttonPlayer.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonPlayerMouseClicked(evt);
            }
        });

        buttonSalvarProcessamento.setText("Salvar Processamento");
        buttonSalvarProcessamento.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonSalvarProcessamentoMouseClicked(evt);
            }
        });

        buttonVisualizarGrafico.setText("Visualizar Gr\u00e1fico");
        buttonVisualizarGrafico.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                buttonVisualizarGraficoMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(138, 138, 138)
                .addComponent(buttonSalvarProcessamento)
                .addGap(65, 65, 65)
                .addComponent(buttonVisualizarGrafico)
                .addGap(65, 65, 65)
                .addComponent(buttonSair)
                .addContainerGap(173, Short.MAX_VALUE))
            .addGroup(layout.createSequentialGroup()
                .addGap(38, 38, 38)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1, 0, 0, Short.MAX_VALUE)
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jProgressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 481, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(40, 40, 40)
                        .addComponent(buttonPlayer)
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addContainerGap(584, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 477, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 62, Short.MAX_VALUE)
                        .addComponent(labelValorNota, javax.swing.GroupLayout.PREFERRED_SIZE, 145, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(22, 22, 22))))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(648, Short.MAX_VALUE)
                .addComponent(labelNota)
                .addGap(73, 73, 73))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(32, 32, 32)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addGap(26, 26, 26)
                        .addComponent(jProgressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(buttonPlayer))
                .addGap(20, 20, 20)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(labelNota)
                .addGap(10, 10, 10)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 84, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(47, 47, 47)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(buttonSalvarProcessamento)
                            .addComponent(buttonSair)
                            .addComponent(buttonVisualizarGrafico)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(28, 28, 28)
                        .addComponent(labelValorNota, javax.swing.GroupLayout.PREFERRED_SIZE, 13, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(23, Short.MAX_VALUE))
        );
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-752)/2, (screenSize.height-366)/2, 752, 366);
    }// </editor-fold>//GEN-END:initComponents

    private void buttonSalvarProcessamentoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonSalvarProcessamentoMouseClicked
        
            if (salvarProcessamento){       
                new AlgGeneticoSalvarProcessamentoFORM(this);
            }
            
    }//GEN-LAST:event_buttonSalvarProcessamentoMouseClicked

    private void buttonVisualizarGraficoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonVisualizarGraficoMouseClicked
        if (visualizarGrafico){
            if (ag.isProcessamentoComDuasOrf()){
                new GraficoFORM(this, "grfico S da ORF 1 ", "grfico S da ORF 1",  ag.getTraducaoOrf1());
                new GraficoFORM(this, "grfico S da ORF 2 ", "grfico S da ORF 2",  ag.getTraducaoOrf2());
            }else {
                new GraficoFORM(this, "grfico S da ORF", "grfico S da ORF",  ag.getTraducaoOrf1());
            }
            
        }

            
    }//GEN-LAST:event_buttonVisualizarGraficoMouseClicked
    /**
     * metodo responsvel por criar e parar as duas treads: gentico e barra de progresso
     */
    private void buttonPlayerMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonPlayerMouseClicked
        if(buttonPlayer.getText().equals("Iniciar processamento")){
            
            log.info("Iniciando o processamento, usurio clicou em Iniciar Processamento");
            buttonPlayer.setText("Parar");
            this.atualizarStatusBotoes();
            
            threadAlgoritmoGenetico = new Thread(ag);       
            threadBarraDeProgresso = new Thread(barraProgresso);            
                        
            threadAlgoritmoGenetico.start();
            threadBarraDeProgresso.start();     
            
        } else if(buttonPlayer.getText().equals("Parar")){
            
            log.info("Parando o processamento, usurio clicou em Parar");
            buttonPlayer.setText("Continuar");
            this.atualizarStatusBotoes();
            barraProgresso.setPararExecucao();
            ag.pararProcessamento();
       
                
        } else if(buttonPlayer.getText().equals("Continuar")){
            
            log.info("processando genetico novamente, usurio clicou em Continuar");
            buttonPlayer.setText("Parar");
            this.atualizarStatusBotoes();
            ag.continuarProcessamento();
            
            synchronized (ag) {
                ag.notify();
            }
            
            barraProgresso.setContinuarExecucao();
            
            synchronized (barraProgresso) {
                barraProgresso.notify();
            }
                
        } else if(buttonPlayer.getText().equals("Processar Novamente")){                                    
            
            log.info("Iniciando novo processamento, com os mesmos dados usurio clicou em Processar novamente");
            
            buttonPlayer.setText("Parar");
            this.atualizarStatusBotoes();
            
            threadAlgoritmoGenetico = new Thread(ag);       
            threadAlgoritmoGenetico.start();            
            
            threadBarraDeProgresso = new Thread(barraProgresso);            
            threadBarraDeProgresso.start();

        }
    }//GEN-LAST:event_buttonPlayerMouseClicked

    private void buttonSairMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_buttonSairMouseClicked
        fecharJanela();
    }//GEN-LAST:event_buttonSairMouseClicked



    public void setMelhorInd(String ind) {
        jTextPane1.setText(ind);
    }
    
    
    // Declarao de variveis - no modifique//GEN-BEGIN:variables
    private javax.swing.JButton buttonPlayer;
    private javax.swing.JButton buttonSair;
    private javax.swing.JButton buttonSalvarProcessamento;
    private javax.swing.JButton buttonVisualizarGrafico;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextPane jTextPane1;
    private javax.swing.JLabel labelNota;
    private javax.swing.JLabel labelValorNota;
    // Fim da declarao de variveis//GEN-END:variables
    
     public void atualizarStatusBotoes(){
        log.info("Atualizando o status (habilitado/desabilitado) dos botes");
        if(buttonPlayer.getText().equals("Iniciar processamento")){
            buttonSalvarProcessamento.setEnabled(false);
            buttonVisualizarGrafico.setEnabled(false);            
            visualizarGrafico = false;
            salvarProcessamento = false;            
            labelNota.setText("");
            labelValorNota.setText("");
                
        } else if(buttonPlayer.getText().equals("Parar")){
            buttonSalvarProcessamento.setEnabled(false);
            buttonVisualizarGrafico.setEnabled(true);
            visualizarGrafico = true;
            salvarProcessamento = false;
            labelNota.setText("Nota");
            labelValorNota.setText("");
                
        } else if(buttonPlayer.getText().equals("Continuar")){
            buttonSalvarProcessamento.setEnabled(true);
            buttonVisualizarGrafico.setEnabled(true);
            visualizarGrafico = true;
            salvarProcessamento = true;          
                
        } else if(buttonPlayer.getText().equals("Processar Novamente")){                                                
            buttonSalvarProcessamento.setEnabled(true);
            buttonVisualizarGrafico.setEnabled(true);
            visualizarGrafico = true;
            salvarProcessamento = true;          
                
        }    
        
    }
     
     private void mostarMelhorIndividuo(){
                         //mostra melhor indivduo gerado
                String texto = "";
                byte[]  ind = ag.getMelhorIndividuo();
                for (int cont = 0; cont < 64; cont++){
                  
                    if (ind[cont] < 10 ){ 
                        texto += " ";
                    }
                    texto += Byte.toString(ind[cont]) + " " ;
                    
                    if((cont + 1) % 20 == 0){
                        texto += "\n";
                    }                    
                }
                
                jTextPane1.setText(texto);
         
     }
             
     private void fecharJanela(){
         sair = true;
         
         
         if (!(this.threadBarraDeProgresso == null)){        
             // manda as Threads se matarem!
             if (threadBarraDeProgresso.isAlive()) barraProgresso.killThread();         
             // se o bicho tiver esperando = acorda o bicho para ele cometer um atentado contra a propria vida
             if (ag.isThreadWait()){
                ag.continuarProcessamento();
                synchronized (ag) {
                    ag.notify();
                }
             }
         }
         
         if (!(this.threadAlgoritmoGenetico == null)){
             if (threadAlgoritmoGenetico.isAlive()) ag.killThread();         
             // se o bicho tiver esperando = acorda o bicho para ele cometer um atentado contra a propria vida
             if (ag.isThreadWait()){
                barraProgresso.setContinuarExecucao();
                synchronized (barraProgresso) {
                    barraProgresso.notify();
                }
             }
         }
         
         dispose();
     }
}

