/*
 * BarraProgresso.java
 *
 * Created on 9 de Julho de 2007, 12:03
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package jorfinder.view;


import jorfinder.log2java.Logger;

/**
 * Utilizada dentro de uma thread durante o processamento do algoritmogentico
 * aceita um objeto da tela AlgGeneticoProcessandoFORM no construtor. Este objeto contm o atributo
 * statusBarra que  atualizado pelo algoritmo gentico e aplicado  barra de progresso por esta
 * classe
 * 
 * @author matheus
 */
public class BarraProgresso implements Runnable {
    
    public static Logger log = new Logger(BarraProgresso.class.getName());
    private AlgGeneticoProcessandoFORM telaPai;
    private boolean continuarExecucao = true;
    private boolean killThread = false;
    
    
    /** Creates a new instance of BarraProgresso */
    public BarraProgresso(AlgGeneticoProcessandoFORM param) {
        telaPai = param;
    }
    
    public void setPararExecucao(){
        continuarExecucao = false;
    }
    
    public void setContinuarExecucao(){
        continuarExecucao = true;
    }
    
    public void killThread(){
        killThread = true;
    }

    public void run() {
        startBarra();
    }    
    
    public boolean isThreadWait(){
        if (continuarExecucao) return false;
        return true;
    }
    
    private void startBarra(){

        while (!killThread){
                
                
                try {
                        Thread.sleep(100);
                    } catch (InterruptedException ex) {
                        log.exception("Erro ao tentar dar um sleep na Thread", ex);
                        
                    }            
                telaPai.atualizarStatusProcessamento();
                synchronized (this) {
                            while (!continuarExecucao) {
                                try {
                                    log.info("Executando um wait() na Thread da Barra de progresso");
                                    wait();
                                } catch (Exception e) {
                                    log.exception("Erro ao dar um wait na Thread", e);
                                }
                            }
                        }
                
                } 
                killThread = false;
                log.info("Thread da Barra de progresso sendo finalizada");
        }       
    
}
