/*
 * DadosGrafico.java
 *
 * Criado em 12 de Agosto de 2007, 11:42
 *
 * Para mudar este modelo, escolha Ferramentas | Gerenciador de Modelos
 * e abra o modelo no editor.
 */

package jorfinder.view;

import java.util.ArrayList;
import java.util.Arrays;
import jorfinder.information.GabaritoVO;
import jorfinder.information.NotaVO;
import jorfinder.information.ORFCodonVO;
import jorfinder.information.ORFVO;
import jorfinder.log2java.Logger;
import jorfinder.persistence.GabaritoDAO;
import jorfinder.persistence.NotaDAO;
import jorfinder.persistence.ORFCodonDAO;
import jorfinder.persistence.ORFDAO;


/**
 *
 * @author Marcelo Moreira Mendes
 */
public class DadosGrafico {
   
    public static Logger log = new Logger(DadosGrafico.class.getName()); 
    
   
    public DadosGrafico() { }
    
    
     private byte[] getArrayCodon(ORFVO orf){
    
            ArrayList<ORFCodonVO> array = ORFCodonDAO.getListaObjetoByUnique(ORFDAO.getObjetoByUnique(orf));
            byte[] retorno = new byte[array.size()];
            int i = 0;
            for (ORFCodonVO oRFCodonVO: array){
                retorno[i] = (byte) oRFCodonVO.getCodCodon(); 
                i++;        
            }
            
            return retorno;
        }
     
     
       public byte[] getDadosGrafico(ORFVO orfVO, GabaritoVO gabaritoVO){    
               byte[] dadosGrafico = setTraducao(getArrayCodon(orfVO), getArrayNotas(gabaritoVO));
               Arrays.sort(dadosGrafico);
               return  dadosGrafico;
        }
     
      
       public byte[] setTraducao(byte[] arrayCodonOrf, byte[] gabarito) {    
            byte[] traducao = new byte[arrayCodonOrf.length];
            for (int codon = 0; codon < arrayCodonOrf.length; codon++){
                traducao[codon] = gabarito[arrayCodonOrf[codon]];
            }
            return traducao;
            
            
        }
       
        
        private byte[] getArrayNotas(GabaritoVO gabaritoVO) {       
            ArrayList<NotaVO> array = NotaDAO.getListaObjetoByUnique(GabaritoDAO.getObjetoByUnique(gabaritoVO));
            byte[] retorno = new byte[array.size()];
            int i = 0;
            for (NotaVO notaVO: array){
                retorno[i] = (byte) notaVO.getNota(); 
                i++;        
            }
            return retorno;
        }
        
        
         public byte[] getTraducao(ORFVO orfVO, GabaritoVO gabaritoVO) {
               byte[] dadosGrafico = setTraducao(getArrayCodon(orfVO), getArrayNotas(gabaritoVO));
               return  dadosGrafico;
        }
        
     
}
 
