/*
 * ORFBaseAdicionar.java
 *
 * Created on 9 de Junho de 2007, 13:10
 */

package jorfinder.view;
import java.text.SimpleDateFormat;
import javax.swing.JDialog;
import javax.swing.JFrame;
import jorfinder.business.ClasseBO;
import jorfinder.business.GabaritoBO;
import jorfinder.business.ORFBO;
import jorfinder.information.ClasseVO;
import jorfinder.information.GabaritoVO;
import jorfinder.information.ORFVO;
import jorfinder.view.DadosGrafico;
import jorfinder.log2java.Logger;
/**
 *
 * @author  MaTHeuS
 */
public class GabaritoVisualizarFORM extends javax.swing.JDialog{
    
    /** Creates new form ORFBaseAdicionar */
    
    public static Logger log = new Logger(GabaritoVisualizarFORM.class.getName());
    private GabaritoFORM formOwner;
    private DadosGrafico dadosGraficoSBO = new DadosGrafico();
    private GabaritoVO gabaritoVO = new GabaritoVO();
    private ORFVO orf1VO =new ORFVO();
    private ORFVO orf2VO =new ORFVO();
    
    
    public GabaritoVisualizarFORM(GabaritoFORM owner,int codGabarito, int codORF1, int codORF2){
        super(owner, "Visualizar Gabarito", true);
        log.info("Criando a tela  GabaritoVisualizarFORM...... ");
        this.formOwner=owner;
        initComponents(); 
        montaTela(codGabarito, codORF1, codORF2);
        this.setVisible(true);
        
    }
    
    
    public void montaTela(int codGabarito, int codORF1, int codORF2) {
        
        log.info("Montando a tela.....");
        String tempoProc, geracoes, mutacao, elitismo, tamPopulacao, nome, descricao, fitness;
        String nome1, tipo1, classe1, descricao1;
        String nome2, tipo2, classe2, descricao2;
                
        GabaritoVO gabaritoVO = new GabaritoVO();
        ORFVO orf1VO =new ORFVO();
        ORFVO orf2VO =new ORFVO();
        ClasseVO classeORFVO = new ClasseVO();
        
        GabaritoBO gabaritoBO = new GabaritoBO();
        ORFBO orf1BO = new ORFBO();
        ORFBO orf2BO = new ORFBO();
        ClasseBO  classeORFBO= new ClasseBO();
        
        //-------------Seta os dados do gabarito------------------------------------------
        gabaritoVO.setCod(codGabarito);
        gabaritoVO=gabaritoBO.getObjetoByUnique(gabaritoVO);
        
        SimpleDateFormat sd = new SimpleDateFormat("HH:mm:ss");
        tempoProc= String.valueOf(sd.format(gabaritoVO.getTempoProcessamento()));
        geracoes=Integer.toString(gabaritoVO.getGeracoes());
        mutacao=Integer.toString(gabaritoVO.getMutacao());
        elitismo=Integer.toString(gabaritoVO.getElitismo());
        tamPopulacao=Integer.toString(gabaritoVO.getPopulacao());
        nome=gabaritoVO.getNome();
        descricao=gabaritoVO.getDescricao();
        fitness = Double.toString(gabaritoVO.getFitness());
        
        //-----------------Seta os dados da ORF1----------------------------------------
        
        if(codORF1>0){
            
            orf1VO.setCod(codORF1);
            orf1VO=orf1BO.getORFVO(orf1VO);
            classeORFVO=orf1VO.getClasse();  
            nome1=orf1VO.getNome();
            classe1=classeORFVO.getNome();
            tipo1=orf1VO.getTipo();
            descricao1=orf1VO.getDescricao();
            
             byte[] dados = new byte[dadosGraficoSBO.getDadosGrafico(orf1VO,gabaritoVO).length];
             dados=dadosGraficoSBO.getDadosGrafico(orf1VO,gabaritoVO);
              
             String conteudo="";
              for(int i=0; i<dados.length;i++){
                 conteudo += Byte.toString(dados[i])+ " ";
                 
              }    
            
             jTextPane2.setText(conteudo);
             this.orf1VO=orf1VO;
             this.gabaritoVO=gabaritoVO;
              
        }
        else{
            
            nome1="";
            classe1="";
            tipo1="";
            classe1="";
            descricao1="";
            
        }
        
        //-----------------Seta os dados da ORF2----------------------------------------
        
        if(codORF2>0){
            
            orf2VO.setCod(codORF2);
            orf2VO=orf1BO.getORFVO(orf2VO);
            
            classeORFVO=orf2VO.getClasse();
            nome2=orf2VO.getNome();
            classe2=classeORFVO.getNome();
            tipo2=orf2VO.getTipo();
            descricao2=orf2VO.getDescricao();
            
             byte[] dados = new byte[dadosGraficoSBO.getDadosGrafico(orf2VO,gabaritoVO).length];
             dados=dadosGraficoSBO.getDadosGrafico(orf2VO,gabaritoVO);
              
             String conteudo="";
              for(int i=0; i<dados.length;i++){                 
                 conteudo += Byte.toString(dados[i])+ " ";                 
              }    
            
             jTextPane1.setText(conteudo);
            
            
            this.orf2VO=orf2VO; 
            this.gabaritoVO=gabaritoVO;
           
        }
        else{
            
            nome2="";
            classe2="";
            tipo2="";
            classe2="";
            descricao2="";
            
        }
        //---------------------------Seta os JLabel-------------------------------------------
        
        //------------Label do Gabarito---------------------------
        jLabel6.setText("Tempo de Processamento: "+tempoProc);
        jLabel2.setText("Gera\u00e7\u00f5es: "+geracoes);
        jLabel3.setText("Muta\u00e7\u00e3o(%): "+mutacao);
        jLabel4.setText("Elitismo(%): "+elitismo);
        jLabel5.setText("Tamanho da Popula\u00e7\u00e3o: "+tamPopulacao);
        jLabel7.setText("Nome: "+nome);
        jLabel8.setText("Descri\u00e7\u00e3o: "+descricao);
        jLabel11.setText("Fitness: "+fitness);
        
        //------------Label da ORF1-------------------------------
        
         jLabel14.setText("Nome: "+nome1);
         jLabel19.setText("Tipo: "+tipo1);
         jLabel17.setText("Classe: "+classe1); 
         jLabel9.setText("Decri\u00e7\u00e3o: "+descricao1);
         
         //------------Label da ORF2-------------------------------
         
        jLabel16.setText("Nome: "+nome2);
        jLabel18.setText("Tipo: "+tipo2);
        jLabel15.setText("Classe: "+classe2);
        jLabel10.setText("Descri\u00e7\u00e3o: "+descricao2);
        
    
    }
    //--------------------------------------------------------------------------------------
    // <editor-fold defaultstate="collapsed" desc=" Cdigo Gerado ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jLabel2 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel12 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jSeparator2 = new javax.swing.JSeparator();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextPane2 = new javax.swing.JTextPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setResizable(false);
        jLabel2.setText("Gera\u00e7\u00f5es:");

        jLabel6.setText("Tempo de Processamento:");

        jLabel18.setText("Tipo:");

        jLabel14.setText("Nome:");

        jLabel16.setText("Nome:");

        jLabel5.setText("Tamanho da Popula\u00e7\u00e3o:");

        jLabel15.setText("Classe: ");

        jLabel20.setText("ORF 2");

        jLabel19.setText("Tipo: ");

        jLabel17.setText("Classe: ");

        jLabel12.setText("ORF 1");

        jLabel4.setText("Elitismo(%):");

        jLabel3.setText("Muta\u00e7\u00e3o(%):");

        jButton1.setText("Fechar");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton1MouseClicked(evt);
            }
        });

        jLabel7.setText("Nome:");

        jLabel8.setText("Descri\u00e7\u00e3o: ");

        jLabel9.setText("Descri\u00e7\u00e3o:");

        jLabel10.setText("Decri\u00e7\u00e3o:");

        jLabel11.setText("Fitness:");

        jButton2.setText("Visualizar Gr\u00e1fico ORF1");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                botaoVisualizarGrafORF1(evt);
            }
        });

        jButton3.setText("Visualizar Gr\u00e1fico ORF2");
        jButton3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                botaoVisualizarGrafORF2(evt);
            }
        });

        jLabel1.setText("Tradu\u00e7\u00e3o ORF 1");

        jLabel13.setText("Tradu\u00e7\u00e3o ORF2");

        jTextPane2.setEnabled(false);
        jScrollPane2.setViewportView(jTextPane2);

        jTextPane1.setEnabled(false);
        jScrollPane1.setViewportView(jTextPane1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel14)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED))
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel4)
                                    .addComponent(jLabel2)
                                    .addComponent(jLabel3)
                                    .addComponent(jLabel6)
                                    .addComponent(jLabel12))
                                .addGap(288, 288, 288)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel7)
                                    .addComponent(jLabel8)
                                    .addComponent(jLabel11)
                                    .addComponent(jLabel5))
                                .addGap(304, 304, 304))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel19)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 716, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel17, javax.swing.GroupLayout.DEFAULT_SIZE, 222, Short.MAX_VALUE)
                                .addGap(612, 612, 612))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel9)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 693, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel20)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 713, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel16)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 712, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel10)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 698, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel18)
                                    .addComponent(jLabel15))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 705, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jButton2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 598, Short.MAX_VALUE))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel1)
                                    .addComponent(jButton3)
                                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 362, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(18, 18, 18)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 363, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel13))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addComponent(jSeparator2, javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jSeparator1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 734, Short.MAX_VALUE))))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(348, 348, 348)
                        .addComponent(jButton1)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel4))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel7)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel8)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel11)))
                .addGap(16, 16, 16)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 12, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel12)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel14)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel19)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel17)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel9)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton2)
                .addGap(13, 13, 13)
                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(8, 8, 8)
                .addComponent(jLabel20)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel16)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel18)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel15)
                .addGap(8, 8, 8)
                .addComponent(jLabel10)
                .addGap(15, 15, 15)
                .addComponent(jButton3)
                .addGap(15, 15, 15)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel13))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 36, Short.MAX_VALUE)
                .addComponent(jButton1)
                .addContainerGap())
        );
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-791)/2, (screenSize.height-629)/2, 791, 629);
    }// </editor-fold>//GEN-END:initComponents

    private void botaoVisualizarGrafORF2(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_botaoVisualizarGrafORF2
         if (orf2VO.getCod()>0) {
            new GraficoFORM(this, "Grfico S da ORF 2 ", "Grfico S da ORF 2", dadosGraficoSBO.getDadosGrafico(orf2VO,gabaritoVO));
          
        }    
        
    }//GEN-LAST:event_botaoVisualizarGrafORF2

    private void botaoVisualizarGrafORF1(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_botaoVisualizarGrafORF1

        if (orf1VO.getCod()>0){
              new GraficoFORM(this, "Grfico S da ORF 1 ", "Grfico S da ORF 1", dadosGraficoSBO.getDadosGrafico(orf1VO,gabaritoVO));
        }    
        
        
    }//GEN-LAST:event_botaoVisualizarGrafORF1

    private void jButton1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton1MouseClicked
        this.dispose();
    }//GEN-LAST:event_jButton1MouseClicked
    
    
    // Declarao de variveis - no modifique//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JTextPane jTextPane1;
    private javax.swing.JTextPane jTextPane2;
    // Fim da declarao de variveis//GEN-END:variables
    
}
