package jorfinder.business;

import java.util.ArrayList;
import jorfinder.util.Informacao;
import jorfinder.information.GabaritoVO;
import jorfinder.information.NotaVO;
import jorfinder.information.RedeVO;
import jorfinder.persistence.GabaritoDAO;
import jorfinder.persistence.NotaDAO;

public class GabaritoBO {
    
	private Informacao msg = new Informacao();

        public Informacao getMensagem(){
            return this.msg;
        }
        
         public void adiciona(GabaritoVO obj){
        	
            GabaritoDAO gabdao = new GabaritoDAO();
            NotaDAO notadao = new NotaDAO();
            NotaVO notavo;
            try {
                //pega um array contendo as Strings de cada gabarito, contendo um nome e suas notas
                String[] gabaritos = obj.getGabXML().split("<gabarito>");
                //comea em um para excluir a primeira tag
                for(int cont=1; cont < gabaritos.length; cont++){
                    String nome = gabaritos[cont].substring(gabaritos[cont].indexOf("<nome>")+6,
                            gabaritos[cont].indexOf("</nome>"));
                    obj.setNome(nome);
                    if(this.getObjetoByUnique(obj) != null){
                        this.msg.setMsg("Erro! J existe um gabarito com este nome no banco!");
                        this.msg.setSucesso(false);                     
                    } else {
                        gabdao.adiciona(obj);
                        gabdao.commit();
                        
                        this.msg.setMsg("Cadastro realizado com sucesso!");
                        this.msg.setSucesso(true);
                        
                        //pega o cara que a cabou de ser inserido
                        GabaritoVO gabcadastrado = gabdao.getObjetoByUnique(obj);
                        
                        //pega as notas do cara que acabou de ser inserido
                        String[] notas = gabaritos[cont].split("<nota>");
                        for(int c=1; c < notas.length; c++){
                            notavo = new NotaVO();
                            notavo.setCodGabarito(gabcadastrado.getCod());
                            notavo.setCodCodon((c-1));
                            notavo.setNota(Integer.parseInt(notas[c].substring(0, notas[c].indexOf("</nota>"))));
                            notadao.adiciona(notavo);
                            notadao.commit();
                        }  
                    }                                  
                }                                 
            } catch (jorfinder.util.UniqueException ex) {
                this.msg.setMsg("Houve falha ao inserir o registro!");
                this.msg.setSucesso(false);
            }finally{
            	gabdao.commitAndCloseConn();
            	notadao.commitAndCloseConn();
            }
            
        }
         
         public GabaritoVO getObjetoByUnique(GabaritoVO obj){
            GabaritoDAO dao = new GabaritoDAO();
            GabaritoVO Gabaritovo = dao.getObjetoByUnique(obj);
            if(Gabaritovo == null){
                this.msg.setMsg("Erro! Fragmento inexistente no banco!");
                this.msg.setSucesso(false);  
            } else {
                this.msg.setMsg("Fragmento ok!");
                this.msg.setSucesso(true);
            }
            dao.commitAndCloseConn();
            return Gabaritovo;
        }
                       
        public ArrayList<GabaritoVO> getListaObjeto(RedeVO obj){
            GabaritoDAO dao = new GabaritoDAO();
            ArrayList<GabaritoVO> array = dao.getListaObjeto(obj);
            
            if(array == null){
                this.msg.setMsg("Erro! Nenhum Fragmento retornou na consulta ao banco!");
                this.msg.setSucesso(false);  
            } else {
                this.msg.setMsg("Fragmentos ok!");
                this.msg.setSucesso(true);
            }
            dao.commitAndCloseConn();
            return array;
        }
}
