package jorfinder.business;

import java.util.List;
import jorfinder.information.ORFVO;
import jorfinder.persistence.ORFDAO;
import jorfinder.util.Informacao;
import jorfinder.util.UniqueException;

public class ORFBO {
    
	private Informacao msg = new Informacao();

        public Informacao getMensagem(){
            return this.msg;
        }

        public ORFVO getObjetoByUnique(ORFVO obj){
            ORFDAO dao = new ORFDAO();
            ORFVO usuvo = dao.getObjetoByUnique(obj);
            if(usuvo == null){
                this.msg.setMsg("Erro! Fragmento inexistente no banco!");
                this.msg.setSucesso(false);  
            } else {
                this.msg.setMsg("Fragmento ok!");
                this.msg.setSucesso(true);
            }
            dao.commitAndCloseConn();
            return usuvo;
        }
        
            
               
        public void atualiza(ORFVO obj){
        	ORFDAO dao = new ORFDAO();
        	try {
                        dao.atualiza(obj);
                        this.msg.setMsg("ORF Alterado com sucesso!");
                        this.msg.setSucesso(true);
                } catch (UniqueException e) {
                        this.msg.setMsg("Erro! O ORF no pde ser alterado!");
                        this.msg.setSucesso(false);  
                }finally{  
                    dao.commitAndCloseConn();
                }
        }
        
        public List<ORFVO> getListaObjeto(ORFVO obj){
            ORFDAO dao = new ORFDAO();
            List<ORFVO> array = dao.getListaObjeto(obj);
            
            if(array == null){
                this.msg.setMsg("Erro! Nenhum Fragmento retornou na consulta ao banco!");
                this.msg.setSucesso(false);  
            } else {
                this.msg.setMsg("Fragmentos ok!");
                this.msg.setSucesso(true);
            }
            dao.commitAndCloseConn();
            return array;
        }
}
