package jorfinder.business;

import java.util.ArrayList;
import java.util.List;
import jfan.fan.MonitorFAN;
import jfan.fan.NeuronioFAN;
import jfan.fan.padroes.IPadrao;
import jfan.fan.padroes.Padrao;
import jfan.io.arquivos.CarregaNeuronioXML;
import jfan.io.arquivos.GerenciadorPadroes;
import jorfinder.information.ORFVO;
import jorfinder.information.PesquisaVO;
import jorfinder.information.ProjetoVO;
import jorfinder.information.RedeVO;
import jorfinder.log2java.Logger;
import jorfinder.persistence.ORFDAO;
import jorfinder.persistence.PesquisaDAO;
import jorfinder.persistence.RedeDAO;
import jorfinder.util.Informacao;
import jorfinder.util.Mensagem;
import jorfinder.util.VioletionFKException;
import org.biojava.bio.seq.DNATools;
import org.biojava.bio.symbol.IllegalAlphabetException;
import org.biojava.bio.symbol.IllegalSymbolException;


public class PesquisaBO {
    
	private Informacao msg = new Informacao();
        public static Logger log = new Logger(PesquisaBO.class.getName());
        
        public Informacao getMensagem(){
            return this.msg;
        }

        public PesquisaVO getObjetoByUnique(PesquisaVO obj){
            PesquisaDAO dao = new PesquisaDAO();
            PesquisaVO usuvo = dao.getObjetoByUnique(obj);
            if(usuvo == null){
                this.msg.setMsg("Erro! Pesquisa inexistente no banco!");
                this.msg.setSucesso(false);  
            } else {
                this.msg.setMsg("Pesquisa ok!");
                this.msg.setSucesso(true);
            }
            dao.commitAndCloseConn();
            return usuvo;
        }
        public PesquisaVO getUltimoCadastrado() {
            PesquisaDAO dao = new PesquisaDAO();
            PesquisaVO usuvo = dao.getUltimoCadastrado();
            if(usuvo == null){
                this.msg.setMsg("Erro! Pesquisa inexistente no banco!");
                this.msg.setSucesso(false);  
            } else {
                this.msg.setMsg("Pesquisa ok!");
                this.msg.setSucesso(true);
            }
            dao.commitAndCloseConn();
            return usuvo;
        }
        
        public void adiciona(PesquisaVO obj){
            ORFVO fragvo;
            ORFDAO fragdao = new ORFDAO();
            PesquisaDAO pesqdao = new PesquisaDAO();
            String path = new Mensagem().getMensagem("rede.diretorio");
            
            ArrayList<String> codonsStart = new ArrayList<String>();
            codonsStart.add("ATG");
            codonsStart.add("GTG");
            
            ArrayList<String> codonsStop = new ArrayList<String>();
            codonsStop.add("TGA");
            codonsStop.add("TAG");
            codonsStop.add("TAA");
            boolean achoustop = false;

            try {
                RedeDAO rededao = new RedeDAO();
                RedeVO redevo = new RedeVO();
                redevo.setCod(obj.getCodRede());
                redevo = rededao.getObjetoByUnique(redevo);
                AGBO agbo = new AGBO(redevo);
                AGBO.gravaArquivoRede(path + redevo.getNome()+".enn", redevo.getRede());
                
                ArrayList<String> shits = new ArrayList<String>();
                try {    
                    pesqdao.adiciona(obj);
                    pesqdao.commit();
                    this.msg.setMsg("Cadastro realizado com sucesso!");
                    this.msg.setSucesso(true);  

                    //pega o objeto PesquisaVO que acabou de ser cadastrado
                    PesquisaVO pesqvo = pesqdao.getUltimoCadastrado();  

                    //array list que conter o cdigo com as 6 linhas do dna
                    // 3 linhas regulares e 3 complementares
                    ArrayList<String> arraydna = new ArrayList<String>();
                    arraydna.add(pesqvo.getDna().substring(0, pesqvo.getDna().length()));
                    arraydna.add(pesqvo.getDna().substring(1, pesqvo.getDna().length()));
                    arraydna.add(pesqvo.getDna().substring(2, pesqvo.getDna().length()));
                    String dnaComplementar;
                    //tenta pegar a sequencia complementar e as 3 linhas linhas logo abaixo
                    try {
                        dnaComplementar = DNATools.reverseComplement(DNATools.createDNA(pesqvo.getDna())).seqString().toUpperCase();
                        arraydna.add(dnaComplementar.substring(0, dnaComplementar.length()));
                        arraydna.add(dnaComplementar.substring(1, dnaComplementar.length()));
                        arraydna.add(dnaComplementar.substring(2, dnaComplementar.length()));
                        
                        //percorre o arraylist com as 6 linhas em busca de orfs
                        for(int linha = 0; linha < 6; linha++){
                            String dna =  arraydna.get(linha);
                            String codon = "";

                            boolean esperandoStop = false;
                            int numorf = 0;
                            ArrayList<Integer> posStart = new ArrayList<Integer>();
                            for(int cont = 0; cont < dna.length()/3; cont++){		
                                codon = dna.substring(cont*3, (cont + 1)*3);
                                //verifica se um cdon stop estava sendo esperado e caso o cdon atual seja um stop
                                //pega todos os starts que estavam no aguardo e monta um orf para cada um deles at o stop encontrado
                                if(esperandoStop){
                                    for(String codonstop : codonsStop){                             
                                        if(codonstop.equals(codon)){
                                            achoustop = true;
                                        }
                                    }
                                    if(achoustop){
                                        achoustop = false;
                                        for(int contstart = 0; contstart < posStart.size(); contstart++){
                                            numorf++;
                                            if(cont - posStart.get(contstart) >= obj.getOrfMinimo()){  
                                                GerenciadorPadroes gpClass = new GerenciadorPadroes();
                                                CarregaNeuronioXML cf = new CarregaNeuronioXML(path + redevo.getNome()+".enn", gpClass);
                                                MonitorFAN monitor = new MonitorFAN(gpClass);
                                                ArrayList<NeuronioFAN> neuronios = cf.getNeuroniosFAN();
                                                IPadrao padrao;
                                                //aqui deve se extrair a orf inteira e submeter ao mtodo
                                                //que dir sua classe
                                                byte[] codCodons = agbo.getTraducaoCodOrf(arraydna.get(linha).substring(posStart.get(contstart)*3, (cont+1)*3));
                                                double caracs[] = agbo.getFitness(agbo.getTraducaoGabarito(codCodons));

                                                String asdf = "";
                                                for(int shit = 0; shit < caracs.length; shit++){
                                                    asdf += caracs[shit]+" ";
                                                    
                                                }
                                                shits.add(asdf);
                                                padrao = new Padrao(caracs, 1);       
                                                String classeString = monitor.classificar(neuronios,cf, padrao); 
                                                
                                                fragvo = new ORFVO();
                                                fragvo.setCodPesquisa(pesqvo.getCod());
                                                fragvo.setCodTipoORF(Integer.parseInt(classeString));
                                                fragvo.setLinha(linha+1);
                                                fragvo.setPosCodonStart(posStart.get(contstart));
                                                fragvo.setPosCodonStop(cont);
                                                fragvo.setObservacao("");
                                                fragdao.adiciona(fragvo);
                                                fragdao.commit();
                                                 
                                            }
                                        }  
                                        esperandoStop = false;
                                        posStart.clear();
                                    }                                    
                                }
                                //verifica se  um cdon start, ento guarda a posio do cara e passa a esperar
                                //esperar por um cdon stop
                                
                                for(String codonstart : codonsStart){                             
                                    if(codonstart.equals(codon)){
                                        posStart.add(cont);
                                        esperandoStop = true;
                                    }
                                }
                                
                            }     
                        }
                        
                    } catch (IllegalAlphabetException ex) {
                        log.exception("erro no metodo adiciona", ex);
                    } catch (IllegalSymbolException ex) {
                    	log.exception("erro no metodo adiciona", ex);
                    }

                } catch (jorfinder.util.UniqueException ex) {
                    this.msg.setMsg("Houve falha ao inserir o registro!");
                    this.msg.setSucesso(false);
                }  finally {
                    rededao.commitAndCloseConn();
                    pesqdao.commitAndCloseConn();
                    fragdao.commitAndCloseConn();
                }                    
            } catch (Exception ex) {
            	log.exception("erro no metodo adiciona", ex);
            }                
        }
        
        public List<PesquisaVO> getListaObjeto(ProjetoVO obj){
            PesquisaDAO dao = new PesquisaDAO();
            List<PesquisaVO> array = dao.getListaObjeto(obj);
            
            if(array == null){
                this.msg.setMsg("Erro! Nenhuma Pesquisa retornou na consulta ao banco!");
                this.msg.setSucesso(false);  
            } else {
                this.msg.setMsg("Pesquisas ok!");
                this.msg.setSucesso(true);
            }
            dao.commitAndCloseConn();
            return array;
        }
        
        public void excluir(PesquisaVO obj){
        	PesquisaDAO dao = new PesquisaDAO();
        	try {
                        dao.exclui(obj);
			} catch (VioletionFKException e) {
				// nesse caso no precisa tratar
			}
        	dao.commitAndCloseConn();
        }
}
