package jorfinder.business;

import java.util.List;

import jorfinder.information.ProjetoVO;
import jorfinder.information.UsuarioVO;
import jorfinder.persistence.ProjetoDAO;
import jorfinder.util.Mensagem;
import jorfinder.util.UniqueException;
import jorfinder.util.VioletionFKException;

public class ProjetoBO {

    private String mensagem = "";
	
    public String getMensagemErro(){
        return mensagem;
    }

    
    public ProjetoVO getObjetoByUnique(ProjetoVO obj){
    	ProjetoDAO dao = new ProjetoDAO();
        ProjetoVO usuvo = dao.getObjetoByUnique(obj);
        dao.commitAndCloseConn();
        return usuvo;
    }
    
    public List<ProjetoVO> getLista(){
    	
        ProjetoDAO dao = new ProjetoDAO();
        List<ProjetoVO> lista = dao.getListaObjeto();
        dao.commitAndCloseConn();
        return lista;
    }
    
    public boolean atualiza(ProjetoVO obj, List<UsuarioVO> listUsuario){
    	
    	ProjetoDAO dao = new ProjetoDAO();
    	try {
    		
            dao.atualiza(obj);
            dao.atualizaListUsuarios(obj, listUsuario);
            
            } catch (UniqueException e) {
                    mensagem += new Mensagem().getMensagem("projeto.error.nome.unique");
                    return false;
            }finally{  
                    dao.commitAndCloseConn();
	    }
	    
            return true;
		
    }
    
    public boolean adiciona(ProjetoVO obj, List<UsuarioVO> listUsuario){
    	
        ProjetoDAO dao = new ProjetoDAO();
        try {
                dao.adiciona(obj, listUsuario);
                return true;                   
        	} catch (jorfinder.util.UniqueException ex) {
        		mensagem += new Mensagem().getMensagem("projeto.error.nome.unique");
            		
        }finally{  
        	dao.commitAndCloseConn();
        }
        return false;
    }

    public void excluirProjeto(ProjetoVO obj){
    	ProjetoDAO dao = new ProjetoDAO();
    	try {
			dao.exclui(obj);
		} catch (VioletionFKException e) {
			// not necessary! 
		}finally{  
        	dao.commitAndCloseConn();
        }
    	
    }
    
    public List<ProjetoVO> getListaProjetoUsuario(UsuarioVO obj){
    	
    	ProjetoDAO dao = new ProjetoDAO();
    	List<ProjetoVO> lista = dao.getListaProjetoUsuario(obj);
    	dao.commitAndCloseConn();    	
    	return lista;
    }
    
    public List<UsuarioVO> getListaUsuarioProjeto(ProjetoVO obj){
    	ProjetoDAO dao = new ProjetoDAO();
    	List<UsuarioVO> lista = dao.getListaUsuarioProjeto(obj);
    	dao.commitAndCloseConn();    	
    	return lista;
    }
    
    public boolean UsuarioTemPermissaoAcesso(ProjetoVO projeto, UsuarioVO obj){
    	ProjetoDAO dao = new ProjetoDAO();
    	boolean resp = dao.usuarioTemPermissaoAcesso(projeto, obj);
    	dao.commitAndCloseConn();
    	return resp;
    }
    
}
