package jorfinder.business;

import java.util.ArrayList;
import jorfinder.util.Informacao;
import jorfinder.information.RedeVO;
import jorfinder.persistence.RedeDAO;
import jorfinder.util.VioletionFKException;

public class RedeBO {
	
        private Informacao msg = new Informacao();

        public Informacao getMensagem(){
            return this.msg;
        }
        
         public void adiciona(RedeVO obj){
        	
            RedeDAO dao = new RedeDAO();
            try {
                if(this.getObjetoByUnique(obj) != null){
                    this.msg.setMsg("Erro! J existe uma rede orf com este nome no banco!");
                    this.msg.setSucesso(false);                     
                } else {
                    dao.adiciona(obj);
                    dao.commit();
                    this.msg.setMsg("Cadastro realizado com sucesso!");
                    this.msg.setSucesso(true);
                }                       
            } catch (jorfinder.util.UniqueException ex) {
                this.msg.setMsg("Houve falha ao inserir o registro!");
                this.msg.setSucesso(false);
            }finally{
            	dao.commitAndCloseConn();
            }
            
        }
        
        public RedeVO getObjetoByUnique(RedeVO obj){
            RedeDAO dao = new RedeDAO();
            RedeVO redevo = dao.getObjetoByUnique(obj);
            if(redevo == null){
                this.msg.setMsg("Erro! Fragmento inexistente no banco!");
                this.msg.setSucesso(false);  
            } else {
                this.msg.setMsg("Fragmento ok!");
                this.msg.setSucesso(true);
            }
            dao.commitAndCloseConn();
            return redevo;
        }
        
               
        public ArrayList<RedeVO> getListaObjeto(){
            RedeDAO dao = new RedeDAO();
            ArrayList<RedeVO> array = dao.getListaObjeto();
            
            if(array == null){
                this.msg.setMsg("Erro! Nenhum Fragmento retornou na consulta ao banco!");
                this.msg.setSucesso(false);  
            } else {
                this.msg.setMsg("Fragmentos ok!");
                this.msg.setSucesso(true);
            }
            dao.commitAndCloseConn();
            return array;
        }
        
        public void excluirRede(RedeVO obj){
    	RedeDAO dao = new RedeDAO();
    	try {
		dao.exclui(obj);
                this.msg.setMsg("Excluso realizada com sucesso!");
                this.msg.setSucesso(true);
		} catch (VioletionFKException e) {
			this.msg.setMsg("Erro! A rede no pode ser excluda, porque existem pesquisas que dependem dela!");
            this.msg.setSucesso(false);  
		}finally{  
        	dao.commitAndCloseConn();
        }    	
    }
    
    public static String getRede(String xmlrede){
        return  "<?xml version=\"1.0\"?>\n"+xmlrede.substring(xmlrede.indexOf("<net>"), xmlrede.indexOf("<gab>"));           
    }    
    
    public static String getGabarito(String xmlgab){
        return xmlgab.substring(xmlgab.indexOf("<gab>"), xmlgab.indexOf("</rede>"));
    }      
}
