package jorfinder.business;


import java.util.List;

import jorfinder.information.UsuarioVO;
import jorfinder.persistence.UsuarioDAO;
import jorfinder.util.Mensagem;
import jorfinder.util.UniqueException;

public class UsuarioBO {
		
        private String mensagem = "";
		
        public String getMensagemErro(){
            return mensagem;
        }
	
        
        public UsuarioVO getObjetoByUnique(UsuarioVO obj){
        	
            UsuarioDAO dao = new UsuarioDAO();
            UsuarioVO usuvo = dao.getObjetoByUnique(obj);
            dao.commitAndCloseConn();
            return usuvo;
        }
        
        public List<UsuarioVO> getLista(){
        	
            UsuarioDAO dao = new UsuarioDAO();
            List<UsuarioVO> lista = dao.getListaObjeto();
            dao.commitAndCloseConn();
            return lista;
        }
        
        public boolean atualiza(UsuarioVO obj){
        	UsuarioDAO dao = new UsuarioDAO();
        	try {
				dao.atualiza(obj);
				return true;
			} catch (UniqueException e) {
				mensagem += new Mensagem().getMensagem("cadastro.email.unique");
        		
		    }finally{  
		    	dao.commitAndCloseConn();
		    }
			return false;
        }
        
        public boolean adiciona(UsuarioVO obj){
        	
            UsuarioDAO dao = new UsuarioDAO();
            try {
            		dao.adiciona(obj);
                    return true;                   
            	} catch (jorfinder.util.UniqueException ex) {
            			UsuarioVO usuario = new UsuarioVO();
            			usuario.setEmail(obj.getEmail());
            			if(getObjetoByUnique(usuario) != null){
		            			mensagem += new Mensagem().getMensagem("cadastro.email.unique");
                		}
            			usuario = new UsuarioVO();
            			usuario.setLogin(obj.getLogin());
            			if(getObjetoByUnique(usuario) != null){
                			mensagem += new Mensagem().getMensagem("cadastro.login.unique");
                		}
            			
            }finally{  
            	dao.commitAndCloseConn();
            }
            return false;
        }

        public boolean isUserAndPasswordOK(UsuarioVO obj){
        	
        	UsuarioDAO dao = new UsuarioDAO();
        	boolean resposta = dao.isUserPasswordOk(obj); 
        	dao.commitAndCloseConn();
        	return resposta;
        }
        
        public UsuarioVO getUsuarioWithLoginAndEmail(UsuarioVO usu){
        	UsuarioDAO dao = new UsuarioDAO();
        	UsuarioVO usuario = dao.getUsuarioWithLoginEmail(usu);
        	dao.commitAndCloseConn();
        	return usuario;
        }


}
