package jorfinder.persistence;


import java.sql.Connection;
import java.sql.SQLException;
import javax.sql.DataSource;
import jorfinder.log2java.Logger;


public class ConnectionFactory {
	
    public static Logger log = new Logger(ConnectionFactory.class.getName());
    // DataSource que vem do pool de conexo
    private DataSource datasource;
    // guarda a minha instncia
    private static ConnectionFactory INSTANCIA;
    // guarda a interface do BD
    private RDBMS rdbms; 
    
    // evita que seja INSTANCIAda por outras classes
    private ConnectionFactory(DataSource datasource, RDBMS rdbms){
    	log.info("Instanciando a ConnectionFactory - executando construtor");
    	this.datasource = datasource;
    	this.rdbms = rdbms;
    }
    
    // recebe um DataSource que vem do listener do pool de conexes
    public static void setInstancia(DataSource datasource, RDBMS rdbms){
        if (INSTANCIA == null) {
        	INSTANCIA = new ConnectionFactory(datasource, rdbms);
        	INSTANCIA.rdbms.verificarRDBMS(ConnectionFactory.getConnection());
        }        
        
    }
    

    // metodo usado por todas as DAO's para pegar a conexo com o BD
    public static Connection getConnection(){
    	try {
    		
			return INSTANCIA.datasource.getConnection(); 
		} catch (SQLException ex) {
			log.exception("Erro ao executado o metodo getConnection dessa classe", ex);
		}
		return null;
		
    }
    
    // metodo usado por todas as DAO's para fechar as conexes
    public static void closeConnection(Connection conn){
    	try {
    		if (conn != null) 
    			conn.close();
    		    
    		} catch (SQLException ex) {
    			log.exception("Erro ao executado o metodo closeConnection dessa classe", ex);
    		}
    }
    
	public static String getCodUniqueException() {
		return INSTANCIA.rdbms.getCodUniqueException();		
	}


	public static String getCodVioletionFKException() {
		return INSTANCIA.rdbms.getCodVioletionFKException();
	}
 
 

}
