package jorfinder.persistence;


import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import jorfinder.information.GabaritoVO;
import jorfinder.information.NotaVO;
import jorfinder.log2java.Logger;
import jorfinder.util.UniqueException;
import jorfinder.util.VioletionFKException;

public class NotaDAO extends AbstractDAO<NotaVO>{

	public static Logger log = new Logger(NotaDAO.class.getName());
	
	public NotaDAO(){

	}
	
	public NotaDAO(java.sql.Connection conn){
		super(conn);
		
	}
		
	@Override
	public void adiciona(NotaVO obj) throws UniqueException {
		PreparedStatement ps = null;
		try{
                    ps = conn.prepareStatement("insert into nota(codGabarito, codCodon, nota) values(?,?,?)");
                    ps.setInt(1, obj.getCodGabarito());
                    ps.setInt(2, obj.getCodCodon());
                    ps.setInt(3, obj.getNota());
                    
                    ps.execute(); 
                }catch (SQLException e) {
                	String theError = (e).getSQLState();
                    // verifica se  um erro de violao de chave unique
                    if (theError.equals(ConnectionFactory.getCodUniqueException())){
                         log.exception("Lanando uma excesso de violao de unique ao adicionar NotaVO");
                         throw new UniqueException();
                    }
                    log.exception("Erro ao cadastrar NotaVO", e);
                }finally{
                        this.closePstmt(ps);
		}	
	}

	@Override
	public void atualiza(NotaVO obj) throws UniqueException {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void exclui(NotaVO obj) throws VioletionFKException {
		// TODO Auto-generated method stub
		
	}
        
        @Override
		public ArrayList<NotaVO> getListaObjeto() {
            return null;
	}

        public ArrayList<NotaVO> getObjetoByUnique(GabaritoVO objeto) {
            PreparedStatement ps = null;
            ResultSet rs = null;
            NotaVO obj = null;
            ArrayList<NotaVO> array = new ArrayList<NotaVO>();

            try {
                ps = conn.prepareStatement("select codGabarito, codCodon, nota from nota where codGabarito = ? ");
                ps.setInt(1,objeto.getCod());
                
                rs = ps.executeQuery();   
                while(rs.next()){
                    // Cria e popula o objeto
                    obj = new NotaVO();
                    obj.setCodGabarito(rs.getInt("codGabarito"));
                    obj.setCodCodon(rs.getInt("codCodon"));
                    obj.setNota(rs.getInt("nota"));
                    array.add(obj);
                }                  
            }catch (SQLException e) {
                    log.exception("erro ao executar getObjetoByUnique", e);
            }finally{
                    this.closePstmtAndResultSet(ps, rs);
            }
            return array;
        }

		@Override
		public NotaVO getObjetoByUnique(NotaVO objeto) {
			// TODO Auto-generated method stub
			return null;
		}
        

        
}
