package jorfinder.persistence;


import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;
import jorfinder.information.RedeVO;
import jorfinder.log2java.Logger;
import jorfinder.util.UniqueException;
import jorfinder.util.VioletionFKException;

public class RedeDAO extends AbstractDAO<RedeVO>{
        
        public static Logger log = new Logger(ProjetoDAO.class.getName());
        
	public RedeDAO(){
		
	}
	
	public RedeDAO(java.sql.Connection conn){
		super(conn);
		
	}
	
	
	@Override
	public void adiciona(RedeVO obj) throws UniqueException {
		PreparedStatement ps = null;
		try{
                    ps = conn.prepareStatement("insert into Rede(nome, descricao, rede) values(?,?,?)");
                    ps.setString(1, obj.getNome());
                    ps.setString(2, obj.getDescricao());
                    ps.setString(3, obj.getRede());
                    
                    ps.execute(); 
                }catch (SQLException e) {
                	String theError = (e).getSQLState();
                    // verifica se  um erro de violao de chave unique
                    if (theError.equals(ConnectionFactory.getCodUniqueException())){
                         log.exception("Lanando uma excesso de violao de unique ao adicionar RedeVO");
                         throw new UniqueException();
                    }
                    log.exception("Erro ao cadastrar RedeVO", e);
                  
                }finally{
                        this.closePstmt(ps);
		}	
	}

	@Override
	public void atualiza(RedeVO obj) throws UniqueException {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void exclui(RedeVO obj) throws VioletionFKException {
		PreparedStatement ps = null;
		try{
					
                    ps = conn.prepareStatement("delete from rede where cod = ?");
                    ps.setInt(1, obj.getCod());                    
                    ps.execute();
                    
                }catch (SQLException e) {
                	String theError = (e).getSQLState();
                    // verifica se  um erro de violao de FK
                    if (theError.equals(ConnectionFactory.getCodVioletionFKException())){
                         log.exception("Lanando uma excesso de violao de FK ao adicionar RedeVO");
                         throw new VioletionFKException();
                    }
                    	log.exception("Erro ao excluir rede", e);
                    
                    
                }finally{
                        this.closePstmt(ps);
		}		
	}
        
        public List<RedeVO> getListaObjeto(RedeVO redevo) {
            return null;
	}
        
        
	@Override
	public ArrayList<RedeVO> getListaObjeto() {
            PreparedStatement ps = null;
            ResultSet rs = null;
            RedeVO obj = null;
            ArrayList<RedeVO> array = new ArrayList<RedeVO>();

            try {
                ps = conn.prepareStatement("select * from Rede order by cod");
                rs = ps.executeQuery();                
                while(rs.next()){
                    // Cria e popula o objeto
                    obj = new RedeVO();
                    obj.setCod(rs.getInt("cod"));
                    obj.setNome(rs.getString("nome"));                           
                    obj.setDescricao(rs.getString("descricao"));
                    obj.setRede(rs.getString("rede"));
                    array.add(obj);
                }                  
            }catch (SQLException e) {
                    log.exception("erro ao executar getListaObjeto", e);
            }finally{
                    this.closePstmtAndResultSet(ps, rs);
            }
            return array;
	}
        
        @Override
	public RedeVO getObjetoByUnique(RedeVO objeto) {
		PreparedStatement ps = null;
		ResultSet rs = null;
                RedeVO redevo = null;
		try{
                    if(objeto.getNome() != null){
                        ps = conn.prepareStatement("select * from Rede where nome = ?");
                        ps.setString(1, objeto.getNome());
                    } else {
                        ps = conn.prepareStatement("select * from Rede where cod = ?");
                        ps.setInt(1, objeto.getCod());
                    }
                    rs = ps.executeQuery();
                    if (rs.next()){
                             redevo = new RedeVO();
                             redevo.setCod(rs.getInt("cod"));
                             redevo.setNome(rs.getString("nome"));
                             redevo.setDescricao(rs.getString("descricao"));
                             redevo.setRede(rs.getString("rede"));
                    }
                }catch (SQLException e) {
                        log.exception("erro ao executar getObjetoByUnique", e);
                }finally{
                        this.closePstmtAndResultSet(ps, rs);
		}
		return redevo;
	}	
}
