package jorfinder.persistence; 

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import jorfinder.information.TipoORFVO;
import jorfinder.log2java.Logger;
import jorfinder.persistence.AbstractDAO;
import jorfinder.util.UniqueException;
import jorfinder.util.VioletionFKException;

public class TipoORFDAO extends AbstractDAO<TipoORFVO>{

	public static Logger log = new Logger(TipoORFDAO.class.getName());
	
	public TipoORFDAO(){

	}
	
	public TipoORFDAO(java.sql.Connection conn){
		super(conn);
		
	}
	
	
	@Override
	public void adiciona(TipoORFVO obj) throws UniqueException {
		PreparedStatement ps = null;
		try{
                    ps = conn.prepareStatement("insert into TipoORF(tipo) values(?)");
                    ps.setString(1, obj.getTipo());
                    
                    ps.execute(); 
                }catch (SQLException e) {
                	String theError = (e).getSQLState();
                    // verifica se  um erro de violao de chave unique
                    if (theError.equals(ConnectionFactory.getCodUniqueException())){
                         log.exception("Lanando uma excesso de violao de unique ao adicionar TipoORFVO");
                         throw new UniqueException();
                    }
                    log.exception("Erro ao cadastrar tipoORFVO", e);
                }finally{
                        this.closePstmt(ps);
		}	
	}

		@Override
		public void atualiza(TipoORFVO obj) throws UniqueException {
			// TODO Auto-generated method stub
			
		}
	
		@Override
		public void exclui(TipoORFVO obj) throws VioletionFKException {
			// TODO Auto-generated method stub
			
		}
        
        @Override
		public ArrayList<TipoORFVO> getListaObjeto() {
            PreparedStatement ps = null;
            ResultSet rs = null;
            TipoORFVO obj = null;
            ArrayList<TipoORFVO> array = new ArrayList<TipoORFVO>();

            try {
                ps = conn.prepareStatement("select * from TipoORF");
                rs = ps.executeQuery();                
                while(rs.next()){
                    // Cria e popula o objeto
                    obj = new TipoORFVO();
                    obj.setCod(rs.getInt("cod"));
                    obj.setTipo(rs.getString("tipo"));                           
                    array.add(obj);
                }                  
            }catch (SQLException e) {
                    log.exception("erro ao executar getListaObjeto", e);
            }finally{
                    this.closePstmtAndResultSet(ps, rs);
            }
            return array;
	}
        
        


	@Override
	public TipoORFVO getObjetoByUnique(TipoORFVO objeto) {
		PreparedStatement ps = null;
		ResultSet rs = null;
                TipoORFVO tipoORFvo = null;
		try{
                    ps = conn.prepareStatement("select * from tipoORF where cod = ?");
                    ps.setInt(1, objeto.getCod());
                    rs = ps.executeQuery();
                    if (rs.next()){
                             tipoORFvo = new TipoORFVO();
                             tipoORFvo.setCod(rs.getInt("cod"));
                             tipoORFvo.setTipo(rs.getString("tipo"));
                    }
                }catch (SQLException e) {
                        log.exception("erro ao executar getObjetoByUnique", e);
                }finally{
                        this.closePstmtAndResultSet(ps, rs);
		}
		return tipoORFvo;
	}	
}
