package jorfinder.util;


import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.sql.DataSource;

import jorfinder.persistence.RDBMS;

public class PoolListener implements ServletContextListener{
	
	
        public void contextInitialized(ServletContextEvent sce){

            try {
                    // Pega o environment naming context
                    Context envCtx = new InitialContext();						
                    // Procura pelo DataSource
                    DataSource  ds = (DataSource) envCtx.lookup("java:comp/env/jdbc/mypool");
                    // procura a classe 			
                    RDBMS 	rdbms = (RDBMS) Class.forName("jorfinder.persistence." + sce.getServletContext().getInitParameter("rdbms") + "RDBMS").newInstance();

                    // instncia a fabrica de conexo
                    jorfinder.persistence.ConnectionFactory.setInstancia(ds, rdbms);

             } catch(NamingException e){
                     e.printStackTrace();					
                    }catch (ClassNotFoundException e){
                            e.printStackTrace(); 
                    } catch (InstantiationException e) {
                            e.printStackTrace();
                    } catch (IllegalAccessException e) {
                            e.printStackTrace();
                    }

        }

        public void contextDestroyed(ServletContextEvent sce){}
}