package jorfinder.util;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;
import javax.mail.Authenticator;
import javax.mail.Message;
import javax.mail.PasswordAuthentication;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import jorfinder.log2java.Logger;


public class SendMail {
	
    // guarda a minha instncia
    private static Properties config;
    public static Logger log = new Logger(SendMail.class.getName());
    
    
    static{
    	
	    	config = new Properties();  
	        InputStream in =  new Mensagem().getClass().getResourceAsStream("../../smtp.properties");   
	        try {
				config.load(in);
				in.close();
			} catch (IOException ex) {
				log.exception(ex);
			}              
             
    }
    

    public void enviarEmailSenha(String emailDest, String nomeDest, String corpo){
              
    		  
              Properties props = System.getProperties();
              props.put("mail.smtp.host", config.getProperty("smtp_address"));
              props.put("mail.smtp.auth", "true");
              Authenticator auth = new Authenticator() {
                
			  @Override
			  public PasswordAuthentication getPasswordAuthentication() {
                  return new PasswordAuthentication(config.getProperty("smtp_login"), config.getProperty("smtp_senha"));
                }};

              Session session = Session.getInstance(props, auth);
              MimeMessage message = new MimeMessage(session);
              
              try {
            	  
				  message.setFrom(new InternetAddress(config.getProperty("smtp_email_reply"), "J-ORFinder"));
	              message.addRecipient(Message.RecipientType.TO,
	                new InternetAddress(emailDest, nomeDest));
	              message.setSubject("Solicitao de Senha para J-ORFinder");
	              message.setContent(corpo, "text/plain");
	              Transport.send(message);
	              
              } catch (Exception ex) {
            	  log.exception(ex);
              }

              
            }
   
}