package jorfinder.view;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jorfinder.business.ProjetoBO;
import jorfinder.information.ProjetoVO;
import jorfinder.information.UsuarioVO;
import jorfinder.util.Mensagem;
import jorfinder.util.ValidaString;

public class AlterarProjeto implements Action {
	
	private UsuarioVO usuario;
	private ProjetoVO projeto;
	private List<UsuarioVO> listUser;
	private String mensagem = "";

	public void execute(HttpServletRequest req, HttpServletResponse res)
			throws Exception {
	
                usuario = (UsuarioVO) req.getSession().getAttribute("usuario");
			
	        //pegar os parametros da requisio;
	        setParameter(req);
	        
	        boolean dadosUsuario =  checkDados();
        	ProjetoBO bo = new ProjetoBO();
	        
	        boolean retornoBanco = false;
	        boolean permissao = bo.UsuarioTemPermissaoAcesso(projeto, usuario);
	        if (dadosUsuario && permissao){
	        	
	            retornoBanco = bo.atualiza(projeto, listUser);
	            if(!retornoBanco){
	            	mensagem += bo.getMensagemErro();
	            }
	        	
	        }
	        
	        RequestDispatcher rd;
	        if (dadosUsuario && retornoBanco && permissao){
	        	req.setAttribute("alert", new Mensagem().getMensagem("projeto.editar.ok"));
	        	rd = req.getRequestDispatcher("/jw/ListaProjeto");
	        }else{
	        	req.setAttribute("mensagem", mensagem);
	        	rd = req.getRequestDispatcher("/jw/EditaProjeto?cod="+ projeto.getCod());
	        }
	        
	        rd.forward(req, res);
	}

	private void setParameter(HttpServletRequest req){
			
			listUser = new ArrayList<UsuarioVO>();
			UsuarioVO user;
			String[] listUsuarios = req.getParameterValues("select_usersInGroup");
			if (listUsuarios != null){
				for (int i =0; i < listUsuarios.length;i++){
					user = new UsuarioVO();
					user.setCod(Integer.parseInt(listUsuarios[i]));
					listUser.add(user);
				}	
			}
			listUser.add(usuario);
			projeto = new ProjetoVO();
			projeto.setOwner(usuario);
                        projeto.setNome(req.getParameter("nome").toString().trim().toLowerCase());
                        projeto.setDescricao(req.getParameter("descricao").toString().trim().toLowerCase());
                        projeto.setCod(Integer.parseInt(req.getParameter("cod").toString()));
	
	}

	private boolean checkDados(){
	
			boolean dadosUsuarioOk = true;
			if (!ValidaString.isStringOK(projeto.getNome(), 1, 200)){
				dadosUsuarioOk = false;
				mensagem +=  new Mensagem().getMensagem("projeto.error.nome") ;
			}
			if (!ValidaString.isStringOK(projeto.getDescricao(), 1, 200)){
				dadosUsuarioOk = false;
				mensagem +=  new Mensagem().getMensagem("projeto.error.descricao") ;
			}		
			return dadosUsuarioOk;
	}


	

}
