package jorfinder.view; 

import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import jorfinder.business.UsuarioBO;
import jorfinder.information.UsuarioVO;
import jorfinder.util.Crypt;
import jorfinder.util.Mensagem;
import jorfinder.util.ValidaString;


/**
 * Responsvel pelo cadastro de usurios
 * @author Oeslei Taborda Ribas
 */
public class CadastrarPesquisador implements Action{

	
	private UsuarioVO usuario;
	private String mensagem = "";
	
	public CadastrarPesquisador(){
		
	}	
	
	public void execute(HttpServletRequest req, HttpServletResponse res)
			throws Exception {
			
                
                //pegar os parametros da requisio;
                setParameter(req);
                
                boolean dadosUsuario =  checkDados();
                
                boolean retornoBanco = false;
                if (dadosUsuario){
                	// cryptografa a senha
                	cryptPassword();
                	UsuarioBO usubo = new UsuarioBO();
                    retornoBanco = usubo.adiciona(usuario);
                    if(!retornoBanco){
                    	mensagem += usubo.getMensagemErro();
                    }
                	
                }
                
                RequestDispatcher rd;
                System.out.println(mensagem);
                if (dadosUsuario && retornoBanco){
                	HttpSession session = req.getSession();
                	UsuarioBO usubo = new UsuarioBO();
					session.setAttribute("usuario", usubo.getObjetoByUnique(usuario));
                	req.setAttribute("alert", new Mensagem().getMensagem("cadastro.usuario.sucesso"));
                	rd = req.getRequestDispatcher("/index.jsp");
                }else{
                	req.setAttribute("mensagem", mensagem);
                	rd = req.getRequestDispatcher("/pesquisadorCad.jsp");
                }
                
                rd.forward(req, res);
	}
	
	private void setParameter(HttpServletRequest req){
                usuario = new UsuarioVO();
                usuario.setLogin(req.getParameter("login").toString().trim().toLowerCase());
                usuario.setSenha(req.getParameter("senha").toString().trim().toLowerCase());
                usuario.setInstituicao(req.getParameter("instituicao").toString().trim().toLowerCase());
                usuario.setNome(req.getParameter("nome").toString().trim().toLowerCase());
                usuario.setEmail(req.getParameter("email").toString().trim());
		
	}
	
	private boolean checkDados(){
		
		boolean dadosUsuarioOk = true;
		if (!ValidaString.isStringOK(usuario.getNome(), 1, 50)){
			dadosUsuarioOk = false;
			mensagem +=  new Mensagem().getMensagem("cadastro.nome.erro") ;
		}
		if (!ValidaString.isStringOK(usuario.getLogin(), 1, 15)){
			dadosUsuarioOk = false;
			mensagem +=  new Mensagem().getMensagem("cadastro.login.erro") ;
		}
		if (!ValidaString.isStringOK(usuario.getEmail(), 1, 50)){
			dadosUsuarioOk = false;
			mensagem +=  new Mensagem().getMensagem("cadastro.email.erro") ;
		}
		if (!ValidaString.isEmailOK(usuario.getEmail())){
			dadosUsuarioOk = false;
			mensagem +=  new Mensagem().getMensagem("cadastro.email.invalido") ;
		}
		if (!ValidaString.isStringOK(usuario.getSenha(), 1, 15)){
			dadosUsuarioOk = false;
			mensagem +=  new Mensagem().getMensagem("cadastro.senha.erro") ;
		}
		if (!ValidaString.isStringOK(usuario.getInstituicao(), 1, 50)){
			dadosUsuarioOk = false;
			mensagem +=  new Mensagem().getMensagem("cadastro.instituicao.erro") ;
		}
			
		return dadosUsuarioOk;
	}

	private void cryptPassword(){
			usuario.setSenha(Crypt.getHash(usuario.getSenha()));
		
	}
}





