package jorfinder.view;
  
import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


// todas as requisies do sistema passam por esse servlet ele  uma especie
// de porteiro do sistema : )
public class ControllerServlet extends HttpServlet{
	
	
	private static final long serialVersionUID = 1L;

	@SuppressWarnings("unchecked")
	@Override
	public void service(HttpServletRequest req, HttpServletResponse res) 
	    throws ServletException, IOException{
				
		String url = req.getRequestURI();
		// se no existir action definida tenta chamar o jsp solicitado
		if (url.contains("/jw/pages")){			
			
            // encaminhando para o jsp
            RequestDispatcher rd = req.getRequestDispatcher("/WEB-INF/jsp" + url.split("/jw/pages")[1]);
            rd.forward(req, res);
            
		} else {	
			
			//procura a classe
			String action = null;
			try {				
                    if(!(req.getParameter("action") == null)){
                    	action = req.getParameter("action").toString();
                    }else{
                    	String[] urlSplit = url.split("/jw/");
            			action = urlSplit[1];
                    	
                    }
                    Class actionClass = Class.forName("jorfinder.view." + action);
                    // verifica se implementa a interface Action			
                    if (! Action.class.isAssignableFrom(actionClass)){
                              throw new ServletException(" A seguinte classe no implementa a interface Action : jorfinder.view." + action);
                    }
                    // 	agora tentar instanciar
                    Action actionObject = (Action) actionClass.newInstance();
                    // agora repassa a requisio para a Action tratar		
                    actionObject.execute(req, res);

                } catch (ClassNotFoundException e){
                        throw new ServletException(" No foi encontrado a classe com o nome = jorfinder.view." + action);
                } catch (InstantiationException e) {
                        throw new ServletException("Erro ao instanciar o objeto Action", e);
                } catch (IllegalAccessException e){
                        throw new ServletException(e);
                } catch (Exception e) {
                        throw new ServletException("A classe que implementa a interface Action causou o seguinte erro = ", e);
                }			
          }	
	}

	public void execute(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException{
		this.service(req, res);
	}
}
