package jorfinder.view;

import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jorfinder.business.ProjetoBO;
import jorfinder.information.ProjetoVO;
import jorfinder.information.UsuarioVO;
import jorfinder.util.Mensagem;

public class EditaProjeto implements Action {

	public void execute(HttpServletRequest req, HttpServletResponse res)
			throws Exception {
		
		UsuarioVO usuario = (UsuarioVO) req.getSession().getAttribute("usuario");
		
		int codProjeto = Integer.parseInt(req.getParameter("cod"));
		
		ProjetoVO proje = new ProjetoVO();
		proje.setCod(codProjeto);
		
		ProjetoBO bo = new ProjetoBO();
		proje = bo.getObjetoByUnique(proje);
		
		List<UsuarioVO> usuariosProjeto = bo.getListaUsuarioProjeto(proje);
		 
		if (bo.UsuarioTemPermissaoAcesso(proje, usuario)){
		
			RequestDispatcher rd = req.getRequestDispatcher("/WEB-INF/jsp/projetoAlt.jsp");
			req.setAttribute("usuariosProjeto", usuariosProjeto);
			req.setAttribute("projeto", proje);
                        rd.forward(req, res);
        	
		}else{
                        req.setAttribute("mensagem", new Mensagem().getMensagem("projeto.altera.erro"));
	        	new ListaProjeto().execute(req, res);
	        	
	        }
		
	}

}
