package jorfinder.view;


import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jorfinder.business.PesquisaBO;
import jorfinder.business.ProjetoBO;
import jorfinder.information.PesquisaVO;
import jorfinder.information.ProjetoVO;
import jorfinder.information.UsuarioVO;
import jorfinder.util.Mensagem;

public class ExcluirPesquisa implements Action {

	public void execute(HttpServletRequest req, HttpServletResponse res)
			throws Exception {

		UsuarioVO usuario = (UsuarioVO) req.getSession().getAttribute("usuario");
		
		int codPesquisa = Integer.parseInt(req.getParameter("pesquisa"));
		int codProjeto = Integer.parseInt(req.getParameter("projeto"));
		
		ProjetoVO proje = new ProjetoVO();
		proje.setCod(codProjeto);
		
		PesquisaVO pesquisa = new PesquisaVO();
		pesquisa.setCod(codPesquisa);
		
		ProjetoBO bo = new ProjetoBO();
		if (bo.UsuarioTemPermissaoAcesso(proje, usuario)){
			
			PesquisaBO pesqBo = new PesquisaBO();
			pesqBo.excluir(pesquisa);
			req.setAttribute("alert", new Mensagem().getMensagem("pesquisa.exclusao.ok"));
        	
		}else{
			
	        	req.setAttribute("mensagem", new Mensagem().getMensagem("pesquisa.exclusao.erro.permissao"));
	        }
		
		
		RequestDispatcher rd = req.getRequestDispatcher("/jw/ListaPesquisa?cod="+codPesquisa);
                rd.forward(req, res);
		

	}

}
