package jorfinder.view;

import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import jorfinder.business.UsuarioBO;
import jorfinder.information.UsuarioVO;
import jorfinder.log2java.Logger;
import jorfinder.util.Crypt;
import jorfinder.util.Mensagem;
import jorfinder.util.ValidaString;



// classe q trata o form de login da aplicao 
public class Login implements Action{

	public static Logger log = new Logger(Login.class.getName());
	private UsuarioVO usuario;
	private String mensagem = "";
	
	public Login(){	}
	
	
	public void execute(HttpServletRequest req, HttpServletResponse res) throws Exception {

                // pega os dados da requisio
                getParameters(req);
                // valida os dados
                boolean isdadosok = validarDados();

                boolean isUserPasswordOk = false;
                if(isdadosok){
                        cryptPassword();
                        UsuarioBO usubo = new UsuarioBO();
                        isUserPasswordOk = usubo.isUserAndPasswordOK(usuario);
                        if (!isUserPasswordOk){
                                mensagem += new Mensagem().getMensagem("login.erro");
                        }else{
                                HttpSession session = req.getSession();
                                session.setAttribute("usuario", usubo.getObjetoByUnique(usuario));
                        }

                }
                
				
                if (isUserPasswordOk && isdadosok){
                	new ListaProjeto().execute(req, res);
                }else{
                	req.setAttribute("mensagem", mensagem);
                	RequestDispatcher rd = req.getRequestDispatcher("/index.jsp");
                	rd.forward(req, res);
                }
                
                
                
	}
	
	private void getParameters(HttpServletRequest req){
		usuario = new UsuarioVO();
		usuario.setLogin(req.getParameter("login").toString().trim().toLowerCase());
                usuario.setSenha(req.getParameter("senha").toString().trim());
		
	}
	
	private boolean validarDados(){
		boolean dadosUsuarioOk = true;
		if (!ValidaString.isStringOK(usuario.getLogin(), 1, 15)){
			dadosUsuarioOk = false;
			mensagem +=  new Mensagem().getMensagem("cadastro.login.erro") ;
		}
		if (!ValidaString.isStringOK(usuario.getSenha(), 1, 15)){
			dadosUsuarioOk = false;
			mensagem +=  new Mensagem().getMensagem("cadastro.senha.erro") ;
		}
		
		return dadosUsuarioOk;
	}
	
	private void cryptPassword(){
		usuario.setSenha(Crypt.getHash(usuario.getSenha()));
	
	}
}

