/*
 * PesquisaBean.java
 *
 * Created on 16 de Outubro de 2007, 08:12
 */

package jorfinder.view;

import java.util.ArrayList;
import jorfinder.business.ORFBO;
import jorfinder.business.PesquisaBO;
import jorfinder.business.TipoORFBO;
import jorfinder.information.ORFVO;
import jorfinder.information.PesquisaVO;
import jorfinder.information.TipoORFVO;
import jorfinder.log2java.Logger;
import org.biojava.bio.seq.DNATools;
import org.biojava.bio.symbol.IllegalAlphabetException;
import org.biojava.bio.symbol.IllegalSymbolException;

/**
 *
 * @author matheus
 */
public class ORFBean {
	
	public static Logger log = new Logger(ORFBean.class.getName());
    public final int contespaco = 5;
    public final int basesporlinha = 70;
    private ORFVO orfvo;  
    public String usuario;

    public ORFVO getORFVO(){
        return this.orfvo;
    }   
    
    public void setORFVO(int codPesquisa, int linha, int posCodonStart, int posCodonStop){
        ORFBO orfbo = new ORFBO();
        ORFVO orf = new ORFVO();
        orf.setCodPesquisa(codPesquisa);
        orf.setLinha(linha);
        orf.setPosCodonStart(posCodonStart);
        orf.setPosCodonStop(posCodonStop);
        this.orfvo = orfbo.getObjetoByUnique(orf);
    }
    
    public int getContespaco(){
        return this.contespaco;
    }
    
    public String getSequencia() {
        String seq = " ";
        PesquisaBO pesqbo = new PesquisaBO();
        PesquisaVO pesqvo = new PesquisaVO();
        pesqvo.setCod(this.orfvo.getCodPesquisa());
        pesqvo = pesqbo.getObjetoByUnique(pesqvo);
        
        if(this.orfvo.getLinha() > 3){
            try {
                String dnaComplementar = DNATools.reverseComplement(DNATools.createDNA(pesqvo.getDna())).seqString().toUpperCase();
                //pega a linha correta
                seq = dnaComplementar.substring(this.orfvo.getLinha()-4, dnaComplementar.length());
                //pega o trecho do DNA correspondente ao orf
                seq = seq.substring(this.orfvo.getPosCodonStart()*3, (this.orfvo.getPosCodonStop()+1)*3);
            } catch (IllegalAlphabetException ex) {
                log.exception("erro ao executar getSequencia", ex);
            } catch (IllegalSymbolException ex) {
            	log.exception("erro ao executar getSequencia", ex);
            }                   
        } else{       
            //pega a linha correta
            seq = pesqvo.getDna().substring(this.orfvo.getLinha()-1, pesqvo.getDna().length());
            //pega o trecho do DNA correspondente ao orf
            seq = seq.substring(this.orfvo.getPosCodonStart()*3, (this.orfvo.getPosCodonStop()+1)*3);
        }

        //faz a quebra de linha
        for(int quebra = this.basesporlinha; quebra < seq.length(); quebra=quebra+this.basesporlinha){
            seq = seq.substring(0,quebra)+"<br>"+seq.substring(quebra, seq.length());
            quebra = quebra+4;
        }
        return seq;        
    } 
    
     public String getObservacao() {
         return this.orfvo.getObservacao();
     }

     public TipoORFVO getClassificacao() {
         TipoORFBO tipoorfbo = new TipoORFBO();
         TipoORFVO tipoorfvo = new TipoORFVO();
         tipoorfvo.setCod(this.orfvo.getCodTipoORF());
         return tipoorfbo.getObjetoByUnique(tipoorfvo);
     } 
     
     public ArrayList<TipoORFVO> getListaTipoORF() {
         TipoORFBO tipoorfbo = new TipoORFBO();
         return tipoorfbo.getLista();
     } 
     
    public String getUsuario() {
        return usuario;
    }

    public void setUsuario(String usuario) {
        this.usuario = usuario;
    }
}
