package jorfinder.view;

import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import jorfinder.business.UsuarioBO;
import jorfinder.information.UsuarioVO;
import jorfinder.util.Crypt;
import jorfinder.util.Mensagem;
import jorfinder.util.SendMail;
import jorfinder.util.ValidaString;


public class RecuperarSenha implements Action {

	UsuarioVO usuario;
	String mensagem = "";
	
	public void execute(HttpServletRequest req, HttpServletResponse res)
			throws Exception {
        
		//pegar os parametros da requisio;
        getParameters(req);
        
        boolean dadosUsuario =  validarDados();
        
        boolean retornoBanco = false;
        if (dadosUsuario){
        	
        	UsuarioBO usubo = new UsuarioBO();
            UsuarioVO usu = usubo.getUsuarioWithLoginAndEmail(usuario);
            if(usu == null){
            	mensagem += new Mensagem().getMensagem("email.nao.cadastrado");
            }else{
            	
            	String novaSenha = String.valueOf(getNewSenha());
            	String SenhaCrypt = Crypt.getHash(novaSenha);
            	usu.setSenha(SenhaCrypt);
            	usubo.atualiza(usu);
            	SendMail send = new SendMail();
        		send.enviarEmailSenha(usu.getEmail(), usu.getNome(), getTextoEmail(novaSenha));    	
            	retornoBanco = true;
            }
        	
        }
        
        RequestDispatcher rd;
        
        if (dadosUsuario && retornoBanco){
        	req.setAttribute("alert", new Mensagem().getMensagem("email.enviado.sucesso"));
        	rd = req.getRequestDispatcher("/index.jsp");
        }else{
        	req.setAttribute("mensagem", mensagem);
        	rd = req.getRequestDispatcher("/recuperarSenha.jsp");
        }
        
        rd.forward(req, res);
		
		
	}
	
	private void getParameters(HttpServletRequest req){
		usuario = new UsuarioVO();
		usuario.setLogin(req.getParameter("login").toString().trim().toLowerCase());
        usuario.setEmail(req.getParameter("email").toString().trim().toLowerCase());
		
	}
	
	private boolean validarDados(){
		boolean dadosUsuarioOk = true;
		if (!ValidaString.isStringOK(usuario.getLogin(), 1, 15)){
			dadosUsuarioOk = false;
			mensagem +=  new Mensagem().getMensagem("cadastro.login.erro") ;
		}
		if (!ValidaString.isStringOK(usuario.getEmail(), 1, 50)){
			dadosUsuarioOk = false;
			mensagem +=  new Mensagem().getMensagem("cadastro.email.erro") ;
		}
		if (!ValidaString.isEmailOK(usuario.getEmail())){
			dadosUsuarioOk = false;
			mensagem +=  new Mensagem().getMensagem("cadastro.email.invalido") ;
		}
		
		return dadosUsuarioOk;
	}
	
	private int getNewSenha(){
		return  (int) ( 1 + (Math.random() * 999999));
	}

	public String getTextoEmail(String senha){
		return "Caro usuario,\n\n" +
				"    A sua nova senha de acesso ao J-ORFinde-web segue abaixo: \n" +
				"      " +senha +
				"\n    Solicitamos que voc troque essa senha no primeiro acesso ao sistema\n\n" +
				"Atenciosamente \nEquipe J-ORFinder.";

	}

}
